function varargout = gyro_evaluation(varargin)
% GYRO_EVALUATION M-file for gyro_evaluation.fig
%      GYRO_EVALUATION, by itself, creates a new GYRO_EVALUATION or raises the existing
%      singleton*.
%
%      H = GYRO_EVALUATION returns the handle to a new GYRO_EVALUATION or the handle to
%      the existing singleton*.
%
%      GYRO_EVALUATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GYRO_EVALUATION.M with the given input arguments.
%
%      GYRO_EVALUATION('Property','Value',...) creates a new GYRO_EVALUATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gyro_evaluation_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gyro_evaluation_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gyro_evaluation

% Last Modified by GUIDE v2.5 25-May-2006 12:54:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gyro_evaluation_OpeningFcn, ...
                   'gui_OutputFcn',  @gyro_evaluation_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gyro_evaluation is made visible.
function gyro_evaluation_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gyro_evaluation (see VARARGIN)

% Choose default command line output for gyro_evaluation
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gyro_evaluation wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gyro_evaluation_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in togglebutton_ON.
function togglebutton_ON_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_ON (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_ON

initserial=0; %initialization serial port
inittimevec=0;
initplotvec=0;
initwrite=0;
initbias=0;
k=0;
bias=0;

state=get(hObject,'Value');% get ON-button state

while state == 1 %Main loop
    
%---initialization serial port---------------------------------
    while initserial==0
        s=serial('COM1');
        set(s,'BaudRate',38400,'Parity','none','Stopbits',1);
        set(s, 'Timeout', 5,'InputBufferSize',4,'OutputBufferSize',1);
        fopen(s);
        initserial=1;
    end

%---------Async read------------------------------

    while initwrite==0
        try
            fwrite(s,55,'uchar','sync');
        catch
            fclose(s) %disconnect from the device
            delete(s) %remove from memory
            clear s   %remove from MatLab Workspace
            state=0;
            set(handles.togglebutton_ON,'value',0);
            break
        end
        
        initwrite=1;
    end


    [a,count,msg] = fread(s,4,'uchar');
    
     if inittimevec==0
        timevec=zeros(1,300);
        tic;
        inittimevec=1;
     else
        timediff=toc;  %etime
        timevec(2:300)=timevec(1:299);
        timevec(1)=timediff;
        timevec(2:300)=timevec(2:300)+(timediff);
        tic;
    end

    G(1:2) = a(1:2);
    T(1:2) = a(3:4);
        
        gyrodata=((G(1)*256)+G(2));
        temperaturdata=(T(1)*256)+T(2);
        
%     if gyrodata > 1983
%         gyrodata = (gyrodata - 1983)*(300/2048)*1.7647;
%     else
%         gyrodata = ((1983 - gyrodata)*(300/2048))*(-1)*1.7647;
%     end
        
%     while initbias == 0
%         while k<1000
%             
%             [a,count,msg] = fread(s,4,'uchar');
% 
%             G(1:2) = a(1:2);
%             T(1:2) = a(3:4);
%         
%             gyrodata=((G(1)*256)+G(2));
%         
%         
%             if gyrodata > 2018
%                 gyrodata = (gyrodata - 2018)*(300/2048);
%             else
%                 gyrodata = ((2018 - gyrodata)*(300/2048))*(-1);
%             end
%             
%             bias=gyrodata+bias;
%             k=k+1;
%         end
%         bias=bias/1000;
%         initbias=1;
%     end
%         
%         gyrodata=gyrodata+bias;
        %---creating-time-vector-----------------------------------
%Length of time vector is set to 300 values, giving highest 
%value about 20 seconds

%     if inittimevec==0
%         timevec=zeros(1,300);
%         tic;
%         inittimevec=1;
%     else
%         
%         timediff=toc;  %etime
%         timevec(2:300)=timevec(1:299);
%         timevec(1)=timediff;
%         timevec(2:300)=timevec(2:300)+(timediff);
%         tic;
%     end
        
        
    %----------creating-plot-vectors--------------------------------
%Length of plot vectors is set to 300 values, must be the same
%as for the time vector     
    
    if initplotvec == 0
        gyrodatavec=zeros(1,300);
        gyrodatavec(1)=gyrodata;
        temperaturdatavec=zeros(1,300);
        temperaturdatavec(1)=temperaturdata;
        initplotvec=1;
    else
        gyrodatavec(2:300)=gyrodatavec(1:299);
        gyrodatavec(1)=gyrodata;
        temperaturdatavec(2:300)=temperaturdatavec(1:299);
        temperaturdatavec(1)=temperaturdata; 
    end
    
    received=s.ValuesReceived/4;
    
    if (received == 0) | (received > 300)
        
        fwrite(s,56,'uchar','sync');
        fclose(s) %disconnect from the device
        delete(s) %remove from memory
        clear s   %remove from MatLab Workspace
        savefile = 'datafil.mat';
        g = fliplr(gyrodatavec);
        t = timevec;
        save(savefile, 'g', 't')
        state=0;
        set(handles.togglebutton_ON,'value',0);
        OFF = 1;
        pause(0.01)
        ca_samplingsfrekvens = 1/(timevec(300)/300);
        set(handles.edit_received,'String',ca_samplingsfrekvens);
        nulltest=sum(gyrodatavec)/300;
        set(handles.edit_gyro,'String',nulltest);
        %set(handles.edit_gyroraw,'String',bias);
        gyrosum=sum(gyrodatavec*0.01);
        set(handles.edit_vinkel,'String',gyrosum);
        
    end
    
end
    
function edit_gyroraw_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gyroraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gyroraw as text
%        str2double(get(hObject,'String')) returns contents of edit_gyroraw as a double


% --- Executes during object creation, after setting all properties.
function edit_gyroraw_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gyroraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in togglebutton_OFF.
function togglebutton_OFF_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_OFF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_OFF

load datafil

f=t(2:300)-t(1:299);
axes(handles.axes1)
cla
plot(f)
title('Samplings intervall')

%set(h(2),'Visible','on')
%set(handles.axes2,'Visible','off')
            
axes(handles.axes2)
cla
set(handles.axes2,'Visible','off')



function edit_tempraw_Callback(hObject, eventdata, handles)
% hObject    handle to edit_tempraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_tempraw as text
%        str2double(get(hObject,'String')) returns contents of edit_tempraw as a double


% --- Executes during object creation, after setting all properties.
function edit_tempraw_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_tempraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit_gyro_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gyro (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gyro as text
%        str2double(get(hObject,'String')) returns contents of edit_gyro as a double


% --- Executes during object creation, after setting all properties.
function edit_gyro_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gyro (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_temperatur_Callback(hObject, eventdata, handles)
% hObject    handle to edit_temperatur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_temperatur as text
%        str2double(get(hObject,'String')) returns contents of edit_temperatur as a double


% --- Executes during object creation, after setting all properties.
function edit_temperatur_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_temperatur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit_received_Callback(hObject, eventdata, handles)
% hObject    handle to edit_received (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_received as text
%        str2double(get(hObject,'String')) returns contents of edit_received as a double


% --- Executes during object creation, after setting all properties.
function edit_received_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_received (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in togglebutton_fft.
function togglebutton_fft_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_fft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_fft

%fft=get(hObject,'Value');
load datafil
G=g-2018;
%--Plot gyro data-------------------------------------------------
    axes(handles.axes1)
    cla
    plot(t,g);
   title('Time domain')
    xlabel('Time [sec]')
%     ylabel('Angular rate [degree/second]')
     
Y=fft(g,300);
%Pyy=Y.*conj(Y)/300;
Pyy=abs(Y)/300;
f=100*(0:150)/300;
axes(handles.axes2)
cla
semilogy(f,Pyy(1:151))
title('Frequency domain')
xlabel('frequency (Hz)')
%ylabel('Temperatur [degree celsius]')



% --- Executes on button press in togglebutton_realtime.
function togglebutton_realtime_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_realtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_realtime

initserial=0; %initialization serial port
inittimevec=0;
initplotvec=0;
initwrite=0;
sumgyrodata=0;
timediff=0;
k=0;

state=get(hObject,'Value');% get ON-button state

while state == 1 %Main loop
    
%---initialization serial port---------------------------------
    while initserial==0
        s=serial('COM1');
        set(s,'BaudRate',38400,'Parity','none','Stopbits',1);
        set(s, 'Timeout', 5,'InputBufferSize',4,'OutputBufferSize',1);
        fopen(s);
        initserial=1;
    end

%---------Async read------------------------------

    while initwrite==0
        try
            fwrite(s,55,'uchar','sync');
        catch
            fclose(s) %disconnect from the device
            delete(s) %remove from memory
            clear s   %remove from MatLab Workspace
            state=0;
            set(handles.togglebutton_ON,'value',0);
            break
        end
        
        initwrite=1;
    end


    [a,count,msg] = fread(s,4,'uchar');

    G(1:2) = a(1:2);
    T(1:2) = a(3:4);
        
    gyrodata=(G(1)*256)+G(2);
    temperaturdata=(T(1)*256)+T(2);
    
    set(handles.edit_gyroraw,'String',gyrodata);
    set(handles.edit_tempraw,'String',temperaturdata);
    bias=str2double(get(handles.edit_bias,'String'));
    sf=str2double(get(handles.edit_sf,'String'));
    
    if gyrodata > bias
        gyrodata = (gyrodata - bias)*(300/2048)*(sf);
    else
        gyrodata = ((bias - gyrodata)*(300/2048))*(-1)*(sf);
    end
        
    set(handles.edit_gyro,'String',gyrodata);
    
      temperaturdata = temperaturdata - 2023;%celsius 
      set(handles.edit_temperatur,'String',temperaturdata);
      
      
%---Temperatur kompasasjon--------------------------------
    %temperaturdata = temperaturdata - 1750;%kelvin
    %scale_factor=2048/temperaturdata;
    %gyrodata=gyrodata*scale_factor;
        
        
        %---creating-time-vector-----------------------------------
%Length of time vector is set to 300 values, giving highest 
%value about 20 seconds

    if inittimevec==0
        timevec=zeros(1,300);
        tic;
        inittimevec=1;
    else
        
        timediff=toc;  %etime
        timevec(2:300)=timevec(1:299);
        timevec(1)=timediff;
        timevec(2:300)=timevec(2:300)+(timediff);
        tic;
    end
    
    integral=gyrodata*(timediff);
    sumgyrodata=sumgyrodata+integral;
    set(handles.edit_vinkel,'String',round(sumgyrodata)); 
    
        ca_samplingsfrekvens = 1/(timediff);
        set(handles.edit_received,'String',round(ca_samplingsfrekvens));
    %----------creating-plot-vectors--------------------------------
%Length of plot vectors is set to 300 values, must be the same
%as for the time vector     
    
    if initplotvec == 0
        gyrodatavec=zeros(1,300);
        gyrodatavec(1)=gyrodata;
        temperaturdatavec=zeros(1,300);
        temperaturdatavec(1)=temperaturdata;
        initplotvec=1;
    else
        gyrodatavec(2:300)=gyrodatavec(1:299);
        gyrodatavec(1)=gyrodata;
        temperaturdatavec(2:300)=temperaturdatavec(1:299);
        temperaturdatavec(1)=temperaturdata; 
    end
   
    plot=get(handles.togglebutton_graph,'value');
    if plot==1
  
        %--Plot gyro data-------------------------------------------------

        axes(handles.axes1)
        cla
        line(timevec,gyrodatavec);
   
        xlabel('Time [sec]')
        ylabel('Angular rate [degree/second]')
    
        %--Plot gyro temperatur-------------------------------------------
        axes(handles.axes2)
        set(handles.axes2,'Visible','on')
        cla
        line(timevec,temperaturdatavec);
        xlim([0 20])
        ylim([0 60])
        xlabel('Time [sec]')
        ylabel('Temperatur [degree celsius]')
        title('Temperatur')
    end
    %received=s.ValuesReceived/4;
    
%     if k>50
         pause(0.01)
%         k=0;
%     end
%     k=k+1;
    
        off=get(handles.togglebutton_realtime,'value');
    if off==0     
        fwrite(s,56,'uchar','sync');
        fclose(s) %disconnect from the device
        delete(s) %remove from memory
        clear s   %remove from MatLab Workspace
        state=0;
    end
    
    %ca_samplingsfrekvens = 1/(timevec(300)/300);
    %set(handles.edit_received,'String',ca_samplingsfrekvens);
    
end
        
        

        
        



 
    
    
    
    %----------check-OFF-button-state-------------
    %pause(0.01) %pause for 0.01 second
    
%     OFF = get(handles.togglebutton_OFF,'Value');
%     if (OFF == 0) %| (state == 1)
%         fwrite(s,56,'uchar','sync');
%         fclose(s) %disconnect from the device
%         delete(s) %remove from memory
%         clear s   %remove from MatLab Workspace
%         set(handles.togglebutton_ON,'value',0);
%         state=0;
%         set(handles.togglebutton_OFF,'value',0);
%     end   
    
    
    
%-----Reserve funksjoner-----------------------------------------------
    
          %-------Transfer test--------------------
    %measure the time used reading 100 values.
    
%      if received == 2
%          start=clock;
%      end
%      if received ==101
%          usedtime=etime(clock,start)
%      end
    %-----------------------------------------
    
%      %---Take out one package from the two received--------------------
%         k=1;
%         f=0;
%         while f<5
%             
%             if a(k) == 5
%                 f=f+1; 
%             elseif k >= 15
%                 'prver p indeks 19'
%                 set(handles.togglebutton_ON,'value',0);
%                 OFF = 1;
%                 break
%             else
%                 f=0;
%             end
%             
%             k=k+1;
%             
%         end
%         G(1:2) = a(k:(1+k));
%         T(1:2) = a((2+k):(3+k));


    %offset test----------------------------------
%     gyrodata=sum(gyrodatavec)/300;
%     set(handles.edit_gyro,'String',gyrodata);
%     timevec
%     gyrodatavec

 %--conversion from decimal string to binary----------------------- 
       % n=28;% # of bytes
        %PWD=[];
        %k=1;
        %while k<=n
            %c = dec2bin(a,8);
            %PWD = [PWD c]
           % k=k+1;
        %end



function edit_vinkel_Callback(hObject, eventdata, handles)
% hObject    handle to edit_vinkel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_vinkel as text
%        str2double(get(hObject,'String')) returns contents of edit_vinkel as a double


% --- Executes during object creation, after setting all properties.
function edit_vinkel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_vinkel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_bias_Callback(hObject, eventdata, handles)
% hObject    handle to edit_bias (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_bias as text
%        str2double(get(hObject,'String')) returns contents of edit_bias as a double


% --- Executes during object creation, after setting all properties.
function edit_bias_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_bias (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit_sf_Callback(hObject, eventdata, handles)
% hObject    handle to edit_sf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_sf as text
%        str2double(get(hObject,'String')) returns contents of edit_sf as a double


% --- Executes during object creation, after setting all properties.
function edit_sf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_sf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_bias_Callback(hObject, eventdata, handles)
% hObject    handle to slider_bias (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
temp=get(handles.slider_bias,'Value');
guidata(hObject, handles);
set(handles.edit_bias,'String',round(temp));

% --- Executes during object creation, after setting all properties.
function slider_bias_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_bias (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_sf_Callback(hObject, eventdata, handles)
% hObject    handle to slider_sf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
temp=get(handles.slider_sf,'Value');
guidata(hObject, handles);
set(handles.edit_sf,'String',temp);

% --- Executes during object creation, after setting all properties.
function slider_sf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_sf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end




% --- Executes on button press in pushbutton_bias.
function pushbutton_bias_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_bias (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load datafil
bias=mean(g);

set(handles.slider_bias,'Value',bias);
guidata(hObject, handles);
set(handles.edit_bias,'String',round(bias));


% --- Executes on button press in togglebutton_graph.
function togglebutton_graph_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_graph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_graph


