function varargout = live_loop(varargin)
% LIVE_LOOP M-file for live_loop.fig
%      LIVE_LOOP, by itself, creates a new LIVE_LOOP or raises the existing
%      singleton*.
%
%      H = LIVE_LOOP returns the handle to a new LIVE_LOOP or the handle to
%      the existing singleton*.
%
%      LIVE_LOOP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LIVE_LOOP.M with the given input arguments.
%
%      LIVE_LOOP('Property','Value',...) creates a new LIVE_LOOP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before live_loop_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to live_loop_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help live_loop

% Last Modified by GUIDE v2.5 18-May-2006 11:07:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @live_loop_OpeningFcn, ...
                   'gui_OutputFcn',  @live_loop_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before live_loop is made visible.
function live_loop_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to live_loop (see VARARGIN)

% Choose default command line output for live_loop
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes live_loop wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = live_loop_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in togglebutton_read.
function togglebutton_read_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_read (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton_read

%---initialization serial port---------------------------------
s=serial('COM7');
set(s,'BaudRate',38400,'Parity','none','Stopbits',1);
set(s, 'Timeout', 65,'InputBufferSize',36000,'OutputBufferSize',1);
fopen(s);

%--Calibration constants---------------------------------
O_ax = -41.4498;
Sf_ax = 106.7849;
O_ay = -45.0408;
Sf_ay = 106.7870;
O_az = -4.7250;
Sf_az = 104.9252;

O_gx = 2028.419;
Sf_gx = 618.7384;
O_gy = 1945.234;
Sf_gy = -194.9002;
O_gz = 1980.314;
Sf_gz = -599.3583;
%-----------------------------------------------------------

%--Misalingment matrices-------------------------------------

SM_a =[1.0000    0.0068    0.0237;
       0.0305    1.0000    0.0046;
      -0.0209    0.0036    1.0000];
  
SM_g =[ 1.0000   -0.0006   -0.0193;
        0.0109    1.0000   -0.0086;
       -0.0285   -0.0016    1.0000];
   
%---------------------------------------------------------
   
dt=0.01;

p_i=0;
q_i=0;
r_i=0;

ax=0;
ay=0;
az=0;

try
    fwrite(s,55,'uchar','sync');
catch
    fclose(s) %disconnect from the device
    delete(s) %remove from memory
    clear s   %remove from MatLab Workspace
    error_write=1   
end

tic
for i = 1:500
    
    try
        [a,count,msg] = fread(s,12,'uchar');
    catch
        fwrite(s,56,'uchar','sync');
        error_read=1
        break
    end
    
    acc_x_h = a(1);
    acc_x_l = a(2);
    acc_y_h = a(3);
    acc_y_l = a(4);
    acc_z_h = a(5);
    acc_z_l = a(6);
    
    acc_x = binstr2dec(acc_x_h,acc_x_l);
    acc_y = binstr2dec(acc_y_h,acc_y_l);
    acc_z = binstr2dec(acc_z_h,acc_z_l);
    
    gyro_x_h = a(7);
    gyro_x_l = a(8);
    gyro_y_h = a(9);    
    gyro_y_l = a(10);
    gyro_z_h = a(11);
    gyro_z_l = a(12);

    gyro_x=((gyro_x_h*256)+gyro_x_l);
    gyro_y=((gyro_y_h*256)+gyro_y_l);
    gyro_z=((gyro_z_h*256)+gyro_z_l);
    
    p_s=(gyro_x-O_gx)/Sf_gx;     %roll
    q_s=(gyro_y-O_gy)/Sf_gy;     %pitch
    r_s=(gyro_z-O_gz)/Sf_gz;     %heading
    
    gyro_skew=[p_s; q_s; r_s];
    
    gyro_unskew=inv(SM_g)*gyro_skew;

    p=gyro_unskew(1);
    q=gyro_unskew(2);
    r=gyro_unskew(3);%9*(pi/180);
        
%     p_i=p_i+p*dt;
%     q_i=q_i+q*dt;
%     r_i=r_i+r*dt;

%--Accelerometer--------------------------------------------------------
    acc_skew_x=((acc_x-O_ax)/Sf_ax); % langs x-aksen i body koordinater
    acc_skew_y=((acc_y-O_ay)/Sf_ay); % langs y-aksen i body koordinater
    acc_skew_z=((acc_z-O_az)/Sf_az); % langs z-aksen i body koordinater
    
    acc_skew=[acc_skew_x; acc_skew_y; acc_skew_z];

    acc_unskew=inv(SM_a)*acc_skew;
    ax=acc_unskew(1);
    ay=acc_unskew(2);
    az=acc_unskew(3);
%-----------------------------------------------------------------------   

    pause(0.01)
    set(handles.edit_a_x,'string',ax);
    set(handles.edit_a_y,'string',ay);
    set(handles.edit_a_z,'string',az);
    
    set(handles.edit_gyro_x,'string',p*(180/pi));
    set(handles.edit_gyro_y,'string',q*(180/pi));
    set(handles.edit_gyro_z,'string',r*(180/pi));
end

time_used=toc
% set(handles.edit_gyro_x,'string',p_i*(180/pi));
% set(handles.edit_gyro_y,'string',q_i*(180/pi));
% set(handles.edit_gyro_z,'string',r_i*(180/pi));

fwrite(s,56,'uchar','sync'); %Send stop command

fclose(s) %disconnect from the device
delete(s) %remove from memory
clear s   %remove from MatLab Workspace  
        
function edit_gyro_x_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gyro_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gyro_x as text
%        str2double(get(hObject,'String')) returns contents of edit_gyro_x as a double


% --- Executes during object creation, after setting all properties.
function edit_gyro_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gyro_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_gyro_y_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gyro_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gyro_y as text
%        str2double(get(hObject,'String')) returns contents of edit_gyro_y as a double


% --- Executes during object creation, after setting all properties.
function edit_gyro_y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gyro_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_gyro_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gyro_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gyro_z as text
%        str2double(get(hObject,'String')) returns contents of edit_gyro_z as a double


% --- Executes during object creation, after setting all properties.
function edit_gyro_z_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gyro_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton_stop.
function pushbutton_stop_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit_a_x_Callback(hObject, eventdata, handles)
% hObject    handle to edit_a_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_a_x as text
%        str2double(get(hObject,'String')) returns contents of edit_a_x as a double


% --- Executes during object creation, after setting all properties.
function edit_a_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_a_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_a_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_a_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_a_z as text
%        str2double(get(hObject,'String')) returns contents of edit_a_z as a double


% --- Executes during object creation, after setting all properties.
function edit_a_z_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_a_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


