/************************************************************************** 
Name: 		display.c
Comments:	Display functions
**************************************************************************/

#include <mega128.h>
#include <delay.h>
#include "display.h"


//Initialisation Display
void init_display()
{	
Reset=0;
delay_ms(10);
Reset=1;
delay_ms(10);
CS1=0; 
CS2=1;
C86=0;
       
// Set display, start line
A0=0; 
RD=1; 
WR=0; 
Display_data=0x40;
WR=1;
delay_ms(10);
       
// Set Normal / Reverse Display
WR=0; 
Display_data=0xA6;
WR=1;
delay_ms(10);
       
//Set all indicator
WR=0; 
Display_data=0xA4;
WR=1;
delay_ms(10);
       
//Set duty select
WR=0; 
Display_data=0xA9;
WR=1;
delay_ms(10);
                    
//Set ADC = 1
WR=0; 
Display_data=0xA1;
WR=1;
delay_ms(10);
       
//Output Status
WR=0; 
Display_data=0xCC;
WR=1;
delay_ms(10);
                    
//Set built in power supply
WR=0; 
Display_data=0x25;
WR=1;
delay_ms(10);
       
//Set power on completion
WR=0; 
Display_data=0xED;
WR=1;
delay_ms(10);
       
//Set electronic volume control
WR=0; 
Display_data=0x8F;
WR=1;
delay_ms(10); 
       
//Set Display ON
WR=0; 
Display_data=0xAF;
WR=1;
delay_ms(10);
       
//Set page adress
WR=0; 
Display_data=0xB0;
WR=1;
delay_ms(10);
        
//Set column adress high order 4-bits
WR=0; 
Display_data=0x12;
WR=1;
delay_ms(10);
       
//Set column adress low order 4-bits
WR=0; 
Display_data=0x00;
WR=1;
delay_ms(10);
                 
/*//Read modify Write
RD=1; 
WR=0; 
Display_data=0xE0;
WR=1;
delay_ms(50);*/ 
       
       
/*//Display status          
A0=0;  
RD=0; 
WR=1; 
Display_data=0x00; 
WR=1;
delay_ms(50); 
DDRC=0x00; // Port C innport
delay_ms(50);*/

} 
                           
// Write to Display       
void Write(unsigned char letter, unsigned int page, unsigned int pos)
{         

if ((page>=0 && page<=8) && (pos>=0 && pos<=17))
	{        
	unsigned int adr;
	unsigned int colum;
	unsigned int colum_h;
	unsigned int colum_l;
	
	adr=0xB0+page;
	
	//Set Page adress
	A0=0;  
 	RD=1; 
  	WR=0; 
       	Display_data=adr;
       	WR=1;  
        
        colum=pos*6; 
        colum_h= (char)(colum >> 4) ; // high 4-bits
        colum_l=colum & 0x0F;   // low 4-bits
        colum_h=colum_h + 0x12;
        
   	//Set column adress high order 4-bits
       	WR=0; 
       	Display_data=colum_h;
       	WR=1;
       	
       	//Set column adress low order 4-bits 
       	WR=0; 
       	Display_data=colum_l;
       	WR=1;  
       	}
          
else
      	{
      	//Illegal page adress or position. Page must be equal or bigger than 0 and less than 8.
      	//Position must be equal or bigger than 0 and less than 16. Each letter is 6 pixels including
      	//space, the display is 100 pixels wide, which gives 16 hole letters a line/page.
       	return;  
      	} 
      
//Display data write
A0=1;  
RD=1; 
WR=0;
       
switch (letter)
	{     
 	case ' ':
  	WR=0;
   	Display_data=0x00;
    	WR=1;
     	WR=0;
      	Display_data=0x00;
       	WR=1;
        WR=0;
        Display_data=0x00;
        WR=1;
        WR=0;
        Display_data=0x00;
        WR=1;
        WR=0;
        Display_data=0x00;
        WR=1; 
        WR=0;
        Display_data=0x00;
        WR=1; 
        return; 
       
       	case '0':
       	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
	return;	   
       
       	case '1':
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x02;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;  
       
       	case '2':
       	WR=0;
       	Display_data=0x42;
       	WR=1;
       	WR=0;
       	Display_data=0x61;
       	WR=1;
       	WR=0;
       	Display_data=0x51;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x46;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;    
                  
  	case '3':
       	WR=0;
       	Display_data=0x22;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return; 
       
       	case '4':
       	WR=0;
       	Display_data=0x18;
       	WR=1;
       	WR=0;
       	Display_data=0x14;
       	WR=1;
       	WR=0;
       	Display_data=0x12;
       	WR=1;
       	WR=0;
       	Display_data=0x79;
       	WR=1;
       	WR=0;
       	Display_data=0x10;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return; 

	case '5':
       	WR=0;
       	Display_data=0x2F;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x31;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;        

	case '6':
       	WR=0;
       	Display_data=0x3C;
       	WR=1;
       	WR=0;
       	Display_data=0x4A;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x30;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;       
       
       	case '7':
       	WR=0;
       	Display_data=0x01;
       	WR=1;
       	WR=0;
       	Display_data=0x61;
       	WR=1;
       	WR=0;
       	Display_data=0x11;
       	WR=1;
       	WR=0;
       	Display_data=0x0D;
       	WR=1;
       	WR=0;
       	Display_data=0x03;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;   
       
       	case '8':
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;          

	case '9':
       	WR=0;
       	Display_data=0x06;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x29;
       	WR=1;
       	WR=0;
       	Display_data=0x19;
       	WR=1;
       	WR=0;
       	Display_data=0x0E;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;     
       
       	case 'A':
       	WR=0;
       	Display_data=0x7C;
       	WR=1;
       	WR=0;
       	Display_data=0x12;
       	WR=1;
       	WR=0;
       	Display_data=0x11;
       	WR=1;
       	WR=0;
       	Display_data=0x12;
       	WR=1;
       	WR=0;
       	Display_data=0x7C;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;      
       
 	case 'B':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;           
       
       	case 'C':
       	WR=0;
       	Display_data=0x1C;
       	WR=1;
       	WR=0;
       	Display_data=0x22;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x22;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;           
       
       	case 'D':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x22;
       	WR=1;
       	WR=0;
       	Display_data=0x1C;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;           
                 
        case 'E':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;  
       
       	case 'F':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x01;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
              
       	case 'G':
       	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x51;
       	WR=1;
       	WR=0;
       	Display_data=0x32;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;  
       	return;
              
       	case 'H':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x08;
       	WR=1;
       	WR=0;
       	Display_data=0x08;
       	WR=1;
       	WR=0;
       	Display_data=0x08;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;  
       	return;
           
       	case 'I':
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;  
       
       	case 'J':
       	WR=0;
       	Display_data=0x20;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x3F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
       
       	case 'K':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x08;
       	WR=1;
       	WR=0;
       	Display_data=0x14;
       	WR=1;
       	WR=0;
       	Display_data=0x22;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
                 
       	case 'L':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return; 
       
  	case 'M':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x02;
       	WR=1;
       	WR=0;
       	Display_data=0x04;
       	WR=1;
       	WR=0;
       	Display_data=0x02;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
       
       	case 'N':
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x06;
       	WR=1;
       	WR=0;
       	Display_data=0x18;
       	WR=1;
       	WR=0;
       	Display_data=0x20;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
          
        case 'O':
       	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
	return;	   
       
	case 'P':
 	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x06; 
       	WR=1; 
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
       
  	case 'Q':
   	WR=0;
       	Display_data=0x3E;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x61;
       	WR=1;
       	WR=0;
       	Display_data=0x7E;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
	return;	   
      
	
	case 'R':
 	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x19;
       	WR=1;
       	WR=0;
       	Display_data=0x29; 
       	WR=1;
       	WR=0;
       	Display_data=0x46; 
       	WR=1;  
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;   
       
       	case 'S':
  	WR=0;
       	Display_data=0x26;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x49; 
       	WR=1; 
       	WR=0;
       	Display_data=0x32;
       	WR=1; 
       	WR=0;
       	Display_data=0x00;
       	WR=1; 
       	return;
  
  	case 'T':
   	WR=0;
       	Display_data=0x01; 
       	WR=1;
       	WR=0;
       	Display_data=0x01;
       	WR=1;
       	WR=0;
       	Display_data=0x7F;
       	WR=1;
       	WR=0;
       	Display_data=0x01; 
       	WR=1;
       	WR=0;
       	Display_data=0x01;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;
	  
	        
  	case 'U':
   	WR=0;
       	Display_data=0x3F; 
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x40; 
       	WR=1;
       	WR=0;
       	Display_data=0x3F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;
                  
   	case 'V':
    	WR=0;
       	Display_data=0x0F; 
       	WR=1;
       	WR=0;
       	Display_data=0x30;
       	WR=1;
       	WR=0;
       	Display_data=0x40;
       	WR=1;
       	WR=0;
       	Display_data=0x30; 
       	WR=1;
       	WR=0;
       	Display_data=0x0F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;
               
     	case 'W':
     	WR=0;
       	Display_data=0x1F; 
       	WR=1;
       	WR=0;
       	Display_data=0x60;
       	WR=1;
       	WR=0;
       	Display_data=0x0C;
       	WR=1;
       	WR=0;
       	Display_data=0x60; 
       	WR=1;
       	WR=0;
       	Display_data=0x1F;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;
       
        case 'X':
      	WR=0;
       	Display_data=0x41; 
       	WR=1;
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x08;
       	WR=1;
       	WR=0;
       	Display_data=0x36; 
       	WR=1;
       	WR=0;
       	Display_data=0x41;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;  
       
       	case 'Y':
      	WR=0;
       	Display_data=0x01; 
       	WR=1;
       	WR=0;
       	Display_data=0x06;
       	WR=1;
       	WR=0;
       	Display_data=0x78;
       	WR=1;
       	WR=0;
       	Display_data=0x06; 
       	WR=1;
       	WR=0;
       	Display_data=0x01;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;   
       
       	case 'Z':
   	WR=0;
       	Display_data=0x61; 
       	WR=1;
       	WR=0;
       	Display_data=0x51;
       	WR=1;
       	WR=0;
       	Display_data=0x49;
       	WR=1;
       	WR=0;
       	Display_data=0x45; 
       	WR=1;
       	WR=0;
       	Display_data=0x43;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;   
               
    	case 'd'://degree sign
     	WR=0;
       	Display_data=0x06; 
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x09;
       	WR=1;
       	WR=0;
       	Display_data=0x06; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;  
       
       	case ',':
      	WR=0;
       	Display_data=0x00; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0xB0;
       	WR=1;
       	WR=0;
       	Display_data=0x70; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;      
       	
       	case ':':
      	WR=0;
       	Display_data=0x00; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x36;
       	WR=1;
       	WR=0;
       	Display_data=0x36; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;  
       	
       	case '.':
      	WR=0;
       	Display_data=0x00; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x60;
       	WR=1;
       	WR=0;
       	Display_data=0x60; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;  
       	
       	case ';':
      	WR=0;
       	Display_data=0x00; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0xB6;
       	WR=1;
       	WR=0;
       	Display_data=0x76; 
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;
       	
	case '-':
      	WR=0;
       	Display_data=0x10; 
       	WR=1;
       	WR=0;
       	Display_data=0x10;
       	WR=1;
       	WR=0;
       	Display_data=0x10;
       	WR=1;
       	WR=0;
       	Display_data=0x10; 
       	WR=1;
       	WR=0;
       	Display_data=0x10;
       	WR=1;
       	WR=0;
       	Display_data=0x00;
       	WR=1;
       	return;        	        
	} 	
} 

//Clear display
void clear_display(void)
{
unsigned char i, j;

for(j=0;j<8;j++)
	{
	for(i=0;i<18;i++)
 		{
        	Write(' ', j, i);
        	}
	}  
}


// Writes an unsigned int to the display
void lcdprint( unsigned short int n, unsigned char page, unsigned char start_pos)
{
unsigned char d4, d3, d2, d1, q;
unsigned short int d0;

if ((start_pos < 12) && (page < 8))   //Sjekke om vi har 
        {
        d0 = n       & 0xF;
        d1 = (n>>4)  & 0xF;
        d2 = (n>>8)  & 0xF;
        d3 = (n>>12) & 0xF;
        
        d0 = 6*(d3 + d2 + d1) + d0;
        q = d0 / 10;
        d0 = d0 % 10;
        
        d1 = q + 9*d3 + 5*d2 + d1;
        q = d1 / 10;
        d1 = d1 % 10;
        
        d2 = q + 2*d2;
        q = d2 / 10;
        d2 = d2 % 10;
        
        d3 = q + 4*d3;
        q = d3 / 10;
        d3 = d3 % 10;
        
        d4 = q;
        
        Write(d4 + '0',page,start_pos );
        Write(d3 + '0',page,start_pos + 1 );
        Write(d2 + '0',page,start_pos + 2 );
        Write(d1 + '0',page,start_pos + 3 );
        Write(d0 + '0',page,start_pos + 4 );
        }
}
