/************************************************************************** 
Name: 		filter.c
Comments:	Moving average routines
**************************************************************************/

#include "filter.h"

void moving_average_gyro(void)
{
gyro_X_H_akse = average_1(gyro_X_H_akse);
gyro_X_L_akse = average_2(gyro_X_L_akse);	
gyro_Y_H_akse = average_3(gyro_Y_H_akse);
gyro_Y_L_akse = average_4(gyro_Y_L_akse);
gyro_Z_H_akse = average_5(gyro_Z_H_akse);
gyro_Z_L_akse = average_6(gyro_Z_L_akse);
}


/*
// 5-point moving average
 
unsigned short int average_1(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_1[4] = gyro_vekt_1[3];
gyro_vekt_1[3] = gyro_vekt_1[2];
gyro_vekt_1[2] = gyro_vekt_1[1];
gyro_vekt_1[1] = gyro_vekt_1[0];
gyro_vekt_1[0] = data;
average_data = ( gyro_vekt_1[0] + gyro_vekt_1[1] + gyro_vekt_1[2] + gyro_vekt_1[3] + gyro_vekt_1[4] )/5;//  + gyro_vekt_1[5] + gyro_vekt_1[6] + gyro_vekt_1[7] + gyro_vekt_1[8] + gyro_vekt_1[9] ) /10;
return average_data;
}

unsigned short int average_2(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_2[4] = gyro_vekt_2[3];
gyro_vekt_2[3] = gyro_vekt_2[2];
gyro_vekt_2[2] = gyro_vekt_2[1];
gyro_vekt_2[1] = gyro_vekt_2[0];
gyro_vekt_2[0] = data;
average_data = ( gyro_vekt_2[0] + gyro_vekt_2[1] + gyro_vekt_2[2] + gyro_vekt_2[3] + gyro_vekt_2[4] )/5;// + gyro_vekt_2[5] + gyro_vekt_2[6] + gyro_vekt_2[7] + gyro_vekt_2[8] + gyro_vekt_2[9] ) /
return average_data;
}

unsigned short int average_3(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_3[4] = gyro_vekt_3[3];
gyro_vekt_3[3] = gyro_vekt_3[2];
gyro_vekt_3[2] = gyro_vekt_3[1];
gyro_vekt_3[1] = gyro_vekt_3[0];
gyro_vekt_3[0] = data;
average_data = ( gyro_vekt_3[0] + gyro_vekt_3[1] + gyro_vekt_3[2] + gyro_vekt_3[3] + gyro_vekt_3[4] )/5;// + gyro_vekt_3[5] + gyro_vekt_3[6] + gyro_vekt_3[7] + gyro_vekt_3[8] + gyro_vekt_3[9] ) /10;
return average_data;
}

unsigned short int average_4(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_4[4] = gyro_vekt_4[3];
gyro_vekt_4[3] = gyro_vekt_4[2];
gyro_vekt_4[2] = gyro_vekt_4[1];
gyro_vekt_4[1] = gyro_vekt_4[0];
gyro_vekt_4[0] = data;
average_data = ( gyro_vekt_4[0] + gyro_vekt_4[1] + gyro_vekt_4[2] + gyro_vekt_4[3] + gyro_vekt_4[4] )/5;// + gyro_vekt_4[5] + gyro_vekt_4[6] + gyro_vekt_4[7] + gyro_vekt_4[8] + gyro_vekt_4[9] ) /10;
return average_data;
}

unsigned short int average_5(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_5[4] = gyro_vekt_5[3];
gyro_vekt_5[3] = gyro_vekt_5[2];
gyro_vekt_5[2] = gyro_vekt_5[1];
gyro_vekt_5[1] = gyro_vekt_5[0];
gyro_vekt_5[0] = data;
average_data = ( gyro_vekt_5[0] + gyro_vekt_5[1] + gyro_vekt_5[2] + gyro_vekt_5[3] + gyro_vekt_5[4] )/5;// + gyro_vekt_5[5] + gyro_vekt_5[6] + gyro_vekt_5[7] + gyro_vekt_5[8] + gyro_vekt_5[9] ) /10;
return average_data;
}   

unsigned short int average_6(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_6[4] = gyro_vekt_6[3];
gyro_vekt_6[3] = gyro_vekt_6[2];
gyro_vekt_6[2] = gyro_vekt_6[1];
gyro_vekt_6[1] = gyro_vekt_6[0];
gyro_vekt_6[0] = data;
average_data = ( gyro_vekt_6[0] + gyro_vekt_6[1] + gyro_vekt_6[2] + gyro_vekt_6[3] + gyro_vekt_6[4] )/5;// + gyro_vekt_6[5] + gyro_vekt_6[6] + gyro_vekt_6[7] + gyro_vekt_6[8] + gyro_vekt_6[9] ) /10;
return average_data;
}
   */  


// 10-point moving average
 
unsigned short int average_1(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_1[9] = gyro_vekt_1[8];
gyro_vekt_1[8] = gyro_vekt_1[7];
gyro_vekt_1[7] = gyro_vekt_1[6];
gyro_vekt_1[6] = gyro_vekt_1[5];
gyro_vekt_1[5] = gyro_vekt_1[4]; 
gyro_vekt_1[4] = gyro_vekt_1[3];
gyro_vekt_1[3] = gyro_vekt_1[2];
gyro_vekt_1[2] = gyro_vekt_1[1];
gyro_vekt_1[1] = gyro_vekt_1[0];
gyro_vekt_1[0] = data;
average_data = ( gyro_vekt_1[0] + gyro_vekt_1[1] + gyro_vekt_1[2] + gyro_vekt_1[3] + gyro_vekt_1[4]  + gyro_vekt_1[5] + gyro_vekt_1[6] + gyro_vekt_1[7] + gyro_vekt_1[8] + gyro_vekt_1[9] ) /10;
return average_data;
}

unsigned short int average_2(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_2[9] = gyro_vekt_2[8];
gyro_vekt_2[8] = gyro_vekt_2[7];
gyro_vekt_2[7] = gyro_vekt_2[6];
gyro_vekt_2[6] = gyro_vekt_2[5];
gyro_vekt_2[5] = gyro_vekt_2[4]; 
gyro_vekt_2[4] = gyro_vekt_2[3];
gyro_vekt_2[3] = gyro_vekt_2[2];
gyro_vekt_2[2] = gyro_vekt_2[1];
gyro_vekt_2[1] = gyro_vekt_2[0];
gyro_vekt_2[0] = data;
average_data = ( gyro_vekt_2[0] + gyro_vekt_2[1] + gyro_vekt_2[2] + gyro_vekt_2[3] + gyro_vekt_2[4] + gyro_vekt_2[5] + gyro_vekt_2[6] + gyro_vekt_2[7] + gyro_vekt_2[8] + gyro_vekt_2[9] ) /10;
return average_data;
}

unsigned short int average_3(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_3[9] = gyro_vekt_3[8];
gyro_vekt_3[8] = gyro_vekt_3[7];
gyro_vekt_3[7] = gyro_vekt_3[6];
gyro_vekt_3[6] = gyro_vekt_3[5];
gyro_vekt_3[5] = gyro_vekt_3[4];
gyro_vekt_3[4] = gyro_vekt_3[3];
gyro_vekt_3[3] = gyro_vekt_3[2];
gyro_vekt_3[2] = gyro_vekt_3[1];
gyro_vekt_3[1] = gyro_vekt_3[0];
gyro_vekt_3[0] = data;
average_data = ( gyro_vekt_3[0] + gyro_vekt_3[1] + gyro_vekt_3[2] + gyro_vekt_3[3] + gyro_vekt_3[4] + gyro_vekt_3[5] + gyro_vekt_3[6] + gyro_vekt_3[7] + gyro_vekt_3[8] + gyro_vekt_3[9] ) /10;
return average_data;
}

unsigned short int average_4(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_4[9] = gyro_vekt_4[8];
gyro_vekt_4[8] = gyro_vekt_4[7];
gyro_vekt_4[7] = gyro_vekt_4[6];
gyro_vekt_4[6] = gyro_vekt_4[5];
gyro_vekt_4[5] = gyro_vekt_4[4]; 
gyro_vekt_4[4] = gyro_vekt_4[3];
gyro_vekt_4[3] = gyro_vekt_4[2];
gyro_vekt_4[2] = gyro_vekt_4[1];
gyro_vekt_4[1] = gyro_vekt_4[0];
gyro_vekt_4[0] = data;
average_data = ( gyro_vekt_4[0] + gyro_vekt_4[1] + gyro_vekt_4[2] + gyro_vekt_4[3] + gyro_vekt_4[4] + gyro_vekt_4[5] + gyro_vekt_4[6] + gyro_vekt_4[7] + gyro_vekt_4[8] + gyro_vekt_4[9] ) /10;
return average_data;
}

unsigned short int average_5(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_5[9] = gyro_vekt_5[8];
gyro_vekt_5[8] = gyro_vekt_5[7];
gyro_vekt_5[7] = gyro_vekt_5[6];
gyro_vekt_5[6] = gyro_vekt_5[5];
gyro_vekt_5[5] = gyro_vekt_5[4]; 
gyro_vekt_5[4] = gyro_vekt_5[3];
gyro_vekt_5[3] = gyro_vekt_5[2];
gyro_vekt_5[2] = gyro_vekt_5[1];
gyro_vekt_5[1] = gyro_vekt_5[0];
gyro_vekt_5[0] = data;
average_data = ( gyro_vekt_5[0] + gyro_vekt_5[1] + gyro_vekt_5[2] + gyro_vekt_5[3] + gyro_vekt_5[4] + gyro_vekt_5[5] + gyro_vekt_5[6] + gyro_vekt_5[7] + gyro_vekt_5[8] + gyro_vekt_5[9] ) /10;
return average_data;
}   

unsigned short int average_6(unsigned short int data)
{
unsigned short int average_data;

gyro_vekt_6[9] = gyro_vekt_6[8];
gyro_vekt_6[8] = gyro_vekt_6[7];
gyro_vekt_6[7] = gyro_vekt_6[6];
gyro_vekt_6[6] = gyro_vekt_6[5];
gyro_vekt_6[5] = gyro_vekt_6[4]; 
gyro_vekt_6[4] = gyro_vekt_6[3];
gyro_vekt_6[3] = gyro_vekt_6[2];
gyro_vekt_6[2] = gyro_vekt_6[1];
gyro_vekt_6[1] = gyro_vekt_6[0];
gyro_vekt_6[0] = data;
average_data = ( gyro_vekt_6[0] + gyro_vekt_6[1] + gyro_vekt_6[2] + gyro_vekt_6[3] + gyro_vekt_6[4] + gyro_vekt_6[5] + gyro_vekt_6[6] + gyro_vekt_6[7] + gyro_vekt_6[8] + gyro_vekt_6[9] ) /10;
return average_data;
}
