/************************************************************************** 
Name: 		imu.c
Comments:	Intializing and reading the sensors
**************************************************************************/

#include "imu.h"
//#include <spi.h>
#include <stdio.h>
#include <mega128.h>

//Read the gyros (X-, Y- and Zaxis)
void read_gyros(void)
{                    
unsigned char i = 0;
gyro_X_H_akse = 0;	
gyro_X_L_akse = 0;	
gyro_Y_H_akse = 0;
gyro_Y_L_akse = 0;
gyro_Z_H_akse = 0;
gyro_Z_L_akse = 0;

        for(i=0; i<gyro_measurements; i++)
        	{              
                //ADC, gyro Z  
                PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
                gyro_z_h[i] = spi(0b10001011); //Init. next conversion, i.e. gyro Y
                gyro_z_h[i] = gyro_z_h[i] & 0x0F;
                gyro_z_l[i] = spi(0b00010000); //cont. init. (ctrl-reg is 12 bit).
                PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
                //ADC, gyro Y 
                PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
                gyro_y_h[i] = spi(0b10010011); //Init next conversion, i.e. gyro X
                gyro_y_h[i] = gyro_y_h[i] & 0x0F;
                gyro_y_l[i] = spi(0b00010000);
                PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
                //ADC, gyro X 
                PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
                gyro_x_h[i] = spi(0b10000011); //Init next conversion, i.e. gyro Z
                gyro_x_h[i] = gyro_x_h[i] & 0x0F;
                gyro_x_l[i] = spi(0b00010000);
                PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
        	}
        	
        //Sum all measurements
        for(i=0; i<gyro_measurements; i++)
        	{
		gyro_X_H_akse = gyro_X_H_akse + gyro_x_h[i];
        	gyro_X_L_akse = gyro_X_L_akse + gyro_x_l[i];
                gyro_Y_H_akse = gyro_Y_H_akse + gyro_y_h[i];
                gyro_Y_L_akse = gyro_Y_L_akse + gyro_y_l[i];
                gyro_Z_H_akse = gyro_Z_H_akse + gyro_z_h[i];
                gyro_Z_L_akse = gyro_Z_L_akse + gyro_z_l[i];
                }                                              
                
        //Divide by number of measurment        
	gyro_X_H_akse = gyro_X_H_akse / gyro_measurements;
	gyro_X_L_akse = gyro_X_L_akse / gyro_measurements;
        gyro_Y_H_akse = gyro_Y_H_akse / gyro_measurements;
        gyro_Y_L_akse = gyro_Y_L_akse / gyro_measurements;
        gyro_Z_H_akse = gyro_Z_H_akse / gyro_measurements;
        gyro_Z_L_akse = gyro_Z_L_akse / gyro_measurements;                
         
	//Read gyro temperature
	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	spi(0b10000111);			//Init. reading of temp Z (Vin1)
	spi(0b00010000);
	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer                                     
	
	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	gyro_temp_z_h = spi(0b10001111); 	//Init. reading of temp Y (Vin3)
	gyro_temp_z_h = gyro_temp_z_h & 0x0F;
	gyro_temp_z_l = spi(0b00010000);
	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	
	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	gyro_temp_y_h = spi(0b10010111);	//Init. reading of temp X (Vin5)
	gyro_temp_y_h = gyro_temp_y_h & 0x0F;
	gyro_temp_y_l = spi(0b00010000);
	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	
	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	gyro_temp_x_h = spi(0b10000011);	//Init. reading of gyro Z
	gyro_temp_x_h = gyro_temp_x_h & 0x0F;
	gyro_temp_x_l = spi(0b00010000);
	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
  
}                                              


//Init. the AD7927 ADC. We use ADC in normal mode and no sequencer operation
void init_ADC(void)
{
        PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
        spi(0xFF);		//Dummy conversion
        spi(0xFF);
        PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
        delay_ms(5);
        PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
        spi(0xFF);		//Dummy conversion
        spi(0xFF);
        PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
        delay_ms(5);
        PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
        spi(0b10000011);        //Put ADC in the right mode and init. conversion of gyro X
        spi(0b00010000);
        PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
        delay_ms(5); 
}

//Init. the HMC6352 compass. Operational mode: 10Hz update (in cont. mode), periodic S/R on, standby mode
void init_compass(void)
{
        i2c_start();
        i2c_write(0x42);  	//write to kompass
        i2c_write(0x47);  	//write to RAM ('G'-command)
        delay_us(70);
        i2c_write(0x74);  	//write data to RAM-register 0x74 (Operational mode)
        delay_us(70);
        i2c_write(0b01010000);  //Operational mode: 10Hz update (in cont. mode), periodic S/R on, standby mode
        delay_us(70);
        i2c_stop();
        
        i2c_start();
        i2c_write(0x42);  	//write to kompass
        i2c_write(0x47);  	//write to RAM ('G'-command)
        delay_us(70);
        i2c_write(0x4E);  	//write data to RAM-register 0x4E (output mode)
        delay_us(70);
        i2c_write(0b00000000);  //Output mode: Heading
        delay_us(70);
        i2c_stop();
              
	i2c_start();
        i2c_write(0x42);  	// write to kompass
        i2c_write(0x4F);  	// S/R now
        delay_ms(8);
        i2c_stop();
                
}                   

//Read compass
unsigned int read_compass(void)
{
unsigned char kompass_dum_h;
unsigned char kompass_dum_l; 
unsigned int kompass_dum;
                      
        i2c_start();
        delay_ms(1);
        i2c_write(0x42);  //Write to I2c slave 
        delay_ms(6);
        i2c_write(0x41);  // 'A'-command
        i2c_stop();        
        delay_ms(6);
        
        i2c_start();
        i2c_ack = i2c_write(0x43);  //Read from slave
        delay_ms(6);
        if(i2c_ack == 1)
                {
                kompass_dum_h = i2c_read(1);	  //read, og sender en ack-bit for  signalisere at jeg vil lese mer    
                delay_ms(1);
                kompass_dum_l = i2c_read(0);	  //read, 
                delay_ms(1); 
                }
        i2c_stop();
        delay_ms(1); 
        
        kompass_dum_h = kompass_dum_h & 0x0F;
        kompass_dum = (kompass_dum_h*256) + kompass_dum_l;
                     
 
return kompass_dum;        
}


//Init accelerometer
void init_aks(void)
{
      PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
      spi(0x20); 		//write ctrl1
      spi(0xD7); 		//0xD7 in ctrl1
      PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
      
      PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
      spi(0x21);  		//write ctrl2
      spi(0x40);  		//0x40 in ctrl2
      PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
}

//Read accelerometerdata
void read_acc(void)
{
      PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
      spi(0xE8); 		//read, with auto increment 
      acc_dum_l_x = spi(0x00);	//read OUTX_L
      acc_dum_h_x = spi(0x00);	//read OUTX_H
      acc_dum_l_y = spi(0x00);	//read OUTY_L
      acc_dum_h_y = spi(0x00);	//read OUTY_H
      acc_dum_l_z = spi(0x00);	//read OUTZ_L
      acc_dum_h_z = spi(0x00);	//read OUTZ_H	
      PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
}