/************************************************************************** 
Name: 		isr.c
Comments:	All ISR's (Interrupt Service Routine)
**************************************************************************/

#include "isr.h"
#include "imu.h"
#include <stdio.h>
#include <mega128.h>
//#include "flash.h"

extern volatile unsigned int samples_teller;

volatile unsigned char rec_matlab = 0;

// External Interrupt 4 service routine
interrupt [EXT_INT4] void ext_int4_isr(void)
{

delay_ms(500);	//delay to prevent the issues from button-bouncing
rec_matlab = start_send;
start_of_transmission = 1;
samples_teller = 0;
ms = 0;
TCNT0=0x00;
}

// External Interrupt 5 service routine
interrupt [EXT_INT5] void ext_int5_isr(void)
{
rec_matlab = stop_send;


}

// External Interrupt 6 service routine
interrupt [EXT_INT6] void ext_int6_isr(void)
{

}

// External Interrupt 7 service routine
interrupt [EXT_INT7] void ext_int7_isr(void)
{


}


// USART1 Receiver interrupt service routine
// Recieve from PC(Matlab) via USB
#pragma savereg-
interrupt [USART1_RXC] void uart1_rx_isr(void)
{
char status,data;
#asm
    push r26
    push r27
    push r30
    push r31
    in   r26,sreg
    push r26
#endasm
status=UCSR1A;
data=UDR1;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
        {
        rec_matlab=data;
        }
if(rec_matlab == start_send)
        {
        start_of_transmission = 1;
        samples_teller = 0;
        ms = 0;
        TCNT0=0x00;
        }
#asm
    pop  r26
    out  sreg,r26
    pop  r31
    pop  r30
    pop  r27
    pop  r26
#endasm
}
#pragma savereg+ 


        
/// USART1 Transmitter interrupt service routine 
// Transmit to PC via USB
#pragma savereg-
interrupt [USART1_DRE] void uart1_dre_isr(void)
{
#asm
    push r26
    push r27
    push r30
    push r31
    in   r26,sreg
    push r26
#endasm
{
UDR1 = imu_data[imu_data_teller];
imu_data_teller++;
if(imu_data_teller > 11)//0 - 5 is acc data, 6 t.o.m. 11 er gyro data, 12 tom 17 er gyrtemp, 18 t.o.m 19 er samples_teller
        {
        imu_data_teller  = 0;
	UCSR1B = 0x98;	//disable UDR1E isr
	timer1_isr = 0;
        }
}
       
#asm
    pop  r26
    out  sreg,r26
    pop  r31
    pop  r30
    pop  r27
    pop  r26
#endasm 

}
#pragma savereg+
            

// Timer 1 output compare A interrupt service routine
// Samples the sensors, 100 Hz.
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{             
//Les gyro XYZ og midle 5 mlinger 
SPCR=0x54;             
read_gyros();
//Read acc
SPCR=0x5C;
read_acc();
timer1_isr = 1;
samples_teller++;

}

// Timer 0 output compare interrupt service routine 
// RTC
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
static char LeapMonth;

ms++;
if (ms == 10000)
	{
	ms = 0;
       //	SECOND++;   // increment second
	}
/*
if (SECOND == 60)
	{
        SECOND = 0;
        MINUTE++;
        
        if (MINUTE > 59)
        	{
            	MINUTE = 0;
            	HOUR++;
            
            	if (HOUR > 23)
                    	{
                        HOUR = 0;
                        DAY++;
        
                        // Check for leap year if month == February
                        if (MONTH == 2)
                            	{
                            	if (!(YEAR & 0x0003))  
                                	{
                                	if (YEAR%100 == 0)
                                    		{
                                    		if (YEAR%400 == 0)
                                        		{LeapMonth = 1;}
        		                        else
                        		                {LeapMonth = 0;}
                                    		}
                                	else
                                    		{LeapMonth = 1;}
                                	}
                            	else
                                	{LeapMonth = 0;}
                            	}
                        else
                            	{LeapMonth = 0;}
        
                        // Check for month length
                        if (DAY > (MonthLength[MONTH] + LeapMonth))
        	                {
                	        DAY = 1;
                        	MONTH++;
        
                            	if (MONTH > 12)
                            		{
                                	MONTH = 1;
                                	YEAR++;
        		                }
                        	}
                    	}
        	}
    	}
    	*/
}
