/*********************************************
This program was produced by the
CodeWizardAVR V1.23.7 Standard
Automatic Program Generator
 Copyright 1998-2002 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : Kalibrering av treghetsmodul
Version : 1.0
Date    : 16.03.2006
Author  : License 61, Lawicel HB          
Company : Klubbgatan 3, Tyringe, Sweden   
Comments: 


Chip type           : ATmega128L
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 4096
External SRAM size  : 0
Data Stack size     : 1024
*********************************************/

#include <mega128.h>
#include <spi.h>
#include <stdio.h>
#include <ctype.h>
#include "delay.h"
#include "display.h"
#include "imu.h"
#include "filter.h"
#include "main.h"
#include "isr.h"
#include "flash.h"

 
// SW I2C Bus functions
#asm
   .equ __i2c_port=0x18
   .equ __sda_bit=4
   .equ __scl_bit=5
#endasm
#include <i2c.h>
  

//------Globale variables------
volatile unsigned int volt=0;
volatile unsigned char timer1_isr = 0;
extern volatile unsigned char rec_matlab;
//IMU related variables
unsigned int kompass_retning = 0;
unsigned char i2c_ack = 0;
unsigned char i2c_klar = 0;
unsigned int gyro_z = 0;
unsigned int gyro_z_h[gyro_measurements];
unsigned int gyro_z_l[gyro_measurements];
unsigned int gyro_Z_H_akse = 0;
unsigned int gyro_Z_L_akse = 0;
unsigned int gyro_y = 0;
unsigned int gyro_y_h[gyro_measurements];
unsigned int gyro_y_l[gyro_measurements];
unsigned int gyro_Y_H_akse = 0;
unsigned int gyro_Y_L_akse = 0;
unsigned int gyro_x = 0; 
unsigned int gyro_x_h[gyro_measurements];
unsigned int gyro_x_l[gyro_measurements];
unsigned int gyro_X_H_akse = 0;
unsigned int gyro_X_L_akse = 0;
unsigned int gyro_temp_x_h = 0;
unsigned int gyro_temp_x_l = 0;
unsigned int gyro_temp_y_h = 0;
unsigned int gyro_temp_y_l = 0;
unsigned int gyro_temp_z_h = 0;
unsigned int gyro_temp_z_l = 0;
unsigned int acc_dum_h_x = 0;
unsigned int acc_dum_l_x = 0;
unsigned int acc_dum_h_y = 0;
unsigned int acc_dum_l_y = 0; 
unsigned int acc_dum_h_z = 0;
unsigned int acc_dum_l_z = 0;
unsigned char imu_data[20];
volatile unsigned char imu_data_teller = 0;	
volatile unsigned int samples_teller = 0;
volatile bit start_of_transmission = 1;
volatile unsigned char start_of_transmission_counter = 0;

//Moving average						
unsigned short int gyro_vekt_1[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned short int gyro_vekt_2[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned short int gyro_vekt_3[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned short int gyro_vekt_4[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned short int gyro_vekt_5[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned short int gyro_vekt_6[10] = {0,0,0,0,0,0,0,0,0,0};
//RTC
unsigned char SECOND = 0;
unsigned char MINUTE = 0;
unsigned char HOUR = 0;
unsigned char DAY = 0;
unsigned char MONTH = 0;
unsigned int YEAR = 0;
char MonthLength[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
volatile unsigned int ms = 0;
/*
//FLASH
unsigned char flash_test[12] = {'A','B','C','D','E','F','G','H','I','J','K','L'};
unsigned char i = 0;
unsigned int flash_adresse = 0;
unsigned int flash_start_adresse = 0;
unsigned char flash_delete = 0;
unsigned char flash_transmit = 0;
unsigned char flash_lagre = 0;
unsigned char pause = 0;
  */

void main(void)
{
#asm("cli")

// Input/Output Ports initialization
// Port A initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
PORTA=0x00;
DDRA=0xFF;

// Port B initialization
// Func0=Out Func1=Out Func2=Out Func3=In Func4=In Func5=In Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=T State4=T State5=T State6=0 State7=0 
PORTB=0x00;
DDRB=0xC7;

// Port C initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=Out Func5=Out Func6=Out Func7=In 
// State0=T State1=T State2=T State3=0 State4=0 State5=0 State6=0 State7=T 
PORTD=0x00;
DDRD=0x78;

// Port E initialization
// Func0=In Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=0 State2=T State3=T State4=P State5=P State6=P State7=P 
PORTE=0xF0;
DDRE=0x02;

// Port F initialization
// Func0=Out Func1=In Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=In 
// State0=0 State1=T State2=0 State3=1 State4=1 State5=0 State6=0 State7=T 
PORTF=0x18;
DDRF=0x7D;

// Port G initialization
// Func0=Out Func1=Out Func2=Out Func3=In Func4=In 
// State0=0 State1=0 State2=1 State3=T State4=T 
PORTG=0x04;
DDRG=0x06;     

// Timer/Counter 0 initialization         
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: CTC top=OCR0
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x0C;    
TCNT0=0x00;
OCR0=0x7D;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
//OCR1AH & OCR1AL:
//0x3E8 = 1000 (125Hz), 0x4E2 = 1250 (100Hz), 0x30D4 = 12500(10Hz), 0x2CA = 714 (175Hz)
//0x9C4 = 2500 (50Hz), 0x271 = 625 (200Hz), 0x342 = 833 (150Hz), 0x37D = 893 (140Hz)
//0x470 = 1136 (110), 0x61B = 1563 (80), 0x683 = 1667 (75)
OCR1AH=0x04;    
OCR1AL=0xE2;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: On
// INT4 Mode: Falling Edge
// INT5: On
// INT5 Mode: Falling Edge
// INT6: On
// INT6 Mode: Falling Edge
// INT7: On
// INT7 Mode: Falling Edge
EICRA=0x00;
EICRB=0xAA;
EIMSK=0xF0;
EIFR=0xF0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x12;
//TIMSK:	
//0x12: Bde timer0 og timer1 outputcomp.ISR.	
//0x10: Kun timer1 outputcomp.ISR.
//0x02: Kun timer0 outputcomp.ISR.
ETIMSK=0x00;
             /*
// USART0 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART0 Receiver: On
// USART0 Transmitter: Off
// USART0 Mode: Asynchronous
// USART0 Baud rate: 4800
UCSR0A=0x00;
UCSR0B=0x98;	//0x98	//0x90
UCSR0C=0x06;	//0x06
UBRR0H=0x00;
UBRR0L=0x0C;	//0x0C	//0x67
           */   
// USART1 initialization	 UTEN ISR
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART1 Receiver: On
// USART1 Transmitter: On
// USART1 Mode: Asynchronous
// USART1 Baud rate: 38400
UCSR1A=0x00;
UCSR1B=0x98;
UCSR1C=0x06;
UBRR1H=0x00;
UBRR1L=0x0C;
            

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x00; //0x80
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC High Speed Mode: Off
//ADMUX=0xE7;
//ADCSRA=0xEF; 
//SFIOR&=0xEF; 

ADMUX=0x00;
ADCSRA=0x00; 
SFIOR&=0xEF; 

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*2000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x54;	
//Endret klokkepolaritet (0x50)   58: CPOL=1,CPHA=0
//FLASH works with SPCR=0x50 and SPCR=0x5C
//Accelerometer works with SPCR=0x5C
//ADC works with SPCR=0x54
SPSR=0x01;

//PORTF is in the extended I/O space.
//Cannot use the PORTX.N construct for ports F or G on the ATmega128
PORTF = 0b00011101;  //CS on the voltage regulators, ADC og accelerometer

// I2C Bus initialization
i2c_init();

//Wait for external x-tal to stabilize
delay_ms(1000);     
init_display();
clear_display();

cs_flash = 1; //Active low
charge_enable = 1; //Active low                             
//WARNING: Reading the HMC6352 does not work togther with the chargeIC
//(The I2C lines is the same as STATX lines on the chargeIC)

//Init kompass, ADC and accelerometer
init_compass();
init_ADC();  
init_aks();

// Global enable interrupts
#asm("sei")

//Main loop              
while (1)
        {
        	/*            
	#asm("cli")
        kompass_retning = read_compass();
        lcdprint(kompass_retning,5,0);
        #asm("sei")
                  */          
        //Bare en sjekk som sier i fra
        //ikke ndvendig
        if (samples_teller > 65000)
        	{
        	Write('X',1,15);
        	samples_teller = 0;
        	}
        
        //When a new sample has occured
        if(timer1_isr == 1)
        	{
        	//Moving average filtering for the gyros, if no moving average filter is
        	//needed, remove the line below
                //moving_average_gyro();                 
                
                //Start transmitting to matlab
                if ((rec_matlab == start_send) )
                	{
                	Write('M',0,14); Write('L',0,15); 
                	send_matlab();  
                	}
                	
                //Stop transmitting to matlab.
                if ((rec_matlab == stop_send) )
                        {
                        Write(' ',0,14); Write(' ',0,15);
                        } 

        	timer1_isr = 0;
        	}
        //If Matlab is requesting data, do not update the LCD with gyro data
	if(rec_matlab != start_send)
		{     
                gyro_x = (gyro_X_H_akse*256) + gyro_X_L_akse;
                gyro_y = (gyro_Y_H_akse*256) + gyro_Y_L_akse;
                gyro_z = (gyro_Z_H_akse*256) + gyro_Z_L_akse; 
                lcdprint(gyro_x,0,0);
                Write('G',0,5); Write('Y',0,6); Write('R',0,7); Write('O',0,8); Write('X',0,9);
                lcdprint(gyro_y,1,0);      
                Write('G',1,5); Write('Y',1,6); Write('R',1,7); Write('O',1,8); Write('Y',1,9);      
                lcdprint(gyro_z,2,0);
                Write('G',2,5); Write('Y',2,6); Write('R',2,7); Write('O',2,8); Write('Z',2,9);

                }    
             
        }
}//Main loop end

//Displays the voltage of the battery
//(Must enable ADC ISR with correct Vref)
void check_voltage(void)
{
unsigned int tier;
unsigned int hundre;
unsigned int ener;

Write('V',0,16);

if (volt<10)
	{
	Write('0',0,12);
	Write(',',0,13);
	Write('0',0,14);
	Write(volt+48,0,15);
	}
else if ((volt>=10)&&(volt<100))
	{
	Write('0',0,12);
	Write(',',0,13);
	tier=(volt/10);
	Write(tier+48,0,14);
	Write((volt-(tier*10))+48,0,15);
	}
else
	{
	hundre=(volt/100);
	Write(hundre+48,0,12);
	Write(',',0,13);
	tier=(volt-(hundre*100))/10;
	Write(tier+48,0,14);
	ener=volt-((hundre*100)+(tier*10));
	Write(ener+48,0,15);
	}    
}


void send_matlab(void)
{
unsigned char j = 0; //This is for tx by means of ISR
                
//Sort data for transmitting
imu_data[0] = acc_dum_h_x & 0xFF;
imu_data[1] = acc_dum_l_x & 0xFF;
imu_data[2] = acc_dum_h_y & 0xFF;
imu_data[3] = acc_dum_l_y & 0xFF;
imu_data[4] = acc_dum_h_z & 0xFF;
imu_data[5] = acc_dum_l_z & 0xFF;
imu_data[6] = gyro_X_H_akse & 0xFF;
imu_data[7] = gyro_X_L_akse & 0xFF;
imu_data[8] = gyro_Y_H_akse & 0xFF;
imu_data[9] = gyro_Y_L_akse & 0xFF;
imu_data[10] = gyro_Z_H_akse & 0xFF;
imu_data[11] = gyro_Z_L_akse & 0xFF;

imu_data[12] = gyro_temp_x_h & 0xFF;
imu_data[13] = gyro_temp_x_l & 0xFF;
imu_data[14] = gyro_temp_y_h & 0xFF;
imu_data[15] = gyro_temp_y_l & 0xFF;
imu_data[16] = gyro_temp_z_h & 0xFF;
imu_data[17] = gyro_temp_z_l & 0xFF;

imu_data[18] = samples_teller >> 8;
imu_data[19] = samples_teller & 0xFF;
               
              /*
//Fiktive data for sjekking                
imu_data[0] = 0;
imu_data[1] = 1;
imu_data[2] = 2;
imu_data[3] = 3;
imu_data[4] = 4;
imu_data[5] = 5;
imu_data[6] = 6;
imu_data[7] = 7;
imu_data[8] = 8;
imu_data[9] = 9;
imu_data[10] = 10;
imu_data[11] = 11;
imu_data[12] = samples_teller >> 8;
imu_data[13] = samples_teller & 0xFF;
               */ 
//Enable UDR1E isr 
//If tx by means of polling is wanted, remove this line               
UCSR1B = 0xB8;
       
/*
//UART1 tx by means of polling, if tx by means of ISR is wanted, remove this for-loop
for(j=0;j<12;j++)
	{
	while ((UCSR0A & DATA_REGISTER_EMPTY)==0);
        	{
        	UDR0=imu_data[j];
        	}
	}
*/

}