;CodeVisionAVR C Compiler V1.23.7 Standard
;(C) Copyright 1998-2002 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega128
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;Internal SRAM size  : 4096
;External SRAM size  : 0
;Data Stack size     : 1024
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C
	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "flash.vec"
	.INCLUDE "flash.inc"
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.23.7 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2002 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 14.10.2005
;      12 Author  : License 61, Lawicel HB          
;      13 Company : Klubbgatan 3, Tyringe, Sweden   
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega128
;      18 Program type        : Application
;      19 Clock frequency     : 8,000000 MHz
;      20 Memory model        : Small
;      21 Internal SRAM size  : 4096
;      22 External SRAM size  : 0
;      23 Data Stack size     : 1024
;      24 *********************************************/
;      25 
;      26 #include <mega128.h>
;      27 #include <delay.h>
;      28 // SPI functions
;      29 #include <spi.h>
;      30 #include <string.h>
;      31 #include "flash1.h"
;      32 
;      33 #define RXB8 1
;      34 #define TXB8 0
;      35 #define UPE 2
;      36 #define OVR 3
;      37 #define FE 4
;      38 #define UDRE 5
;      39 #define RXC 7
;      40 
;      41 #define FRAMING_ERROR (1<<FE)
;      42 #define PARITY_ERROR (1<<UPE)
;      43 #define DATA_OVERRUN (1<<OVR)
;      44 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      45 #define RX_COMPLETE (1<<RXC)     
;      46 /*
;      47 //Flash M25P80
;      48 #define DEACTIVATE_FLASH PORTB.0=1
;      49 #define ACTIVATE_FLASH PORTB.0=0          
;      50 #define WREN 0x06
;      51 #define WRDI 0x04
;      52 #define READ 0x03
;      53 #define PP 0x02
;      54 #define FAST_READ 0x0B
;      55 #define BE 0xC7
;      56 #define RDSR 0x05
;      57 */
;      58 // Get a character from the USART1 Receiver
;      59 #pragma used+
;      60 char getchar1(void)
;      61 {

	.CSEG
;      62 char status,data;
;      63 while (1)
;	status -> R16
;	data -> R17
;      64       {
;      65       while (((status=UCSR1A) & RX_COMPLETE)==0);
;      66       data=UDR1;
;      67       if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
;      68          return data;
;      69       };
;      70 }
;      71 #pragma used-
;      72 
;      73 
;      74 // Write a character to the USART1 Transmitter
;      75 #pragma used+
;      76 void putchar1(char c)
;      77 {
;      78 while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
;      79 UDR1=c;
;      80 }
;      81 #pragma used-
;      82 
;      83 /*
;      84 //Sjekke statusregister og vente til klar...
;      85 void wait_flash_rdy(void)
;      86 {
;      87 unsigned char status = 0;
;      88 unsigned char klar = 0x01;
;      89 
;      90 ACTIVATE_FLASH;
;      91 spi(RDSR);
;      92 while (klar == 0x01)
;      93 	{
;      94 	status = spi(0x00);
;      95 	//PORTD = ~status;	//invertert pga LEDS p stk500  
;      96 	klar = (status & 0x01);
;      97 	}
;      98 DEACTIVATE_FLASH;
;      99 }
;     100 
;     101 
;     102 //Write enable
;     103 void write_enable(void)
;     104 {
;     105 ACTIVATE_FLASH;
;     106 spi(WREN);
;     107 DEACTIVATE_FLASH;
;     108 }
;     109 
;     110 
;     111 //Write disable
;     112 void write_disable(void)
;     113 {
;     114 ACTIVATE_FLASH;
;     115 spi(WRDI);
;     116 DEACTIVATE_FLASH;
;     117 }
;     118 
;     119 
;     120 //Pageprogram in external flash
;     121 #pragma used+
;     122 void PageProgram(char data, unsigned long int adress)
;     123 {
;     124 wait_flash_rdy();
;     125 
;     126 write_enable();
;     127 
;     128 //Page program
;     129 ACTIVATE_FLASH;
;     130 spi(PP);
;     131 spi(adress>>16);
;     132 spi(adress>>8);
;     133 spi(adress);
;     134 spi(data);	//ASCII $
;     135 DEACTIVATE_FLASH;
;     136 }
;     137 #pragma used- 
;     138 
;     139 
;     140 //Sletta heila driden....
;     141 void bulk_erase(void)
;     142 {
;     143 wait_flash_rdy();
;     144 
;     145 write_enable();
;     146 
;     147 //BULK ERASE
;     148 ACTIVATE_FLASH;
;     149 spi(BE);
;     150 DEACTIVATE_FLASH;
;     151 }
;     152 
;     153 
;     154 //Read flash
;     155 void flash_page_to_UART(int page_nr)
;     156 {
;     157 unsigned char i, data;
;     158 unsigned long int start_adress;
;     159 
;     160 start_adress = (page_nr*256);
;     161 
;     162 wait_flash_rdy();
;     163 
;     164 ACTIVATE_FLASH;
;     165 spi(READ);
;     166 spi(start_adress>>16);
;     167 spi(start_adress>>8);
;     168 spi(start_adress);
;     169 for(i=0; i<255; i++)
;     170 	{
;     171 	data=spi(0x00);
;     172 	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
;     173         UDR1=data;
;     174 	}	
;     175 DEACTIVATE_FLASH;
;     176 }
;     177 */
;     178 
;     179 // Declare your global variables here
;     180 unsigned char data, nmea_funnet, nmea_index, pos_data_index, tracking;
;     181 unsigned char nmea_data[81];

	.DSEG
_nmea_data:
	.BYTE 0x51
;     182 unsigned char pos_data [25];
_pos_data:
	.BYTE 0x19
;     183 
;     184 flash char strkonst[10] = {'T','O','R',' ','I','V','A','R',0xA,0xD};  //teste....

	.CSEG
;     185 int adresse, start_adresse;    
;     186 unsigned long int flash_size = 1048576; //antall bytes totalt i flashen.... 

	.DSEG
_flash_size:
	.BYTE 0x4
;     187 
;     188 
;     189 void main(void)
;     190 {

	.CSEG
_main:
;     191 // Declare your local variables here
;     192 
;     193 // Input/Output Ports initialization
;     194 // Port A initialization
;     195 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     196 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     197 PORTA=0x00;
	CLR  R30
	OUT  0x1B,R30
;     198 DDRA=0x00;
	OUT  0x1A,R30
;     199 
;     200 // Port B initialization
;     201 // Func0=Out Func1=Out Func2=Out Func3=In Func4=In Func5=In Func6=In Func7=In 
;     202 // State0=0 State1=0 State2=0 State3=T State4=T State5=T State6=T State7=T 
;     203 PORTB=0x00;
	OUT  0x18,R30
;     204 DDRB=0x07;
	LDI  R30,LOW(7)
	OUT  0x17,R30
;     205 
;     206 // Port C initialization
;     207 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     208 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     209 PORTC=0x00;
	CLR  R30
	OUT  0x15,R30
;     210 DDRC=0x00;
	OUT  0x14,R30
;     211 
;     212 // Port D initialization
;     213 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     214 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     215 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     216 DDRD=0x03;   //PD0 og PD1 er utgang
	LDI  R30,LOW(3)
	OUT  0x11,R30
;     217 
;     218 // Port E initialization
;     219 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     220 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     221 PORTE=0x00;
	CLR  R30
	OUT  0x3,R30
;     222 DDRE=0x00;
	OUT  0x2,R30
;     223 
;     224 // Port F initialization
;     225 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     226 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     227 PORTF=0x00;
	STS  0x62,R30
;     228 DDRF=0x00;
	STS  0x61,R30
;     229 
;     230 // Port G initialization
;     231 // Func0=In Func1=In Func2=In Func3=In Func4=In 
;     232 // State0=T State1=T State2=T State3=T State4=T 
;     233 PORTG=0x00;
	STS  0x65,R30
;     234 DDRG=0x00;
	STS  0x64,R30
;     235 
;     236 // Timer/Counter 0 initialization
;     237 // Clock source: System Clock
;     238 // Clock value: Timer 0 Stopped
;     239 // Mode: Normal top=FFh
;     240 // OC0 output: Disconnected
;     241 ASSR=0x00;
	OUT  0x30,R30
;     242 TCCR0=0x00;
	OUT  0x33,R30
;     243 TCNT0=0x00;
	OUT  0x32,R30
;     244 OCR0=0x00;
	OUT  0x31,R30
;     245 
;     246 // Timer/Counter 1 initialization
;     247 // Clock source: System Clock
;     248 // Clock value: Timer 1 Stopped
;     249 // Mode: Normal top=FFFFh
;     250 // OC1A output: Discon.
;     251 // OC1B output: Discon.
;     252 // OC1C output: Discon.
;     253 // Noise Canceler: Off
;     254 // Input Capture on Falling Edge
;     255 TCCR1A=0x00;
	OUT  0x2F,R30
;     256 TCCR1B=0x00;
	OUT  0x2E,R30
;     257 TCNT1H=0x00;
	OUT  0x2D,R30
;     258 TCNT1L=0x00;
	OUT  0x2C,R30
;     259 OCR1AH=0x00;
	OUT  0x2B,R30
;     260 OCR1AL=0x00;
	OUT  0x2A,R30
;     261 OCR1BH=0x00;
	OUT  0x29,R30
;     262 OCR1BL=0x00;
	OUT  0x28,R30
;     263 OCR1CH=0x00;
	STS  0x79,R30
;     264 OCR1CL=0x00;
	STS  0x78,R30
;     265 
;     266 // Timer/Counter 2 initialization
;     267 // Clock source: System Clock
;     268 // Clock value: Timer 2 Stopped
;     269 // Mode: Normal top=FFh
;     270 // OC2 output: Disconnected
;     271 TCCR2=0x00;
	OUT  0x25,R30
;     272 TCNT2=0x00;
	OUT  0x24,R30
;     273 OCR2=0x00;
	OUT  0x23,R30
;     274 
;     275 // Timer/Counter 3 initialization
;     276 // Clock source: System Clock
;     277 // Clock value: Timer 3 Stopped
;     278 // Mode: Normal top=FFFFh
;     279 // OC3A output: Discon.
;     280 // OC3B output: Discon.
;     281 // OC3C output: Discon.
;     282 TCCR3A=0x00;
	STS  0x8B,R30
;     283 TCCR3B=0x00;
	STS  0x8A,R30
;     284 TCNT3H=0x00;
	STS  0x89,R30
;     285 TCNT3L=0x00;
	STS  0x88,R30
;     286 OCR3AH=0x00;
	STS  0x87,R30
;     287 OCR3AL=0x00;
	STS  0x86,R30
;     288 OCR3BH=0x00;
	STS  0x85,R30
;     289 OCR3BL=0x00;
	STS  0x84,R30
;     290 OCR3CH=0x00;
	STS  0x83,R30
;     291 OCR3CL=0x00;
	STS  0x82,R30
;     292 
;     293 // External Interrupt(s) initialization
;     294 // INT0: Off
;     295 // INT1: Off
;     296 // INT2: Off
;     297 // INT3: Off
;     298 // INT4: Off
;     299 // INT5: Off
;     300 // INT6: Off
;     301 // INT7: Off
;     302 EICRA=0x00;
	STS  0x6A,R30
;     303 EICRB=0x00;
	OUT  0x3A,R30
;     304 EIMSK=0x00;
	OUT  0x39,R30
;     305 
;     306 // Timer(s)/Counter(s) Interrupt(s) initialization
;     307 TIMSK=0x00;
	OUT  0x37,R30
;     308 ETIMSK=0x00;
	STS  0x7D,R30
;     309 
;     310 // USART0 initialization
;     311 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     312 // USART0 Receiver: On
;     313 // USART0 Transmitter: On
;     314 // USART0 Mode: Asynchronous
;     315 // USART0 Baud rate: 4800
;     316 UCSR0A=0x00;
	OUT  0xB,R30
;     317 UCSR0B=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     318 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  0x95,R30
;     319 UBRR0H=0x00;
	CLR  R30
	STS  0x90,R30
;     320 UBRR0L=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
;     321 
;     322 // USART1 initialization
;     323 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     324 // USART1 Receiver: On
;     325 // USART1 Transmitter: On
;     326 // USART1 Mode: Asynchronous
;     327 // USART1 Baud rate: 9600
;     328 UCSR1A=0x00;
	CLR  R30
	STS  0x9B,R30
;     329 UCSR1B=0x18;
	LDI  R30,LOW(24)
	STS  0x9A,R30
;     330 UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  0x9D,R30
;     331 UBRR1H=0x00;
	CLR  R30
	STS  0x98,R30
;     332 UBRR1L=0x33;
	LDI  R30,LOW(51)
	STS  0x99,R30
;     333 
;     334 // Analog Comparator initialization
;     335 // Analog Comparator: Off
;     336 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     337 // Analog Comparator Output: Off
;     338 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     339 SFIOR=0x00;
	CLR  R30
	OUT  0x20,R30
;     340 
;     341 // SPI initialization
;     342 // SPI Type: Master
;     343 // SPI Clock Rate: 2000,000 kHz
;     344 // SPI Clock Phase: Cycle Half
;     345 // SPI Clock Polarity: Low
;     346 // SPI Data Order: MSB First
;     347 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     348 SPSR=0x00;
	CLR  R30
	OUT  0xE,R30
;     349 
;     350 #asm ("cli");
	cli
;     351 
;     352 //start
;     353 PORTD.0=0;
	CBI  0x12,0
;     354 delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     355 DEACTIVATE_FLASH;
	SBI  0x18,0
;     356 bulk_erase();
	RCALL _bulk_erase
;     357 PORTD.0=1;
	SBI  0x12,0
;     358 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     359 
;     360 //hente NMEA data
;     361 nmea_funnet = 0;
	CLR  R5
;     362 nmea_index = 0;
	CLR  R6
;     363 pos_data_index = 0;
	CLR  R7
;     364 start_adresse = 0;
	CLR  R11
	CLR  R12
;     365 tracking = 1;
	LDI  R30,LOW(1)
	MOV  R8,R30
;     366 nmea_data[2] = 0;
	CLR  R30
	__PUTB1MN _nmea_data,2
;     367 
;     368 while (tracking == 1)
_0x3C:
	LDI  R30,LOW(1)
	CP   R30,R8
	BRNE _0x3E
;     369 	{
;     370 	while ((UCSR0A & RX_COMPLETE)==0);
_0x3F:
	SBIS 0xB,7
	RJMP _0x3F
;     371 	if (UDR0 == '$')
	IN   R30,0xC
	CPI  R30,LOW(0x24)
	BRNE _0x42
;     372         	{
;     373         	nmea_index = 0;
	CLR  R6
;     374                 while (nmea_index < 80)
_0x43:
	LDI  R30,LOW(80)
	CP   R6,R30
	BRSH _0x45
;     375                 	{
;     376                 	while ((UCSR0A & RX_COMPLETE)==0);
_0x46:
	SBIS 0xB,7
	RJMP _0x46
;     377                         nmea_data[nmea_index] = UDR0;
	MOV  R26,R6
	CLR  R27
	SUBI R26,LOW(-_nmea_data)
	SBCI R27,HIGH(-_nmea_data)
	IN   R30,0xC
	ST   X,R30
;     378                         nmea_index++;
	INC  R6
;     379 			}
	RJMP _0x43
_0x45:
;     380 		if ((nmea_data[2] == 'G') && (nmea_data[3] == 'L') && (nmea_data[4] == 'L'))
	__GETB1MN _nmea_data,2
	CPI  R30,LOW(0x47)
	BRNE _0x4A
	__GETB1MN _nmea_data,3
	CPI  R30,LOW(0x4C)
	BRNE _0x4A
	__GETB1MN _nmea_data,4
	CPI  R30,LOW(0x4C)
	BREQ _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
;     381 			{
;     382 			tracking = 0;
	CLR  R8
;     383 			}
;     384         	}
_0x49:
;     385        }
_0x42:
	RJMP _0x3C
_0x3E:
;     386 
;     387 PORTD.0=0;	//ferdig med  tracke...
	CBI  0x12,0
;     388 while (PINE.3 == 1);	//trykke p SW1 for  overfre til PC
_0x4C:
	SBIC 0x1,3
	RJMP _0x4C
;     389 PORTD.0=1;  
	SBI  0x12,0
;     390 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     391         
;     392 nmea_index = 6;
	LDI  R30,LOW(6)
	MOV  R6,R30
;     393         
;     394 write_enable();
	RCALL _write_enable
;     395 
;     396 //Legge nmea_data 6 til 28 (=22 stk data) i flash
;     397 for(adresse=start_adresse; adresse<(start_adresse+22); adresse++)
	__MOVEWRR 9,10,11,12
_0x50:
	__GETW1R 11,12
	ADIW R30,22
	CP   R9,R30
	CPC  R10,R31
	BRGE _0x51
;     398 {
;     399 	PageProgram(nmea_data[nmea_index], adresse);
	MOV  R30,R6
	CLR  R31
	SUBI R30,LOW(-_nmea_data)
	SBCI R31,HIGH(-_nmea_data)
	LD   R30,Z
	ST   -Y,R30
	__GETW1R 9,10
	CALL __CWD1
	CALL __PUTPARD1
	RCALL _PageProgram
;     400         nmea_index++;	
	INC  R6
;     401 }
	__GETW1R 9,10
	ADIW R30,1
	__PUTW1R 9,10
	RJMP _0x50
_0x51:
;     402 
;     403 //initialise for neste tracking
;     404 start_adresse = start_adresse+22;
	__GETW1R 11,12
	ADIW R30,22
	__PUTW1R 11,12
;     405 nmea_funnet = 1;	//egentlig 0
	LDI  R30,LOW(1)
	MOV  R5,R30
;     406         
;     407 PORTD.0=0;	//ferdig med  tracke...
	CBI  0x12,0
;     408 while (PINE.3 == 1);	//trykke p SW1 for  overfre til PC
_0x52:
	SBIC 0x1,3
	RJMP _0x52
;     409 PORTD.0=1;
	SBI  0x12,0
;     410 
;     411 
;     412 ACTIVATE_FLASH;
	CBI  0x18,0
;     413 spi(READ);
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x0
;     414 spi(0x00);
	RCALL SUBOPT_0x0
;     415 spi(0x00);
	RCALL SUBOPT_0x0
;     416 spi(0x00);
	ST   -Y,R30
	CALL _spi
;     417 while (start_adresse > 0)
_0x55:
	CLR  R0
	CP   R0,R11
	CPC  R0,R12
	BRGE _0x57
;     418 	{
;     419 	data=spi(0x00);
	RCALL SUBOPT_0x1
	MOV  R4,R30
;     420 	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
_0x58:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x58
;     421         UDR1=data;
	STS  156,R4
;     422         start_adresse--;
	__GETW1R 11,12
	SBIW R30,1
	__PUTW1R 11,12
;     423 	}	
	RJMP _0x55
_0x57:
;     424 DEACTIVATE_FLASH;
	SBI  0x18,0
;     425    
;     426 PORTD.0=0;
	CBI  0x12,0
;     427 
;     428 
;     429 }
_0x5B:
	RJMP _0x5B
;     430 /*************************************************************
;     431 *                                                            *
;     432 *                                                            *
;     433 *                                                            *
;     434 * Rutiner for skriving/lesing til FLASH M25P80 fra ST        *
;     435 *                                                            *
;     436 *************************************************************/ 
;     437 
;     438 #include <mega128.h>
;     439 #include <delay.h>
;     440 // SPI functions
;     441 #include <spi.h>
;     442 #include "flash1.h"
;     443 
;     444 
;     445 //Sjekke statusregister og vente til klar...
;     446 void wait_flash_rdy(void)
;     447 {
_wait_flash_rdy:
;     448 unsigned char status = 0;
;     449 unsigned char klar = 0x01;
;     450 
;     451 ACTIVATE_FLASH;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	klar -> R17
	LDI  R16,0
	LDI  R17,1
	CBI  0x18,0
;     452 spi(RDSR);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _spi
;     453 while (klar == 0x01)
_0x66:
	CPI  R17,1
	BRNE _0x68
;     454 	{
;     455 	status = spi(0x00);
	RCALL SUBOPT_0x1
	MOV  R16,R30
;     456 	klar = (status & 0x01);
	MOV  R30,R16
	ANDI R30,LOW(0x1)
	MOV  R17,R30
;     457 	}
	RJMP _0x66
_0x68:
;     458 DEACTIVATE_FLASH;
	SBI  0x18,0
;     459 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;     460 
;     461 
;     462 //Write enable
;     463 void write_enable(void)
;     464 {
_write_enable:
;     465 ACTIVATE_FLASH;
	CBI  0x18,0
;     466 spi(WREN);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _spi
;     467 DEACTIVATE_FLASH;
	SBI  0x18,0
;     468 }
	RET
;     469 
;     470 
;     471 //Write disable
;     472 void write_disable(void)
;     473 {
;     474 ACTIVATE_FLASH;
;     475 spi(WRDI);
;     476 DEACTIVATE_FLASH;
;     477 }
;     478 
;     479 
;     480 //Pageprogram in external flash
;     481 void PageProgram(char data, unsigned long int adress)
;     482 {
_PageProgram:
;     483 wait_flash_rdy();
	RCALL _wait_flash_rdy
;     484 
;     485 write_enable();
	RCALL _write_enable
;     486 
;     487 ACTIVATE_FLASH;
	CBI  0x18,0
;     488 spi(PP);
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x2
;     489 spi(adress>>16);
	CALL __LSRD16
	ST   -Y,R30
	CALL _spi
;     490 spi(adress>>8);
	__GETD2S 0
	LDI  R30,LOW(8)
	CALL __LSRD12
	RCALL SUBOPT_0x2
;     491 spi(adress);
	ST   -Y,R30
	CALL _spi
;     492 spi(data);	//ASCII $
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _spi
;     493 DEACTIVATE_FLASH;
	SBI  0x18,0
;     494 }
	ADIW R28,5
	RET
;     495  
;     496 
;     497 
;     498 //Sletta heila driden....
;     499 void bulk_erase(void)
;     500 {
_bulk_erase:
;     501 wait_flash_rdy();
	RCALL _wait_flash_rdy
;     502 
;     503 write_enable();
	RCALL _write_enable
;     504 
;     505 //BULK ERASE
;     506 ACTIVATE_FLASH;
	CBI  0x18,0
;     507 spi(BE);
	LDI  R30,LOW(199)
	ST   -Y,R30
	CALL _spi
;     508 DEACTIVATE_FLASH;
	SBI  0x18,0
;     509 }
	RET
;     510 
;     511 
;     512 //Read flash
;     513 void flash_page_to_UART(int page_nr)
;     514 {
;     515 unsigned char i, data;
;     516 unsigned long int start_adress;
;     517 
;     518 start_adress = (page_nr*256);
;	page_nr -> Y+6
;	i -> R16
;	data -> R17
;	start_adress -> Y+2
;     519 
;     520 wait_flash_rdy();
;     521 
;     522 ACTIVATE_FLASH;
;     523 spi(READ);
;     524 spi(start_adress>>16);
;     525 spi(start_adress>>8);
;     526 spi(start_adress);
;     527 for(i=0; i<255; i++)
;     528 	{
;     529 	data=spi(0x00);
;     530 	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
;     531         UDR1=data;
;     532 	}	
;     533 DEACTIVATE_FLASH;
;     534 }

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	ST   -Y,R30
	CALL _spi
	CLR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	CLR  R30
	ST   -Y,R30
	JMP  _spi

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	ST   -Y,R30
	CALL _spi
	__GETD1S 0
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_spi:
	ld   r30,y+
	out  spdr,r30
__spi0:
	sbis spsr,7
	rjmp __spi0
	in   r30,spdr
	ret

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	CLR  R22
	CLR  R23
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

