/*********************************************
This program was produced by the
CodeWizardAVR V1.23.7 Standard
Automatic Program Generator
 Copyright 1998-2002 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 14.10.2005
Author  : License 61, Lawicel HB          
Company : Klubbgatan 3, Tyringe, Sweden   
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 4096
External SRAM size  : 0
Data Stack size     : 1024
*********************************************/

#include <mega128.h>
#include <delay.h>
// SPI functions
#include <spi.h>
#include <string.h>
#include "flash1.h"

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)     
/*
//Flash M25P80
#define DEACTIVATE_FLASH PORTB.0=1
#define ACTIVATE_FLASH PORTB.0=0          
#define WREN 0x06
#define WRDI 0x04
#define READ 0x03
#define PP 0x02
#define FAST_READ 0x0B
#define BE 0xC7
#define RDSR 0x05
*/
// Get a character from the USART1 Receiver
#pragma used+
char getchar1(void)
{
char status,data;
while (1)
      {
      while (((status=UCSR1A) & RX_COMPLETE)==0);
      data=UDR1;
      if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
         return data;
      };
}
#pragma used-


// Write a character to the USART1 Transmitter
#pragma used+
void putchar1(char c)
{
while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
UDR1=c;
}
#pragma used-

/*
//Sjekke statusregister og vente til klar...
void wait_flash_rdy(void)
{
unsigned char status = 0;
unsigned char klar = 0x01;

ACTIVATE_FLASH;
spi(RDSR);
while (klar == 0x01)
	{
	status = spi(0x00);
	//PORTD = ~status;	//invertert pga LEDS p stk500  
	klar = (status & 0x01);
	}
DEACTIVATE_FLASH;
}


//Write enable
void write_enable(void)
{
ACTIVATE_FLASH;
spi(WREN);
DEACTIVATE_FLASH;
}


//Write disable
void write_disable(void)
{
ACTIVATE_FLASH;
spi(WRDI);
DEACTIVATE_FLASH;
}


//Pageprogram in external flash
#pragma used+
void PageProgram(char data, unsigned long int adress)
{
wait_flash_rdy();

write_enable();

//Page program
ACTIVATE_FLASH;
spi(PP);
spi(adress>>16);
spi(adress>>8);
spi(adress);
spi(data);	//ASCII $
DEACTIVATE_FLASH;
}
#pragma used- 


//Sletta heila driden....
void bulk_erase(void)
{
wait_flash_rdy();

write_enable();

//BULK ERASE
ACTIVATE_FLASH;
spi(BE);
DEACTIVATE_FLASH;
}


//Read flash
void flash_page_to_UART(int page_nr)
{
unsigned char i, data;
unsigned long int start_adress;

start_adress = (page_nr*256);

wait_flash_rdy();

ACTIVATE_FLASH;
spi(READ);
spi(start_adress>>16);
spi(start_adress>>8);
spi(start_adress);
for(i=0; i<255; i++)
	{
	data=spi(0x00);
	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
        UDR1=data;
	}	
DEACTIVATE_FLASH;
}
*/

// Declare your global variables here
unsigned char data, nmea_funnet, nmea_index, pos_data_index, tracking;
unsigned char nmea_data[81];
unsigned char pos_data [25];

flash char strkonst[10] = {'T','O','R',' ','I','V','A','R',0xA,0xD};  //teste....
int adresse, start_adresse;    
unsigned long int flash_size = 1048576; //antall bytes totalt i flashen.... 


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func0=Out Func1=Out Func2=Out Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=0 State1=0 State2=0 State3=T State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x07;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTD=0xFF;
DDRD=0x03;   //PD0 og PD1 er utgang

// Port E initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTE=0x00;
DDRE=0x00;

// Port F initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTF=0x00;
DDRF=0x00;

// Port G initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In 
// State0=T State1=T State2=T State3=T State4=T 
PORTG=0x00;
DDRG=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
ETIMSK=0x00;

// USART0 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART0 Receiver: On
// USART0 Transmitter: On
// USART0 Mode: Asynchronous
// USART0 Baud rate: 4800
UCSR0A=0x00;
UCSR0B=0x18;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x67;

// USART1 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART1 Receiver: On
// USART1 Transmitter: On
// USART1 Mode: Asynchronous
// USART1 Baud rate: 9600
UCSR1A=0x00;
UCSR1B=0x18;
UCSR1C=0x06;
UBRR1H=0x00;
UBRR1L=0x33;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x00;

#asm ("cli");

//start
PORTD.0=0;
delay_ms(100);
DEACTIVATE_FLASH;
bulk_erase();
PORTD.0=1;
delay_ms(1000);

//hente NMEA data
nmea_funnet = 0;
nmea_index = 0;
pos_data_index = 0;
start_adresse = 0;
tracking = 1;
nmea_data[2] = 0;

while (tracking == 1)
	{
	while ((UCSR0A & RX_COMPLETE)==0);
	if (UDR0 == '$')
        	{
        	nmea_index = 0;
                while (nmea_index < 80)
                	{
                	while ((UCSR0A & RX_COMPLETE)==0);
                        nmea_data[nmea_index] = UDR0;
                        nmea_index++;
			}
		if ((nmea_data[2] == 'G') && (nmea_data[3] == 'L') && (nmea_data[4] == 'L'))
			{
			tracking = 0;
			}
        	}
       }

PORTD.0=0;	//ferdig med  tracke...
while (PINE.3 == 1);	//trykke p SW1 for  overfre til PC
PORTD.0=1;  
delay_ms(500);
        
nmea_index = 6;
        
write_enable();

//Legge nmea_data 6 til 28 (=22 stk data) i flash
for(adresse=start_adresse; adresse<(start_adresse+22); adresse++)
{
	PageProgram(nmea_data[nmea_index], adresse);
        nmea_index++;	
}

//initialise for neste tracking
start_adresse = start_adresse+22;
nmea_funnet = 1;	//egentlig 0
        
PORTD.0=0;	//ferdig med  tracke...
while (PINE.3 == 1);	//trykke p SW1 for  overfre til PC
PORTD.0=1;


ACTIVATE_FLASH;
spi(READ);
spi(0x00);
spi(0x00);
spi(0x00);
while (start_adresse > 0)
	{
	data=spi(0x00);
	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
        UDR1=data;
        start_adresse--;
	}	
DEACTIVATE_FLASH;
   
PORTD.0=0;


}