/************************************************************************** 
Name: 		nmea.c
Comments:	NMEA functions
**************************************************************************/  

#include "display.h"
#include "nmea.h"

//Put navigation data on display
void display_nmea(void)
{

//Indicates which nmea sentence we recievied according to def's in nmea.h, just for testing.
//Write(nmeaID, 6, 15); 

Write('L', 1, 0); Write('A', 1, 1); Write('T', 1, 2); Write(' ', 1, 3);
Write(' ', 1, 4);
Write('L', 2, 0); Write('O', 2, 1); Write('N', 2, 2); Write(' ', 2, 3); 

//only put position data (LAT/LON) on the display if we recieve a valid NMEA msg
if (valid_nmea == 1)
        {
       //Display: LAT <latitude><N/S>
        Write(tracking_pkt_buf[0], 1, 5);
        Write(tracking_pkt_buf[1], 1, 6);
        Write('d', 1, 7);                  //degree sign
        Write(tracking_pkt_buf[2], 1, 8);
        Write(tracking_pkt_buf[3], 1, 9);
        Write(tracking_pkt_buf[4], 1, 10);
        Write(tracking_pkt_buf[5], 1, 11);
        Write(tracking_pkt_buf[6], 1, 12);
        Write(tracking_pkt_buf[7], 1, 13);
        Write(tracking_pkt_buf[8], 1, 14);   
        Write(tracking_pkt_buf[9], 1, 15); //N or S
        
        //Display: LON <longitude><E/W>
        if(tracking_pkt_buf[11] != '0')	//if it is a 0, don't write it, looks better on the display.
        	{
        	Write(tracking_pkt_buf[11], 2, 4);
        	}
        else
        	{
        	Write(' ', 2, 4);
        	}
        Write(tracking_pkt_buf[12], 2, 5);
        Write(tracking_pkt_buf[13], 2, 6);
        Write('d', 2, 7);                  //degree sign
        Write(tracking_pkt_buf[14], 2, 8);
        Write(tracking_pkt_buf[15], 2, 9);
        Write(tracking_pkt_buf[16], 2, 10);
        Write(tracking_pkt_buf[17], 2, 11);
        Write(tracking_pkt_buf[18], 2, 12);
        Write(tracking_pkt_buf[19], 2, 13);
        Write(tracking_pkt_buf[20], 2, 14);  
        Write(tracking_pkt_buf[21], 2, 15); //E or W
      
        }
        
}  



//Parse nmea messages GLL and RMC
void nmea_parse(unsigned char nmea_msg_type)
{
 /*
//Parse GLL message. Find LAT, LON, UTC. Parsing GLL msg is mainly used under SW development.
//(Not really necessary.)
if (nmea_msg_type == GLL)
	{
	i = 0;
	index1 = 6;
	if (nmea_data[index1] == ',')    //sjekk for komma, hvis komma, ugyldig melding
        	{
        	Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
        	valid_nmea = 0;
        	return;
        	}
	
	//find LAT
	while (nmea_data[index1] != ',')
		{
		LAT[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}  
    		
    	//find LAT N or S
    	while (nmea_data[index1] != ',')
		{
		LAT[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		
    	    		
	//Find LON
	i=0;
    	while (nmea_data[index1] != ',')
		{
		LON[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		} 
    		   		
	//Find LON E or W
	while (nmea_data[index1] != ',')
		{
		LON[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		
    	    		
	//Find UTC
	i=0;
    	while (nmea_data[index1] != ',')
		{
		UTC[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		

    	//check for valid GLL dataset
    	if (nmea_data[index1] == 'A')	
    		{
    		Write('G',0,13); Write('P',0,14); Write('S',0,15);
    		valid_nmea = 1;
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		}
    	}	  	 
            */
//Parse RMC message; Find LAT, LON, UTC, DATE (SPEED and COURSE)
if (nmea_msg_type == RMC)
	{
	i = 0;
	index1 = 6;
	if (nmea_data[index1] == ',')      //sjekk for komma, hvis komma, ugyldig melding
		{
		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
		valid_nmea = 0;
		return;
		}
		
	//Find UTC
    	while (nmea_data[index1] != ',')           // endre til kun  steppe et stepp fra komma... if()
		{
		UTC[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		
    		
    	//check for valid RMC dataset
    	if (nmea_data[index1] == 'A')	
    		{
    		Write('G',0,13); Write('P',0,14); Write('S',0,15);
    		valid_nmea = 1;
    		index1++;
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0; 
    		index1++;
    		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		                              

	//Find LAT
	i=0;
    	while (nmea_data[index1] != ',')
		{
		LAT[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}
    		    		
	//Find LAT E or W
	while (nmea_data[index1] != ',')
		{
		LAT[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		
    		
	//Find LON
	i=0;
    	while (nmea_data[index1] != ',')
		{
		LON[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}
    		    		
	//Find LON E or W
	while (nmea_data[index1] != ',')
		{
		LON[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		
    		
	//Find SPEED         
	i = 0;
	while (nmea_data[index1] != ',')
		{
		SPEED[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		    		
   		
	//Find COARSE
	i = 0;
	while (nmea_data[index1] != ',')
		{
		COURSE[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		   		
                
	//Find DATE
	i = 0;
	while (nmea_data[index1] != ',')
		{
		DATE[i] = nmea_data[index1];
		index1++;
		i++;
		}
    	if(nmea_data[index1] == ',')
    		{
    		index1++;	//Jump over ','
    		}
    	else
    		{
    		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
    		valid_nmea = 0;
    		return;
    		}    		    
   	
	}     
	
	  
	  
//Arrange the data from the NMEA-strings:
//LAT,LON,UTC,DATE;
tracking_pkt_buf[0] = LAT[0];
tracking_pkt_buf[1] = LAT[1];
tracking_pkt_buf[2] = LAT[2];
tracking_pkt_buf[3] = LAT[3];
tracking_pkt_buf[4] = LAT[4];
tracking_pkt_buf[5] = LAT[5];
tracking_pkt_buf[6] = LAT[6];
tracking_pkt_buf[7] = LAT[7];
tracking_pkt_buf[8] = LAT[8];     
tracking_pkt_buf[9] = LAT[9];     //N or S
tracking_pkt_buf[10] = ',';
tracking_pkt_buf[11] = LON[0];
tracking_pkt_buf[12] = LON[1];
tracking_pkt_buf[13] = LON[2];
tracking_pkt_buf[14] = LON[3];
tracking_pkt_buf[15] = LON[4];
tracking_pkt_buf[16] = LON[5];
tracking_pkt_buf[17] = LON[6];
tracking_pkt_buf[18] = LON[7];
tracking_pkt_buf[19] = LON[8];
tracking_pkt_buf[20] = LON[9];    
tracking_pkt_buf[21] = LON[10];    //E or W
tracking_pkt_buf[22] = ',';
tracking_pkt_buf[23] = UTC[0];
tracking_pkt_buf[24] = UTC[1];
tracking_pkt_buf[25] = UTC[2];
tracking_pkt_buf[26] = UTC[3];
tracking_pkt_buf[27] = UTC[4];
tracking_pkt_buf[28] = UTC[5];
tracking_pkt_buf[29] = ',';
tracking_pkt_buf[30] = DATE[0];
tracking_pkt_buf[31] = DATE[1];
tracking_pkt_buf[32] = DATE[2];
tracking_pkt_buf[33] = DATE[3];
tracking_pkt_buf[34] = DATE[4];
tracking_pkt_buf[35] = DATE[5];
tracking_pkt_buf[36] = ';';
tracking_pkt_buf[37] = 0xD;	//ASCII CR
tracking_pkt_buf[38] = 0xA;	//ASCII NL
}
    		
  

 
//Find out what type of NMEA msg
char nmea_type(char id1, char id2, char id3)
{
char msg_type;
if ((id1 == 'R') && (id2 == 'M') && (id3 == 'C'))
	{
	msg_type = RMC;
	}
else if ((id1 == 'G') && (id2 == 'G') && (id3 == 'A'))
	{
	msg_type = GGA;
	}
else if ((id1 == 'G') && (id2 == 'S') && (id3 == 'A'))
	{
	msg_type = GSA;
	}
else if ((id1 == 'G') && (id2 == 'S') && (id3 == 'V'))
	{
	msg_type = GSV;
	}
else if ((id1 == 'G') && (id2 == 'L') && (id3 == 'L'))
	{
	msg_type = GLL;
	}
else
	{
	msg_type = '0';
	} 
return msg_type;
}   	         
 
//Check for new tracking point (Check if LAT and LON have changed)
char check_new_track(void)
{
unsigned char i=0;
unsigned char new_nmea_msg=0;
UCSR0B.7=0;   //disable RXC0 interrupt, we don't want any new data while checking
if (valid_nmea == 1) //for safety..
        {
        //Returns 0 if 20 first bytes of tracking_pkt_buf == tracking_pkt, i.e. LAT & LON
        new_nmea_msg = memcmp(tracking_pkt_buf, tracking_pkt,22); 
        if (new_nmea_msg != 0)
        	{
        	for (i=0; i < tracking_index; i++)
        		{
        		tracking_pkt[i] = tracking_pkt_buf[i];
        		}
        	}
        }
UCSR0B.7=1;	//enable RXC0 interrupt
return new_nmea_msg; 
}

	
