;CodeVisionAVR C Compiler V1.23.7 Standard
;(C) Copyright 1998-2002 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega128L
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Speed
;(s)printf features  : int, width
;Internal SRAM size  : 4096
;External SRAM size  : 0
;Data Stack size     : 1024
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C
	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.23.7 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2002 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Kalibrering av treghetsmodul
;      10 Version : 1.0
;      11 Date    : 16.03.2006
;      12 Author  : License 61, Lawicel HB          
;      13 Company : Klubbgatan 3, Tyringe, Sweden   
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega128L
;      18 Program type        : Application
;      19 Clock frequency     : 8,000000 MHz
;      20 Memory model        : Small
;      21 Internal SRAM size  : 4096
;      22 External SRAM size  : 0
;      23 Data Stack size     : 1024
;      24 *********************************************/
;      25 
;      26 #include <mega128.h>
;      27 #include <spi.h>
;      28 #include <stdio.h>
;      29 #include <ctype.h>
;      30 #include "delay.h"
;      31 #include "display.h"
;      32 #include "imu.h"
;      33 #include "filter.h"
;      34 #include "main.h"
;      35 #include "isr.h"
;      36 #include "flash.h"
;      37 
;      38  
;      39 // SW I2C Bus functions
;      40 #asm
;      41    .equ __i2c_port=0x18
   .equ __i2c_port=0x18
;      42    .equ __sda_bit=4
   .equ __sda_bit=4
;      43    .equ __scl_bit=5
   .equ __scl_bit=5
;      44 #endasm

;      45 #include <i2c.h>
;      46   
;      47 
;      48 //------Globale variables------
;      49 volatile unsigned int volt=0;
_volt:
	.BYTE 0x2
;      50 volatile unsigned char timer1_isr = 0;
_timer1_isr:
	.BYTE 0x1
;      51 extern volatile unsigned char rec_matlab;
;      52 //IMU related variables
;      53 unsigned int kompass_retning = 0;
;      54 unsigned char i2c_ack = 0;
;      55 unsigned char i2c_klar = 0;
;      56 unsigned int gyro_z = 0;
;      57 unsigned int gyro_z_h[gyro_measurements];
_gyro_z_h:
	.BYTE 0x2
;      58 unsigned int gyro_z_l[gyro_measurements];
_gyro_z_l:
	.BYTE 0x2
;      59 unsigned int gyro_Z_H_akse = 0;
;      60 unsigned int gyro_Z_L_akse = 0;
;      61 unsigned int gyro_y = 0;
_gyro_y:
	.BYTE 0x2
;      62 unsigned int gyro_y_h[gyro_measurements];
_gyro_y_h:
	.BYTE 0x2
;      63 unsigned int gyro_y_l[gyro_measurements];
_gyro_y_l:
	.BYTE 0x2
;      64 unsigned int gyro_Y_H_akse = 0;
_gyro_Y_H_akse:
	.BYTE 0x2
;      65 unsigned int gyro_Y_L_akse = 0;
_gyro_Y_L_akse:
	.BYTE 0x2
;      66 unsigned int gyro_x = 0; 
_gyro_x:
	.BYTE 0x2
;      67 unsigned int gyro_x_h[gyro_measurements];
_gyro_x_h:
	.BYTE 0x2
;      68 unsigned int gyro_x_l[gyro_measurements];
_gyro_x_l:
	.BYTE 0x2
;      69 unsigned int gyro_X_H_akse = 0;
_gyro_X_H_akse:
	.BYTE 0x2
;      70 unsigned int gyro_X_L_akse = 0;
_gyro_X_L_akse:
	.BYTE 0x2
;      71 unsigned int gyro_temp_x_h = 0;
_gyro_temp_x_h:
	.BYTE 0x2
;      72 unsigned int gyro_temp_x_l = 0;
_gyro_temp_x_l:
	.BYTE 0x2
;      73 unsigned int gyro_temp_y_h = 0;
_gyro_temp_y_h:
	.BYTE 0x2
;      74 unsigned int gyro_temp_y_l = 0;
_gyro_temp_y_l:
	.BYTE 0x2
;      75 unsigned int gyro_temp_z_h = 0;
_gyro_temp_z_h:
	.BYTE 0x2
;      76 unsigned int gyro_temp_z_l = 0;
_gyro_temp_z_l:
	.BYTE 0x2
;      77 unsigned int acc_dum_h_x = 0;
_acc_dum_h_x:
	.BYTE 0x2
;      78 unsigned int acc_dum_l_x = 0;
_acc_dum_l_x:
	.BYTE 0x2
;      79 unsigned int acc_dum_h_y = 0;
_acc_dum_h_y:
	.BYTE 0x2
;      80 unsigned int acc_dum_l_y = 0; 
_acc_dum_l_y:
	.BYTE 0x2
;      81 unsigned int acc_dum_h_z = 0;
_acc_dum_h_z:
	.BYTE 0x2
;      82 unsigned int acc_dum_l_z = 0;
_acc_dum_l_z:
	.BYTE 0x2
;      83 unsigned char imu_data[20];
_imu_data:
	.BYTE 0x14
;      84 volatile unsigned char imu_data_teller = 0;	
_imu_data_teller:
	.BYTE 0x1
;      85 volatile unsigned int samples_teller = 0;
_samples_teller:
	.BYTE 0x2
;      86 volatile bit start_of_transmission = 1;
;      87 volatile unsigned char start_of_transmission_counter = 0;
_start_of_transmission_counter:
	.BYTE 0x1
;      88 
;      89 //Moving average						
;      90 unsigned short int gyro_vekt_1[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_1:
	.BYTE 0x14
;      91 unsigned short int gyro_vekt_2[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_2:
	.BYTE 0x14
;      92 unsigned short int gyro_vekt_3[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_3:
	.BYTE 0x14
;      93 unsigned short int gyro_vekt_4[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_4:
	.BYTE 0x14
;      94 unsigned short int gyro_vekt_5[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_5:
	.BYTE 0x14
;      95 unsigned short int gyro_vekt_6[10] = {0,0,0,0,0,0,0,0,0,0};
_gyro_vekt_6:
	.BYTE 0x14
;      96 //RTC
;      97 unsigned char SECOND = 0;
;      98 unsigned char MINUTE = 0;
_MINUTE:
	.BYTE 0x1
;      99 unsigned char HOUR = 0;
_HOUR:
	.BYTE 0x1
;     100 unsigned char DAY = 0;
_DAY:
	.BYTE 0x1
;     101 unsigned char MONTH = 0;
_MONTH:
	.BYTE 0x1
;     102 unsigned int YEAR = 0;
_YEAR:
	.BYTE 0x2
;     103 char MonthLength[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
_MonthLength:
	.BYTE 0xD
;     104 volatile unsigned int ms = 0;
_ms:
	.BYTE 0x2
;     105 /*
;     106 //FLASH
;     107 unsigned char flash_test[12] = {'A','B','C','D','E','F','G','H','I','J','K','L'};
;     108 unsigned char i = 0;
;     109 unsigned int flash_adresse = 0;
;     110 unsigned int flash_start_adresse = 0;
;     111 unsigned char flash_delete = 0;
;     112 unsigned char flash_transmit = 0;
;     113 unsigned char flash_lagre = 0;
;     114 unsigned char pause = 0;
;     115   */
;     116 
;     117 void main(void)
;     118 {

	.CSEG
_main:
;     119 #asm("cli")
	cli
;     120 
;     121 // Input/Output Ports initialization
;     122 // Port A initialization
;     123 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     124 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
;     125 PORTA=0x00;
	CLR  R30
	OUT  0x1B,R30
;     126 DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     127 
;     128 // Port B initialization
;     129 // Func0=Out Func1=Out Func2=Out Func3=In Func4=In Func5=In Func6=Out Func7=Out 
;     130 // State0=0 State1=0 State2=0 State3=T State4=T State5=T State6=0 State7=0 
;     131 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;     132 DDRB=0xC7;
	LDI  R30,LOW(199)
	OUT  0x17,R30
;     133 
;     134 // Port C initialization
;     135 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     136 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
;     137 PORTC=0x00;
	CLR  R30
	OUT  0x15,R30
;     138 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     139 
;     140 // Port D initialization
;     141 // Func0=In Func1=In Func2=In Func3=Out Func4=Out Func5=Out Func6=Out Func7=In 
;     142 // State0=T State1=T State2=T State3=0 State4=0 State5=0 State6=0 State7=T 
;     143 PORTD=0x00;
	CLR  R30
	OUT  0x12,R30
;     144 DDRD=0x78;
	LDI  R30,LOW(120)
	OUT  0x11,R30
;     145 
;     146 // Port E initialization
;     147 // Func0=In Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     148 // State0=T State1=0 State2=T State3=T State4=P State5=P State6=P State7=P 
;     149 PORTE=0xF0;
	LDI  R30,LOW(240)
	OUT  0x3,R30
;     150 DDRE=0x02;
	LDI  R30,LOW(2)
	OUT  0x2,R30
;     151 
;     152 // Port F initialization
;     153 // Func0=Out Func1=In Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=In 
;     154 // State0=0 State1=T State2=0 State3=1 State4=1 State5=0 State6=0 State7=T 
;     155 PORTF=0x18;
	LDI  R30,LOW(24)
	STS  0x62,R30
;     156 DDRF=0x7D;
	LDI  R30,LOW(125)
	STS  0x61,R30
;     157 
;     158 // Port G initialization
;     159 // Func0=Out Func1=Out Func2=Out Func3=In Func4=In 
;     160 // State0=0 State1=0 State2=1 State3=T State4=T 
;     161 PORTG=0x04;
	LDI  R30,LOW(4)
	STS  0x65,R30
;     162 DDRG=0x06;     
	LDI  R30,LOW(6)
	STS  0x64,R30
;     163 
;     164 // Timer/Counter 0 initialization         
;     165 // Clock source: System Clock
;     166 // Clock value: 125,000 kHz
;     167 // Mode: CTC top=OCR0
;     168 // OC0 output: Disconnected
;     169 ASSR=0x00;
	CLR  R30
	OUT  0x30,R30
;     170 TCCR0=0x0C;    
	LDI  R30,LOW(12)
	OUT  0x33,R30
;     171 TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;     172 OCR0=0x7D;
	LDI  R30,LOW(125)
	OUT  0x31,R30
;     173 
;     174 // Timer/Counter 1 initialization
;     175 // Clock source: System Clock
;     176 // Clock value: 125,000 kHz
;     177 // Mode: CTC top=OCR1A
;     178 // OC1A output: Discon.
;     179 // OC1B output: Discon.
;     180 // OC1C output: Discon.
;     181 // Noise Canceler: Off
;     182 // Input Capture on Falling Edge
;     183 TCCR1A=0x00;
	CLR  R30
	OUT  0x2F,R30
;     184 TCCR1B=0x0B;
	LDI  R30,LOW(11)
	OUT  0x2E,R30
;     185 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     186 TCNT1L=0x00;
	OUT  0x2C,R30
;     187 //OCR1AH & OCR1AL:
;     188 //0x3E8 = 1000 (125Hz), 0x4E2 = 1250 (100Hz), 0x30D4 = 12500(10Hz), 0x2CA = 714 (175Hz)
;     189 //0x9C4 = 2500 (50Hz), 0x271 = 625 (200Hz), 0x342 = 833 (150Hz), 0x37D = 893 (140Hz)
;     190 //0x470 = 1136 (110), 0x61B = 1563 (80), 0x683 = 1667 (75)
;     191 OCR1AH=0x04;    
	LDI  R30,LOW(4)
	OUT  0x2B,R30
;     192 OCR1AL=0xE2;
	LDI  R30,LOW(226)
	OUT  0x2A,R30
;     193 OCR1BH=0x00;
	CLR  R30
	OUT  0x29,R30
;     194 OCR1BL=0x00;
	OUT  0x28,R30
;     195 OCR1CH=0x00;
	STS  0x79,R30
;     196 OCR1CL=0x00;
	STS  0x78,R30
;     197 
;     198 // Timer/Counter 2 initialization
;     199 // Clock source: System Clock
;     200 // Clock value: Timer 2 Stopped
;     201 // Mode: Normal top=FFh
;     202 // OC2 output: Disconnected
;     203 TCCR2=0x00;
	OUT  0x25,R30
;     204 TCNT2=0x00;
	OUT  0x24,R30
;     205 OCR2=0x00;
	OUT  0x23,R30
;     206 
;     207 // Timer/Counter 3 initialization
;     208 // Clock source: System Clock
;     209 // Clock value: Timer 3 Stopped
;     210 // Mode: Normal top=FFFFh
;     211 // OC3A output: Discon.
;     212 // OC3B output: Discon.
;     213 // OC3C output: Discon.
;     214 TCCR3A=0x00;
	STS  0x8B,R30
;     215 TCCR3B=0x00;
	STS  0x8A,R30
;     216 TCNT3H=0x00;
	STS  0x89,R30
;     217 TCNT3L=0x00;
	STS  0x88,R30
;     218 OCR3AH=0x00;
	STS  0x87,R30
;     219 OCR3AL=0x00;
	STS  0x86,R30
;     220 OCR3BH=0x00;
	STS  0x85,R30
;     221 OCR3BL=0x00;
	STS  0x84,R30
;     222 OCR3CH=0x00;
	STS  0x83,R30
;     223 OCR3CL=0x00;
	STS  0x82,R30
;     224 
;     225 // External Interrupt(s) initialization
;     226 // INT0: Off
;     227 // INT1: Off
;     228 // INT2: Off
;     229 // INT3: Off
;     230 // INT4: On
;     231 // INT4 Mode: Falling Edge
;     232 // INT5: On
;     233 // INT5 Mode: Falling Edge
;     234 // INT6: On
;     235 // INT6 Mode: Falling Edge
;     236 // INT7: On
;     237 // INT7 Mode: Falling Edge
;     238 EICRA=0x00;
	STS  0x6A,R30
;     239 EICRB=0xAA;
	LDI  R30,LOW(170)
	OUT  0x3A,R30
;     240 EIMSK=0xF0;
	LDI  R30,LOW(240)
	OUT  0x39,R30
;     241 EIFR=0xF0;
	OUT  0x38,R30
;     242 
;     243 // Timer(s)/Counter(s) Interrupt(s) initialization
;     244 TIMSK=0x12;
	LDI  R30,LOW(18)
	OUT  0x37,R30
;     245 //TIMSK:	
;     246 //0x12: Bde timer0 og timer1 outputcomp.ISR.	
;     247 //0x10: Kun timer1 outputcomp.ISR.
;     248 //0x02: Kun timer0 outputcomp.ISR.
;     249 ETIMSK=0x00;
	CLR  R30
	STS  0x7D,R30
;     250              /*
;     251 // USART0 initialization
;     252 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     253 // USART0 Receiver: On
;     254 // USART0 Transmitter: Off
;     255 // USART0 Mode: Asynchronous
;     256 // USART0 Baud rate: 4800
;     257 UCSR0A=0x00;
;     258 UCSR0B=0x98;	//0x98	//0x90
;     259 UCSR0C=0x06;	//0x06
;     260 UBRR0H=0x00;
;     261 UBRR0L=0x0C;	//0x0C	//0x67
;     262            */   
;     263 // USART1 initialization	 UTEN ISR
;     264 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     265 // USART1 Receiver: On
;     266 // USART1 Transmitter: On
;     267 // USART1 Mode: Asynchronous
;     268 // USART1 Baud rate: 38400
;     269 UCSR1A=0x00;
	STS  0x9B,R30
;     270 UCSR1B=0x98;
	LDI  R30,LOW(152)
	STS  0x9A,R30
;     271 UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  0x9D,R30
;     272 UBRR1H=0x00;
	CLR  R30
	STS  0x98,R30
;     273 UBRR1L=0x0C;
	LDI  R30,LOW(12)
	STS  0x99,R30
;     274             
;     275 
;     276 // Analog Comparator initialization
;     277 // Analog Comparator: Off
;     278 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     279 // Analog Comparator Output: Off
;     280 ACSR=0x00; //0x80
	CLR  R30
	OUT  0x8,R30
;     281 SFIOR=0x00;
	OUT  0x20,R30
;     282 
;     283 // ADC initialization
;     284 // ADC Clock frequency: 125,000 kHz
;     285 // ADC Voltage Reference: Int., cap. on AREF
;     286 // ADC High Speed Mode: Off
;     287 //ADMUX=0xE7;
;     288 //ADCSRA=0xEF; 
;     289 //SFIOR&=0xEF; 
;     290 
;     291 ADMUX=0x00;
	OUT  0x7,R30
;     292 ADCSRA=0x00; 
	OUT  0x6,R30
;     293 SFIOR&=0xEF; 
	IN   R30,0x20
	ANDI R30,0xEF
	OUT  0x20,R30
;     294 
;     295 // SPI initialization
;     296 // SPI Type: Master
;     297 // SPI Clock Rate: 2*2000,000 kHz
;     298 // SPI Clock Phase: Cycle Half
;     299 // SPI Clock Polarity: Low
;     300 // SPI Data Order: MSB First
;     301 SPCR=0x54;	
	LDI  R30,LOW(84)
	OUT  0xD,R30
;     302 //Endret klokkepolaritet (0x50)   58: CPOL=1,CPHA=0
;     303 //FLASH works with SPCR=0x50 and SPCR=0x5C
;     304 //Accelerometer works with SPCR=0x5C
;     305 //ADC works with SPCR=0x54
;     306 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
;     307 
;     308 //PORTF is in the extended I/O space.
;     309 //Cannot use the PORTX.N construct for ports F or G on the ATmega128
;     310 PORTF = 0b00011101;  //CS on the voltage regulators, ADC og accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;     311 
;     312 // I2C Bus initialization
;     313 i2c_init();
	CALL _i2c_init
;     314 
;     315 //Wait for external x-tal to stabilize
;     316 delay_ms(1000);     
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     317 init_display();
	RCALL _init_display
;     318 clear_display();
	RCALL _clear_display
;     319 
;     320 cs_flash = 1; //Active low
	SBI  0x12,4
;     321 charge_enable = 1; //Active low                             
	SBI  0x18,7
;     322 //WARNING: Reading the HMC6352 does not work togther with the chargeIC
;     323 //(The I2C lines is the same as STATX lines on the chargeIC)
;     324 
;     325 //Init kompass, ADC and accelerometer
;     326 init_compass();
	CALL _init_compass
;     327 init_ADC();  
	CALL _init_ADC
;     328 init_aks();
	CALL _init_aks
;     329 
;     330 // Global enable interrupts
;     331 #asm("sei")
	sei
;     332 
;     333 //Main loop              
;     334 while (1)
_0x3A:
;     335         {
;     336         	/*            
;     337 	#asm("cli")
;     338         kompass_retning = read_compass();
;     339         lcdprint(kompass_retning,5,0);
;     340         #asm("sei")
;     341                   */          
;     342         //Bare en sjekk som sier i fra
;     343         //ikke ndvendig
;     344         if (samples_teller > 65000)
	LDS  R26,_samples_teller
	LDS  R27,_samples_teller+1
	LDI  R30,LOW(65000)
	LDI  R31,HIGH(65000)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x3D
;     345         	{
;     346         	Write('X',1,15);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     347         	samples_teller = 0;
	CLR  R30
	STS  _samples_teller,R30
	STS  _samples_teller+1,R30
;     348         	}
;     349         
;     350         //When a new sample has occured
;     351         if(timer1_isr == 1)
_0x3D:
	LDS  R26,_timer1_isr
	CPI  R26,LOW(0x1)
	BRNE _0x3E
;     352         	{
;     353         	//Moving average filtering for the gyros, if no moving average filter is
;     354         	//needed, remove the line below
;     355                 //moving_average_gyro();                 
;     356                 
;     357                 //Start transmitting to matlab
;     358                 if ((rec_matlab == start_send) )
	LDS  R26,_rec_matlab
	CPI  R26,LOW(0x37)
	BRNE _0x3F
;     359                 	{
;     360                 	Write('M',0,14); Write('L',0,15); 
	LDI  R30,LOW(77)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(76)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     361                 	send_matlab();  
	RCALL _send_matlab
;     362                 	}
;     363                 	
;     364                 //Stop transmitting to matlab.
;     365                 if ((rec_matlab == stop_send) )
_0x3F:
	LDS  R26,_rec_matlab
	CPI  R26,LOW(0x38)
	BRNE _0x40
;     366                         {
;     367                         Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(32)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     368                         } 
;     369 
;     370         	timer1_isr = 0;
_0x40:
	CLR  R30
	STS  _timer1_isr,R30
;     371         	}
;     372         //If Matlab is requesting data, do not update the LCD with gyro data
;     373 	if(rec_matlab != start_send)
_0x3E:
	LDS  R26,_rec_matlab
	CPI  R26,LOW(0x37)
	BRNE PC+3
	JMP _0x41
;     374 		{     
;     375                 gyro_x = (gyro_X_H_akse*256) + gyro_X_L_akse;
	LDS  R30,_gyro_X_H_akse
	LDS  R31,_gyro_X_H_akse+1
	MOV  R31,R30
	CLR  R30
	LDS  R26,_gyro_X_L_akse
	LDS  R27,_gyro_X_L_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_x,R30
	STS  _gyro_x+1,R31
;     376                 gyro_y = (gyro_Y_H_akse*256) + gyro_Y_L_akse;
	LDS  R30,_gyro_Y_H_akse
	LDS  R31,_gyro_Y_H_akse+1
	MOV  R31,R30
	CLR  R30
	LDS  R26,_gyro_Y_L_akse
	LDS  R27,_gyro_Y_L_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_y,R30
	STS  _gyro_y+1,R31
;     377                 gyro_z = (gyro_Z_H_akse*256) + gyro_Z_L_akse; 
	__GETW1R 10,11
	MOV  R31,R30
	CLR  R30
	ADD  R30,R12
	ADC  R31,R13
	__PUTW1R 8,9
;     378                 lcdprint(gyro_x,0,0);
	LDS  R30,_gyro_x
	LDS  R31,_gyro_x+1
	ST   -Y,R31
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	ST   -Y,R30
	RCALL _lcdprint
;     379                 Write('G',0,5); Write('Y',0,6); Write('R',0,7); Write('O',0,8); Write('X',0,9);
	LDI  R30,LOW(71)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(89)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(82)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(79)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(88)
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     380                 lcdprint(gyro_y,1,0);      
	LDS  R30,_gyro_y
	LDS  R31,_gyro_y+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	RCALL _lcdprint
;     381                 Write('G',1,5); Write('Y',1,6); Write('R',1,7); Write('O',1,8); Write('Y',1,9);      
	LDI  R30,LOW(71)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(79)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     382                 lcdprint(gyro_z,2,0);
	ST   -Y,R9
	ST   -Y,R8
	LDI  R30,LOW(2)
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	RCALL _lcdprint
;     383                 Write('G',2,5); Write('Y',2,6); Write('R',2,7); Write('O',2,8); Write('Z',2,9);
	LDI  R30,LOW(71)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(79)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(90)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;     384 
;     385                 }    
;     386              
;     387         }
_0x41:
	RJMP _0x3A
;     388 }//Main loop end
_0x42:
	RJMP _0x42
;     389 
;     390 //Displays the voltage of the battery
;     391 //(Must enable ADC ISR with correct Vref)
;     392 void check_voltage(void)
;     393 {
;     394 unsigned int tier;
;     395 unsigned int hundre;
;     396 unsigned int ener;
;     397 
;     398 Write('V',0,16);
;	tier -> R16,R17
;	hundre -> R18,R19
;	ener -> R20,R21
;     399 
;     400 if (volt<10)
;     401 	{
;     402 	Write('0',0,12);
;     403 	Write(',',0,13);
;     404 	Write('0',0,14);
;     405 	Write(volt+48,0,15);
;     406 	}
;     407 else if ((volt>=10)&&(volt<100))
;     408 	{
;     409 	Write('0',0,12);
;     410 	Write(',',0,13);
;     411 	tier=(volt/10);
;     412 	Write(tier+48,0,14);
;     413 	Write((volt-(tier*10))+48,0,15);
;     414 	}
;     415 else
;     416 	{
;     417 	hundre=(volt/100);
;     418 	Write(hundre+48,0,12);
;     419 	Write(',',0,13);
;     420 	tier=(volt-(hundre*100))/10;
;     421 	Write(tier+48,0,14);
;     422 	ener=volt-((hundre*100)+(tier*10));
;     423 	Write(ener+48,0,15);
;     424 	}    
;     425 }
;     426 
;     427 
;     428 void send_matlab(void)
;     429 {
_send_matlab:
;     430 unsigned char j = 0; //This is for tx by means of ISR
;     431                 
;     432 //Sort data for transmitting
;     433 imu_data[0] = acc_dum_h_x & 0xFF;
	ST   -Y,R16
;	j -> R16
	LDI  R16,0
	LDS  R30,_acc_dum_h_x
	LDS  R31,_acc_dum_h_x+1
	ANDI R31,HIGH(0xFF)
	STS  _imu_data,R30
;     434 imu_data[1] = acc_dum_l_x & 0xFF;
	LDS  R30,_acc_dum_l_x
	LDS  R31,_acc_dum_l_x+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,1
;     435 imu_data[2] = acc_dum_h_y & 0xFF;
	LDS  R30,_acc_dum_h_y
	LDS  R31,_acc_dum_h_y+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,2
;     436 imu_data[3] = acc_dum_l_y & 0xFF;
	LDS  R30,_acc_dum_l_y
	LDS  R31,_acc_dum_l_y+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,3
;     437 imu_data[4] = acc_dum_h_z & 0xFF;
	LDS  R30,_acc_dum_h_z
	LDS  R31,_acc_dum_h_z+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,4
;     438 imu_data[5] = acc_dum_l_z & 0xFF;
	LDS  R30,_acc_dum_l_z
	LDS  R31,_acc_dum_l_z+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,5
;     439 imu_data[6] = gyro_X_H_akse & 0xFF;
	LDS  R30,_gyro_X_H_akse
	LDS  R31,_gyro_X_H_akse+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,6
;     440 imu_data[7] = gyro_X_L_akse & 0xFF;
	LDS  R30,_gyro_X_L_akse
	LDS  R31,_gyro_X_L_akse+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,7
;     441 imu_data[8] = gyro_Y_H_akse & 0xFF;
	LDS  R30,_gyro_Y_H_akse
	LDS  R31,_gyro_Y_H_akse+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,8
;     442 imu_data[9] = gyro_Y_L_akse & 0xFF;
	LDS  R30,_gyro_Y_L_akse
	LDS  R31,_gyro_Y_L_akse+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,9
;     443 imu_data[10] = gyro_Z_H_akse & 0xFF;
	__GETW1R 10,11
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,10
;     444 imu_data[11] = gyro_Z_L_akse & 0xFF;
	__GETW1R 12,13
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,11
;     445 
;     446 imu_data[12] = gyro_temp_x_h & 0xFF;
	LDS  R30,_gyro_temp_x_h
	LDS  R31,_gyro_temp_x_h+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,12
;     447 imu_data[13] = gyro_temp_x_l & 0xFF;
	LDS  R30,_gyro_temp_x_l
	LDS  R31,_gyro_temp_x_l+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,13
;     448 imu_data[14] = gyro_temp_y_h & 0xFF;
	LDS  R30,_gyro_temp_y_h
	LDS  R31,_gyro_temp_y_h+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,14
;     449 imu_data[15] = gyro_temp_y_l & 0xFF;
	LDS  R30,_gyro_temp_y_l
	LDS  R31,_gyro_temp_y_l+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,15
;     450 imu_data[16] = gyro_temp_z_h & 0xFF;
	LDS  R30,_gyro_temp_z_h
	LDS  R31,_gyro_temp_z_h+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,16
;     451 imu_data[17] = gyro_temp_z_l & 0xFF;
	LDS  R30,_gyro_temp_z_l
	LDS  R31,_gyro_temp_z_l+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,17
;     452 
;     453 imu_data[18] = samples_teller >> 8;
	LDS  R30,_samples_teller
	LDS  R31,_samples_teller+1
	MOV  R30,R31
	CLR  R31
	__PUTB1MN _imu_data,18
;     454 imu_data[19] = samples_teller & 0xFF;
	LDS  R30,_samples_teller
	LDS  R31,_samples_teller+1
	ANDI R31,HIGH(0xFF)
	__PUTB1MN _imu_data,19
;     455                
;     456               /*
;     457 //Fiktive data for sjekking                
;     458 imu_data[0] = 0;
;     459 imu_data[1] = 1;
;     460 imu_data[2] = 2;
;     461 imu_data[3] = 3;
;     462 imu_data[4] = 4;
;     463 imu_data[5] = 5;
;     464 imu_data[6] = 6;
;     465 imu_data[7] = 7;
;     466 imu_data[8] = 8;
;     467 imu_data[9] = 9;
;     468 imu_data[10] = 10;
;     469 imu_data[11] = 11;
;     470 imu_data[12] = samples_teller >> 8;
;     471 imu_data[13] = samples_teller & 0xFF;
;     472                */ 
;     473 //Enable UDR1E isr 
;     474 //If tx by means of polling is wanted, remove this line               
;     475 UCSR1B = 0xB8;
	LDI  R30,LOW(184)
	STS  0x9A,R30
;     476        
;     477 /*
;     478 //UART1 tx by means of polling, if tx by means of ISR is wanted, remove this for-loop
;     479 for(j=0;j<12;j++)
;     480 	{
;     481 	while ((UCSR0A & DATA_REGISTER_EMPTY)==0);
;     482         	{
;     483         	UDR0=imu_data[j];
;     484         	}
;     485 	}
;     486 */
;     487 
;     488 }
	LD   R16,Y+
	RET
;     489 /************************************************************************** 
;     490 Name: 		display.c
;     491 Comments:	Display functions
;     492 **************************************************************************/
;     493 
;     494 #include <mega128.h>
;     495 #include <delay.h>
;     496 #include "display.h"
;     497 
;     498 
;     499 //Initialisation Display
;     500 void init_display()
;     501 {	
_init_display:
;     502 Reset=0;
	CBI  0x1B,0
;     503 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     504 Reset=1;
	SBI  0x1B,0
;     505 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     506 CS1=0; 
	CBI  0x1B,1
;     507 CS2=1;
	SBI  0x1B,2
;     508 C86=0;
	CBI  0x1B,3
;     509        
;     510 // Set display, start line
;     511 A0=0; 
	CBI  0x1B,4
;     512 RD=1; 
	SBI  0x1B,6
;     513 WR=0; 
	CBI  0x1B,5
;     514 Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;     515 WR=1;
	SBI  0x1B,5
;     516 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     517        
;     518 // Set Normal / Reverse Display
;     519 WR=0; 
	CBI  0x1B,5
;     520 Display_data=0xA6;
	LDI  R30,LOW(166)
	OUT  0x15,R30
;     521 WR=1;
	SBI  0x1B,5
;     522 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     523        
;     524 //Set all indicator
;     525 WR=0; 
	CBI  0x1B,5
;     526 Display_data=0xA4;
	LDI  R30,LOW(164)
	OUT  0x15,R30
;     527 WR=1;
	SBI  0x1B,5
;     528 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     529        
;     530 //Set duty select
;     531 WR=0; 
	CBI  0x1B,5
;     532 Display_data=0xA9;
	LDI  R30,LOW(169)
	OUT  0x15,R30
;     533 WR=1;
	SBI  0x1B,5
;     534 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     535                     
;     536 //Set ADC = 1
;     537 WR=0; 
	CBI  0x1B,5
;     538 Display_data=0xA1;
	LDI  R30,LOW(161)
	OUT  0x15,R30
;     539 WR=1;
	SBI  0x1B,5
;     540 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     541        
;     542 //Output Status
;     543 WR=0; 
	CBI  0x1B,5
;     544 Display_data=0xCC;
	LDI  R30,LOW(204)
	OUT  0x15,R30
;     545 WR=1;
	SBI  0x1B,5
;     546 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     547                     
;     548 //Set built in power supply
;     549 WR=0; 
	CBI  0x1B,5
;     550 Display_data=0x25;
	LDI  R30,LOW(37)
	OUT  0x15,R30
;     551 WR=1;
	SBI  0x1B,5
;     552 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     553        
;     554 //Set power on completion
;     555 WR=0; 
	CBI  0x1B,5
;     556 Display_data=0xED;
	LDI  R30,LOW(237)
	OUT  0x15,R30
;     557 WR=1;
	SBI  0x1B,5
;     558 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     559        
;     560 //Set electronic volume control
;     561 WR=0; 
	CBI  0x1B,5
;     562 Display_data=0x8F;
	LDI  R30,LOW(143)
	OUT  0x15,R30
;     563 WR=1;
	SBI  0x1B,5
;     564 delay_ms(10); 
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     565        
;     566 //Set Display ON
;     567 WR=0; 
	CBI  0x1B,5
;     568 Display_data=0xAF;
	LDI  R30,LOW(175)
	OUT  0x15,R30
;     569 WR=1;
	SBI  0x1B,5
;     570 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     571        
;     572 //Set page adress
;     573 WR=0; 
	CBI  0x1B,5
;     574 Display_data=0xB0;
	LDI  R30,LOW(176)
	OUT  0x15,R30
;     575 WR=1;
	SBI  0x1B,5
;     576 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     577         
;     578 //Set column adress high order 4-bits
;     579 WR=0; 
	CBI  0x1B,5
;     580 Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;     581 WR=1;
	SBI  0x1B,5
;     582 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     583        
;     584 //Set column adress low order 4-bits
;     585 WR=0; 
	CBI  0x1B,5
;     586 Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     587 WR=1;
	SBI  0x1B,5
;     588 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     589                  
;     590 /*//Read modify Write
;     591 RD=1; 
;     592 WR=0; 
;     593 Display_data=0xE0;
;     594 WR=1;
;     595 delay_ms(50);*/ 
;     596        
;     597        
;     598 /*//Display status          
;     599 A0=0;  
;     600 RD=0; 
;     601 WR=1; 
;     602 Display_data=0x00; 
;     603 WR=1;
;     604 delay_ms(50); 
;     605 DDRC=0x00; // Port C innport
;     606 delay_ms(50);*/
;     607 
;     608 } 
	RET
;     609                            
;     610 // Write to Display       
;     611 void Write(unsigned char letter, unsigned int page, unsigned int pos)
;     612 {         
_Write:
;     613 
;     614 if ((page>=0 && page<=8) && (pos>=0 && pos<=17))
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,0
	BRLO _0x54
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x55
_0x54:
	RJMP _0x56
_0x55:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,0
	BRLO _0x57
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x58
_0x57:
	RJMP _0x56
_0x58:
	RJMP _0x59
_0x56:
	RJMP _0x53
_0x59:
;     615 	{        
;     616 	unsigned int adr;
;     617 	unsigned int colum;
;     618 	unsigned int colum_h;
;     619 	unsigned int colum_l;
;     620 	
;     621 	adr=0xB0+page;
	SBIW R28,8
;	letter -> Y+12
;	page -> Y+10
;	pos -> Y+8
;	adr -> Y+6
;	colum -> Y+4
;	colum_h -> Y+2
;	colum_l -> Y+0
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-176)
	SBCI R31,HIGH(-176)
	STD  Y+6,R30
	STD  Y+6+1,R31
;     622 	
;     623 	//Set Page adress
;     624 	A0=0;  
	CBI  0x1B,4
;     625  	RD=1; 
	SBI  0x1B,6
;     626   	WR=0; 
	CBI  0x1B,5
;     627        	Display_data=adr;
	OUT  0x15,R30
;     628        	WR=1;  
	SBI  0x1B,5
;     629         
;     630         colum=pos*6; 
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL __MULW12U
	STD  Y+4,R30
	STD  Y+4+1,R31
;     631         colum_h= (char)(colum >> 4) ; // high 4-bits
	CALL __LSRW4
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
;     632         colum_l=colum & 0x0F;   // low 4-bits
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	ST   Y,R30
	STD  Y+1,R31
;     633         colum_h=colum_h + 0x12;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,18
	STD  Y+2,R30
	STD  Y+2+1,R31
;     634         
;     635    	//Set column adress high order 4-bits
;     636        	WR=0; 
	CBI  0x1B,5
;     637        	Display_data=colum_h;
	OUT  0x15,R30
;     638        	WR=1;
	SBI  0x1B,5
;     639        	
;     640        	//Set column adress low order 4-bits 
;     641        	WR=0; 
	CBI  0x1B,5
;     642        	Display_data=colum_l;
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x15,R30
;     643        	WR=1;  
	SBI  0x1B,5
;     644        	}
	ADIW R28,8
;     645           
;     646 else
	RJMP _0x5A
_0x53:
;     647       	{
;     648       	//Illegal page adress or position. Page must be equal or bigger than 0 and less than 8.
;     649       	//Position must be equal or bigger than 0 and less than 16. Each letter is 6 pixels including
;     650       	//space, the display is 100 pixels wide, which gives 16 hole letters a line/page.
;     651        	return;  
	RJMP _0x126
;     652       	} 
_0x5A:
;     653       
;     654 //Display data write
;     655 A0=1;  
	SBI  0x1B,4
;     656 RD=1; 
	SBI  0x1B,6
;     657 WR=0;
	CBI  0x1B,5
;     658        
;     659 switch (letter)
	LDD  R30,Y+4
;     660 	{     
;     661  	case ' ':
	CPI  R30,LOW(0x20)
	BRNE _0x5E
;     662   	WR=0;
	CBI  0x1B,5
;     663    	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     664     	WR=1;
	SBI  0x1B,5
;     665      	WR=0;
	CBI  0x1B,5
;     666       	Display_data=0x00;
	OUT  0x15,R30
;     667        	WR=1;
	SBI  0x1B,5
;     668         WR=0;
	CBI  0x1B,5
;     669         Display_data=0x00;
	OUT  0x15,R30
;     670         WR=1;
	SBI  0x1B,5
;     671         WR=0;
	CBI  0x1B,5
;     672         Display_data=0x00;
	OUT  0x15,R30
;     673         WR=1;
	SBI  0x1B,5
;     674         WR=0;
	CBI  0x1B,5
;     675         Display_data=0x00;
	OUT  0x15,R30
;     676         WR=1; 
	SBI  0x1B,5
;     677         WR=0;
	CBI  0x1B,5
;     678         Display_data=0x00;
	OUT  0x15,R30
;     679         WR=1; 
	SBI  0x1B,5
;     680         return; 
	RJMP _0x126
;     681        
;     682        	case '0':
_0x5E:
	CPI  R30,LOW(0x30)
	BRNE _0x5F
;     683        	WR=0;
	CBI  0x1B,5
;     684        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;     685        	WR=1;
	SBI  0x1B,5
;     686        	WR=0;
	CBI  0x1B,5
;     687        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     688        	WR=1;
	SBI  0x1B,5
;     689        	WR=0;
	CBI  0x1B,5
;     690        	Display_data=0x41;
	OUT  0x15,R30
;     691        	WR=1;
	SBI  0x1B,5
;     692        	WR=0;
	CBI  0x1B,5
;     693        	Display_data=0x41;
	OUT  0x15,R30
;     694        	WR=1;
	SBI  0x1B,5
;     695        	WR=0;
	CBI  0x1B,5
;     696        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;     697        	WR=1;
	SBI  0x1B,5
;     698        	WR=0;
	CBI  0x1B,5
;     699        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     700        	WR=1;
	SBI  0x1B,5
;     701 	return;	   
	RJMP _0x126
;     702        
;     703        	case '1':
_0x5F:
	CPI  R30,LOW(0x31)
	BRNE _0x60
;     704        	WR=0;
	CBI  0x1B,5
;     705        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     706        	WR=1;
	SBI  0x1B,5
;     707        	WR=0;
	CBI  0x1B,5
;     708        	Display_data=0x00;
	OUT  0x15,R30
;     709        	WR=1;
	SBI  0x1B,5
;     710        	WR=0;
	CBI  0x1B,5
;     711        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;     712        	WR=1;
	SBI  0x1B,5
;     713        	WR=0;
	CBI  0x1B,5
;     714        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     715        	WR=1;
	SBI  0x1B,5
;     716        	WR=0;
	CBI  0x1B,5
;     717        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     718        	WR=1;
	SBI  0x1B,5
;     719        	WR=0;
	CBI  0x1B,5
;     720        	Display_data=0x00;
	OUT  0x15,R30
;     721        	WR=1; 
	SBI  0x1B,5
;     722        	return;  
	RJMP _0x126
;     723        
;     724        	case '2':
_0x60:
	CPI  R30,LOW(0x32)
	BRNE _0x61
;     725        	WR=0;
	CBI  0x1B,5
;     726        	Display_data=0x42;
	LDI  R30,LOW(66)
	OUT  0x15,R30
;     727        	WR=1;
	SBI  0x1B,5
;     728        	WR=0;
	CBI  0x1B,5
;     729        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;     730        	WR=1;
	SBI  0x1B,5
;     731        	WR=0;
	CBI  0x1B,5
;     732        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;     733        	WR=1;
	SBI  0x1B,5
;     734        	WR=0;
	CBI  0x1B,5
;     735        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     736        	WR=1;
	SBI  0x1B,5
;     737        	WR=0;
	CBI  0x1B,5
;     738        	Display_data=0x46;
	LDI  R30,LOW(70)
	OUT  0x15,R30
;     739        	WR=1;
	SBI  0x1B,5
;     740        	WR=0;
	CBI  0x1B,5
;     741        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     742        	WR=1; 
	SBI  0x1B,5
;     743        	return;    
	RJMP _0x126
;     744                   
;     745   	case '3':
_0x61:
	CPI  R30,LOW(0x33)
	BRNE _0x62
;     746        	WR=0;
	CBI  0x1B,5
;     747        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;     748        	WR=1;
	SBI  0x1B,5
;     749        	WR=0;
	CBI  0x1B,5
;     750        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     751        	WR=1;
	SBI  0x1B,5
;     752        	WR=0;
	CBI  0x1B,5
;     753        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     754        	WR=1;
	SBI  0x1B,5
;     755        	WR=0;
	CBI  0x1B,5
;     756        	Display_data=0x49;
	OUT  0x15,R30
;     757        	WR=1;
	SBI  0x1B,5
;     758        	WR=0;
	CBI  0x1B,5
;     759        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;     760        	WR=1;
	SBI  0x1B,5
;     761        	WR=0;
	CBI  0x1B,5
;     762        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     763        	WR=1; 
	SBI  0x1B,5
;     764        	return; 
	RJMP _0x126
;     765        
;     766        	case '4':
_0x62:
	CPI  R30,LOW(0x34)
	BRNE _0x63
;     767        	WR=0;
	CBI  0x1B,5
;     768        	Display_data=0x18;
	LDI  R30,LOW(24)
	OUT  0x15,R30
;     769        	WR=1;
	SBI  0x1B,5
;     770        	WR=0;
	CBI  0x1B,5
;     771        	Display_data=0x14;
	LDI  R30,LOW(20)
	OUT  0x15,R30
;     772        	WR=1;
	SBI  0x1B,5
;     773        	WR=0;
	CBI  0x1B,5
;     774        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;     775        	WR=1;
	SBI  0x1B,5
;     776        	WR=0;
	CBI  0x1B,5
;     777        	Display_data=0x79;
	LDI  R30,LOW(121)
	OUT  0x15,R30
;     778        	WR=1;
	SBI  0x1B,5
;     779        	WR=0;
	CBI  0x1B,5
;     780        	Display_data=0x10;
	LDI  R30,LOW(16)
	OUT  0x15,R30
;     781        	WR=1;
	SBI  0x1B,5
;     782        	WR=0;
	CBI  0x1B,5
;     783        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     784        	WR=1; 
	SBI  0x1B,5
;     785        	return; 
	RJMP _0x126
;     786 
;     787 	case '5':
_0x63:
	CPI  R30,LOW(0x35)
	BRNE _0x64
;     788        	WR=0;
	CBI  0x1B,5
;     789        	Display_data=0x2F;
	LDI  R30,LOW(47)
	OUT  0x15,R30
;     790        	WR=1;
	SBI  0x1B,5
;     791        	WR=0;
	CBI  0x1B,5
;     792        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     793        	WR=1;
	SBI  0x1B,5
;     794        	WR=0;
	CBI  0x1B,5
;     795        	Display_data=0x49;
	OUT  0x15,R30
;     796        	WR=1;
	SBI  0x1B,5
;     797        	WR=0;
	CBI  0x1B,5
;     798        	Display_data=0x49;
	OUT  0x15,R30
;     799        	WR=1;
	SBI  0x1B,5
;     800        	WR=0;
	CBI  0x1B,5
;     801        	Display_data=0x31;
	LDI  R30,LOW(49)
	OUT  0x15,R30
;     802        	WR=1;
	SBI  0x1B,5
;     803        	WR=0;
	CBI  0x1B,5
;     804        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     805        	WR=1; 
	SBI  0x1B,5
;     806        	return;        
	RJMP _0x126
;     807 
;     808 	case '6':
_0x64:
	CPI  R30,LOW(0x36)
	BRNE _0x65
;     809        	WR=0;
	CBI  0x1B,5
;     810        	Display_data=0x3C;
	LDI  R30,LOW(60)
	OUT  0x15,R30
;     811        	WR=1;
	SBI  0x1B,5
;     812        	WR=0;
	CBI  0x1B,5
;     813        	Display_data=0x4A;
	LDI  R30,LOW(74)
	OUT  0x15,R30
;     814        	WR=1;
	SBI  0x1B,5
;     815        	WR=0;
	CBI  0x1B,5
;     816        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     817        	WR=1;
	SBI  0x1B,5
;     818        	WR=0;
	CBI  0x1B,5
;     819        	Display_data=0x49;
	OUT  0x15,R30
;     820        	WR=1;
	SBI  0x1B,5
;     821        	WR=0;
	CBI  0x1B,5
;     822        	Display_data=0x30;
	LDI  R30,LOW(48)
	OUT  0x15,R30
;     823        	WR=1;
	SBI  0x1B,5
;     824        	WR=0;
	CBI  0x1B,5
;     825        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     826        	WR=1; 
	SBI  0x1B,5
;     827        	return;       
	RJMP _0x126
;     828        
;     829        	case '7':
_0x65:
	CPI  R30,LOW(0x37)
	BRNE _0x66
;     830        	WR=0;
	CBI  0x1B,5
;     831        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;     832        	WR=1;
	SBI  0x1B,5
;     833        	WR=0;
	CBI  0x1B,5
;     834        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;     835        	WR=1;
	SBI  0x1B,5
;     836        	WR=0;
	CBI  0x1B,5
;     837        	Display_data=0x11;
	LDI  R30,LOW(17)
	OUT  0x15,R30
;     838        	WR=1;
	SBI  0x1B,5
;     839        	WR=0;
	CBI  0x1B,5
;     840        	Display_data=0x0D;
	LDI  R30,LOW(13)
	OUT  0x15,R30
;     841        	WR=1;
	SBI  0x1B,5
;     842        	WR=0;
	CBI  0x1B,5
;     843        	Display_data=0x03;
	LDI  R30,LOW(3)
	OUT  0x15,R30
;     844        	WR=1;
	SBI  0x1B,5
;     845        	WR=0;
	CBI  0x1B,5
;     846        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     847        	WR=1; 
	SBI  0x1B,5
;     848        	return;   
	RJMP _0x126
;     849        
;     850        	case '8':
_0x66:
	CPI  R30,LOW(0x38)
	BRNE _0x67
;     851        	WR=0;
	CBI  0x1B,5
;     852        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;     853        	WR=1;
	SBI  0x1B,5
;     854        	WR=0;
	CBI  0x1B,5
;     855        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     856        	WR=1;
	SBI  0x1B,5
;     857        	WR=0;
	CBI  0x1B,5
;     858        	Display_data=0x49;
	OUT  0x15,R30
;     859        	WR=1;
	SBI  0x1B,5
;     860        	WR=0;
	CBI  0x1B,5
;     861        	Display_data=0x49;
	OUT  0x15,R30
;     862        	WR=1;
	SBI  0x1B,5
;     863        	WR=0;
	CBI  0x1B,5
;     864        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;     865        	WR=1;
	SBI  0x1B,5
;     866        	WR=0;
	CBI  0x1B,5
;     867        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     868        	WR=1; 
	SBI  0x1B,5
;     869        	return;          
	RJMP _0x126
;     870 
;     871 	case '9':
_0x67:
	CPI  R30,LOW(0x39)
	BRNE _0x68
;     872        	WR=0;
	CBI  0x1B,5
;     873        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;     874        	WR=1;
	SBI  0x1B,5
;     875        	WR=0;
	CBI  0x1B,5
;     876        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     877        	WR=1;
	SBI  0x1B,5
;     878        	WR=0;
	CBI  0x1B,5
;     879        	Display_data=0x29;
	LDI  R30,LOW(41)
	OUT  0x15,R30
;     880        	WR=1;
	SBI  0x1B,5
;     881        	WR=0;
	CBI  0x1B,5
;     882        	Display_data=0x19;
	LDI  R30,LOW(25)
	OUT  0x15,R30
;     883        	WR=1;
	SBI  0x1B,5
;     884        	WR=0;
	CBI  0x1B,5
;     885        	Display_data=0x0E;
	LDI  R30,LOW(14)
	OUT  0x15,R30
;     886        	WR=1;
	SBI  0x1B,5
;     887        	WR=0;
	CBI  0x1B,5
;     888        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     889        	WR=1; 
	SBI  0x1B,5
;     890        	return;     
	RJMP _0x126
;     891        
;     892        	case 'A':
_0x68:
	CPI  R30,LOW(0x41)
	BRNE _0x69
;     893        	WR=0;
	CBI  0x1B,5
;     894        	Display_data=0x7C;
	LDI  R30,LOW(124)
	OUT  0x15,R30
;     895        	WR=1;
	SBI  0x1B,5
;     896        	WR=0;
	CBI  0x1B,5
;     897        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;     898        	WR=1;
	SBI  0x1B,5
;     899        	WR=0;
	CBI  0x1B,5
;     900        	Display_data=0x11;
	LDI  R30,LOW(17)
	OUT  0x15,R30
;     901        	WR=1;
	SBI  0x1B,5
;     902        	WR=0;
	CBI  0x1B,5
;     903        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;     904        	WR=1;
	SBI  0x1B,5
;     905        	WR=0;
	CBI  0x1B,5
;     906        	Display_data=0x7C;
	LDI  R30,LOW(124)
	OUT  0x15,R30
;     907        	WR=1;
	SBI  0x1B,5
;     908        	WR=0;
	CBI  0x1B,5
;     909        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     910        	WR=1; 
	SBI  0x1B,5
;     911        	return;      
	RJMP _0x126
;     912        
;     913  	case 'B':
_0x69:
	CPI  R30,LOW(0x42)
	BRNE _0x6A
;     914        	WR=0;
	CBI  0x1B,5
;     915        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     916        	WR=1;
	SBI  0x1B,5
;     917        	WR=0;
	CBI  0x1B,5
;     918        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     919        	WR=1;
	SBI  0x1B,5
;     920        	WR=0;
	CBI  0x1B,5
;     921        	Display_data=0x49;
	OUT  0x15,R30
;     922        	WR=1;
	SBI  0x1B,5
;     923        	WR=0;
	CBI  0x1B,5
;     924        	Display_data=0x49;
	OUT  0x15,R30
;     925        	WR=1;
	SBI  0x1B,5
;     926        	WR=0;
	CBI  0x1B,5
;     927        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;     928        	WR=1;
	SBI  0x1B,5
;     929        	WR=0;
	CBI  0x1B,5
;     930        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     931        	WR=1; 
	SBI  0x1B,5
;     932        	return;           
	RJMP _0x126
;     933        
;     934        	case 'C':
_0x6A:
	CPI  R30,LOW(0x43)
	BRNE _0x6B
;     935        	WR=0;
	CBI  0x1B,5
;     936        	Display_data=0x1C;
	LDI  R30,LOW(28)
	OUT  0x15,R30
;     937        	WR=1;
	SBI  0x1B,5
;     938        	WR=0;
	CBI  0x1B,5
;     939        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;     940        	WR=1;
	SBI  0x1B,5
;     941        	WR=0;
	CBI  0x1B,5
;     942        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     943        	WR=1;
	SBI  0x1B,5
;     944        	WR=0;
	CBI  0x1B,5
;     945        	Display_data=0x41;
	OUT  0x15,R30
;     946        	WR=1;
	SBI  0x1B,5
;     947        	WR=0;
	CBI  0x1B,5
;     948        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;     949        	WR=1;
	SBI  0x1B,5
;     950        	WR=0;
	CBI  0x1B,5
;     951        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     952        	WR=1; 
	SBI  0x1B,5
;     953        	return;           
	RJMP _0x126
;     954        
;     955        	case 'D':
_0x6B:
	CPI  R30,LOW(0x44)
	BRNE _0x6C
;     956        	WR=0;
	CBI  0x1B,5
;     957        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     958        	WR=1;
	SBI  0x1B,5
;     959        	WR=0;
	CBI  0x1B,5
;     960        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     961        	WR=1;
	SBI  0x1B,5
;     962        	WR=0;
	CBI  0x1B,5
;     963        	Display_data=0x41;
	OUT  0x15,R30
;     964        	WR=1;
	SBI  0x1B,5
;     965        	WR=0;
	CBI  0x1B,5
;     966        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;     967        	WR=1;
	SBI  0x1B,5
;     968        	WR=0;
	CBI  0x1B,5
;     969        	Display_data=0x1C;
	LDI  R30,LOW(28)
	OUT  0x15,R30
;     970        	WR=1;
	SBI  0x1B,5
;     971        	WR=0;
	CBI  0x1B,5
;     972        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     973        	WR=1; 
	SBI  0x1B,5
;     974        	return;           
	RJMP _0x126
;     975                  
;     976         case 'E':
_0x6C:
	CPI  R30,LOW(0x45)
	BRNE _0x6D
;     977        	WR=0;
	CBI  0x1B,5
;     978        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     979        	WR=1;
	SBI  0x1B,5
;     980        	WR=0;
	CBI  0x1B,5
;     981        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;     982        	WR=1;
	SBI  0x1B,5
;     983        	WR=0;
	CBI  0x1B,5
;     984        	Display_data=0x49;
	OUT  0x15,R30
;     985        	WR=1;
	SBI  0x1B,5
;     986        	WR=0;
	CBI  0x1B,5
;     987        	Display_data=0x49;
	OUT  0x15,R30
;     988        	WR=1;
	SBI  0x1B,5
;     989        	WR=0;
	CBI  0x1B,5
;     990        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     991        	WR=1;
	SBI  0x1B,5
;     992        	WR=0;
	CBI  0x1B,5
;     993        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     994        	WR=1; 
	SBI  0x1B,5
;     995        	return;  
	RJMP _0x126
;     996        
;     997        	case 'F':
_0x6D:
	CPI  R30,LOW(0x46)
	BRNE _0x6E
;     998        	WR=0;
	CBI  0x1B,5
;     999        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1000        	WR=1;
	SBI  0x1B,5
;    1001        	WR=0;
	CBI  0x1B,5
;    1002        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1003        	WR=1;
	SBI  0x1B,5
;    1004        	WR=0;
	CBI  0x1B,5
;    1005        	Display_data=0x09;
	OUT  0x15,R30
;    1006        	WR=1;
	SBI  0x1B,5
;    1007        	WR=0;
	CBI  0x1B,5
;    1008        	Display_data=0x09;
	OUT  0x15,R30
;    1009        	WR=1;
	SBI  0x1B,5
;    1010        	WR=0;
	CBI  0x1B,5
;    1011        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1012        	WR=1;
	SBI  0x1B,5
;    1013        	WR=0;
	CBI  0x1B,5
;    1014        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1015        	WR=1; 
	SBI  0x1B,5
;    1016        	return;
	RJMP _0x126
;    1017               
;    1018        	case 'G':
_0x6E:
	CPI  R30,LOW(0x47)
	BRNE _0x6F
;    1019        	WR=0;
	CBI  0x1B,5
;    1020        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1021        	WR=1;
	SBI  0x1B,5
;    1022        	WR=0;
	CBI  0x1B,5
;    1023        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1024        	WR=1;
	SBI  0x1B,5
;    1025        	WR=0;
	CBI  0x1B,5
;    1026        	Display_data=0x41;
	OUT  0x15,R30
;    1027        	WR=1;
	SBI  0x1B,5
;    1028        	WR=0;
	CBI  0x1B,5
;    1029        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;    1030        	WR=1;
	SBI  0x1B,5
;    1031        	WR=0;
	CBI  0x1B,5
;    1032        	Display_data=0x32;
	LDI  R30,LOW(50)
	OUT  0x15,R30
;    1033        	WR=1;
	SBI  0x1B,5
;    1034        	WR=0;
	CBI  0x1B,5
;    1035        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1036        	WR=1;  
	SBI  0x1B,5
;    1037        	return;
	RJMP _0x126
;    1038               
;    1039        	case 'H':
_0x6F:
	CPI  R30,LOW(0x48)
	BRNE _0x70
;    1040        	WR=0;
	CBI  0x1B,5
;    1041        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1042        	WR=1;
	SBI  0x1B,5
;    1043        	WR=0;
	CBI  0x1B,5
;    1044        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1045        	WR=1;
	SBI  0x1B,5
;    1046        	WR=0;
	CBI  0x1B,5
;    1047        	Display_data=0x08;
	OUT  0x15,R30
;    1048        	WR=1;
	SBI  0x1B,5
;    1049        	WR=0;
	CBI  0x1B,5
;    1050        	Display_data=0x08;
	OUT  0x15,R30
;    1051        	WR=1;
	SBI  0x1B,5
;    1052        	WR=0;
	CBI  0x1B,5
;    1053        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1054        	WR=1;
	SBI  0x1B,5
;    1055        	WR=0;
	CBI  0x1B,5
;    1056        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1057        	WR=1;  
	SBI  0x1B,5
;    1058        	return;
	RJMP _0x126
;    1059            
;    1060        	case 'I':
_0x70:
	CPI  R30,LOW(0x49)
	BRNE _0x71
;    1061        	WR=0;
	CBI  0x1B,5
;    1062        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1063        	WR=1;
	SBI  0x1B,5
;    1064        	WR=0;
	CBI  0x1B,5
;    1065        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1066        	WR=1;
	SBI  0x1B,5
;    1067        	WR=0;
	CBI  0x1B,5
;    1068        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1069        	WR=1;
	SBI  0x1B,5
;    1070        	WR=0;
	CBI  0x1B,5
;    1071        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1072        	WR=1;
	SBI  0x1B,5
;    1073        	WR=0;
	CBI  0x1B,5
;    1074        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1075        	WR=0;
	CBI  0x1B,5
;    1076        	Display_data=0x00;
	OUT  0x15,R30
;    1077        	WR=1; 
	SBI  0x1B,5
;    1078        	return;  
	RJMP _0x126
;    1079        
;    1080        	case 'J':
_0x71:
	CPI  R30,LOW(0x4A)
	BRNE _0x72
;    1081        	WR=0;
	CBI  0x1B,5
;    1082        	Display_data=0x20;
	LDI  R30,LOW(32)
	OUT  0x15,R30
;    1083        	WR=1;
	SBI  0x1B,5
;    1084        	WR=0;
	CBI  0x1B,5
;    1085        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1086        	WR=1;
	SBI  0x1B,5
;    1087        	WR=0;
	CBI  0x1B,5
;    1088        	Display_data=0x40;
	OUT  0x15,R30
;    1089        	WR=1;
	SBI  0x1B,5
;    1090        	WR=0;
	CBI  0x1B,5
;    1091        	Display_data=0x40;
	OUT  0x15,R30
;    1092        	WR=1;
	SBI  0x1B,5
;    1093        	WR=0;
	CBI  0x1B,5
;    1094        	Display_data=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1095        	WR=1;
	SBI  0x1B,5
;    1096        	WR=0;
	CBI  0x1B,5
;    1097        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1098        	WR=1; 
	SBI  0x1B,5
;    1099        	return;
	RJMP _0x126
;    1100        
;    1101        	case 'K':
_0x72:
	CPI  R30,LOW(0x4B)
	BRNE _0x73
;    1102        	WR=0;
	CBI  0x1B,5
;    1103        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1104        	WR=1;
	SBI  0x1B,5
;    1105        	WR=0;
	CBI  0x1B,5
;    1106        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1107        	WR=1;
	SBI  0x1B,5
;    1108        	WR=0;
	CBI  0x1B,5
;    1109        	Display_data=0x14;
	LDI  R30,LOW(20)
	OUT  0x15,R30
;    1110        	WR=1;
	SBI  0x1B,5
;    1111        	WR=0;
	CBI  0x1B,5
;    1112        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1113        	WR=1;
	SBI  0x1B,5
;    1114        	WR=0;
	CBI  0x1B,5
;    1115        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1116        	WR=1;
	SBI  0x1B,5
;    1117        	WR=0;
	CBI  0x1B,5
;    1118        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1119        	WR=1; 
	SBI  0x1B,5
;    1120        	return;
	RJMP _0x126
;    1121                  
;    1122        	case 'L':
_0x73:
	CPI  R30,LOW(0x4C)
	BRNE _0x74
;    1123        	WR=0;
	CBI  0x1B,5
;    1124        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1125        	WR=1;
	SBI  0x1B,5
;    1126        	WR=0;
	CBI  0x1B,5
;    1127        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1128        	WR=1;
	SBI  0x1B,5
;    1129        	WR=0;
	CBI  0x1B,5
;    1130        	Display_data=0x40;
	OUT  0x15,R30
;    1131        	WR=1;
	SBI  0x1B,5
;    1132        	WR=0;
	CBI  0x1B,5
;    1133        	Display_data=0x40;
	OUT  0x15,R30
;    1134        	WR=1;
	SBI  0x1B,5
;    1135        	WR=0;
	CBI  0x1B,5
;    1136        	Display_data=0x40;
	OUT  0x15,R30
;    1137        	WR=1;
	SBI  0x1B,5
;    1138        	WR=0;
	CBI  0x1B,5
;    1139        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1140        	WR=1; 
	SBI  0x1B,5
;    1141        	return; 
	RJMP _0x126
;    1142        
;    1143   	case 'M':
_0x74:
	CPI  R30,LOW(0x4D)
	BRNE _0x75
;    1144        	WR=0;
	CBI  0x1B,5
;    1145        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1146        	WR=1;
	SBI  0x1B,5
;    1147        	WR=0;
	CBI  0x1B,5
;    1148        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;    1149        	WR=1;
	SBI  0x1B,5
;    1150        	WR=0;
	CBI  0x1B,5
;    1151        	Display_data=0x04;
	LDI  R30,LOW(4)
	OUT  0x15,R30
;    1152        	WR=1;
	SBI  0x1B,5
;    1153        	WR=0;
	CBI  0x1B,5
;    1154        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;    1155        	WR=1;
	SBI  0x1B,5
;    1156        	WR=0;
	CBI  0x1B,5
;    1157        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1158        	WR=1;
	SBI  0x1B,5
;    1159        	WR=0;
	CBI  0x1B,5
;    1160        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1161        	WR=1; 
	SBI  0x1B,5
;    1162        	return;
	RJMP _0x126
;    1163        
;    1164        	case 'N':
_0x75:
	CPI  R30,LOW(0x4E)
	BRNE _0x76
;    1165        	WR=0;
	CBI  0x1B,5
;    1166        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1167        	WR=1;
	SBI  0x1B,5
;    1168        	WR=0;
	CBI  0x1B,5
;    1169        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1170        	WR=1;
	SBI  0x1B,5
;    1171        	WR=0;
	CBI  0x1B,5
;    1172        	Display_data=0x18;
	LDI  R30,LOW(24)
	OUT  0x15,R30
;    1173        	WR=1;
	SBI  0x1B,5
;    1174        	WR=0;
	CBI  0x1B,5
;    1175        	Display_data=0x20;
	LDI  R30,LOW(32)
	OUT  0x15,R30
;    1176        	WR=1;
	SBI  0x1B,5
;    1177        	WR=0;
	CBI  0x1B,5
;    1178        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1179        	WR=1;
	SBI  0x1B,5
;    1180        	WR=0;
	CBI  0x1B,5
;    1181        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1182        	WR=1; 
	SBI  0x1B,5
;    1183        	return;
	RJMP _0x126
;    1184           
;    1185         case 'O':
_0x76:
	CPI  R30,LOW(0x4F)
	BRNE _0x77
;    1186        	WR=0;
	CBI  0x1B,5
;    1187        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1188        	WR=1;
	SBI  0x1B,5
;    1189        	WR=0;
	CBI  0x1B,5
;    1190        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1191        	WR=1;
	SBI  0x1B,5
;    1192        	WR=0;
	CBI  0x1B,5
;    1193        	Display_data=0x41;
	OUT  0x15,R30
;    1194        	WR=1;
	SBI  0x1B,5
;    1195        	WR=0;
	CBI  0x1B,5
;    1196        	Display_data=0x41;
	OUT  0x15,R30
;    1197        	WR=1;
	SBI  0x1B,5
;    1198        	WR=0;
	CBI  0x1B,5
;    1199        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1200        	WR=1;
	SBI  0x1B,5
;    1201        	WR=0;
	CBI  0x1B,5
;    1202        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1203        	WR=1;
	SBI  0x1B,5
;    1204 	return;	   
	RJMP _0x126
;    1205        
;    1206 	case 'P':
_0x77:
	CPI  R30,LOW(0x50)
	BRNE _0x78
;    1207  	WR=0;
	CBI  0x1B,5
;    1208        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1209        	WR=1;
	SBI  0x1B,5
;    1210        	WR=0;
	CBI  0x1B,5
;    1211        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1212        	WR=1;
	SBI  0x1B,5
;    1213        	WR=0;
	CBI  0x1B,5
;    1214        	Display_data=0x09;
	OUT  0x15,R30
;    1215        	WR=1;
	SBI  0x1B,5
;    1216        	WR=0;
	CBI  0x1B,5
;    1217        	Display_data=0x09;
	OUT  0x15,R30
;    1218        	WR=1;
	SBI  0x1B,5
;    1219        	WR=0;
	CBI  0x1B,5
;    1220        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1221        	WR=1; 
	SBI  0x1B,5
;    1222        	WR=0;
	CBI  0x1B,5
;    1223        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1224        	WR=1; 
	SBI  0x1B,5
;    1225        	return;
	RJMP _0x126
;    1226        
;    1227   	case 'Q':
_0x78:
	CPI  R30,LOW(0x51)
	BRNE _0x79
;    1228    	WR=0;
	CBI  0x1B,5
;    1229        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1230        	WR=1;
	SBI  0x1B,5
;    1231        	WR=0;
	CBI  0x1B,5
;    1232        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1233        	WR=1;
	SBI  0x1B,5
;    1234        	WR=0;
	CBI  0x1B,5
;    1235        	Display_data=0x41;
	OUT  0x15,R30
;    1236        	WR=1;
	SBI  0x1B,5
;    1237        	WR=0;
	CBI  0x1B,5
;    1238        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1239        	WR=1;
	SBI  0x1B,5
;    1240        	WR=0;
	CBI  0x1B,5
;    1241        	Display_data=0x7E;
	LDI  R30,LOW(126)
	OUT  0x15,R30
;    1242        	WR=1;
	SBI  0x1B,5
;    1243        	WR=0;
	CBI  0x1B,5
;    1244        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1245        	WR=1;
	SBI  0x1B,5
;    1246 	return;	   
	RJMP _0x126
;    1247       
;    1248 	
;    1249 	case 'R':
_0x79:
	CPI  R30,LOW(0x52)
	BRNE _0x7A
;    1250  	WR=0;
	CBI  0x1B,5
;    1251        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1252        	WR=1;
	SBI  0x1B,5
;    1253        	WR=0;
	CBI  0x1B,5
;    1254        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1255        	WR=1;
	SBI  0x1B,5
;    1256        	WR=0;
	CBI  0x1B,5
;    1257        	Display_data=0x19;
	LDI  R30,LOW(25)
	OUT  0x15,R30
;    1258        	WR=1;
	SBI  0x1B,5
;    1259        	WR=0;
	CBI  0x1B,5
;    1260        	Display_data=0x29; 
	LDI  R30,LOW(41)
	OUT  0x15,R30
;    1261        	WR=1;
	SBI  0x1B,5
;    1262        	WR=0;
	CBI  0x1B,5
;    1263        	Display_data=0x46; 
	LDI  R30,LOW(70)
	OUT  0x15,R30
;    1264        	WR=1;  
	SBI  0x1B,5
;    1265        	WR=0;
	CBI  0x1B,5
;    1266        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1267        	WR=1; 
	SBI  0x1B,5
;    1268        	return;   
	RJMP _0x126
;    1269        
;    1270        	case 'S':
_0x7A:
	CPI  R30,LOW(0x53)
	BRNE _0x7B
;    1271   	WR=0;
	CBI  0x1B,5
;    1272        	Display_data=0x26;
	LDI  R30,LOW(38)
	OUT  0x15,R30
;    1273        	WR=1;
	SBI  0x1B,5
;    1274        	WR=0;
	CBI  0x1B,5
;    1275        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1276        	WR=1;
	SBI  0x1B,5
;    1277        	WR=0;
	CBI  0x1B,5
;    1278        	Display_data=0x49;
	OUT  0x15,R30
;    1279        	WR=1;
	SBI  0x1B,5
;    1280        	WR=0;
	CBI  0x1B,5
;    1281        	Display_data=0x49; 
	OUT  0x15,R30
;    1282        	WR=1; 
	SBI  0x1B,5
;    1283        	WR=0;
	CBI  0x1B,5
;    1284        	Display_data=0x32;
	LDI  R30,LOW(50)
	OUT  0x15,R30
;    1285        	WR=1; 
	SBI  0x1B,5
;    1286        	WR=0;
	CBI  0x1B,5
;    1287        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1288        	WR=1; 
	SBI  0x1B,5
;    1289        	return;
	RJMP _0x126
;    1290   
;    1291   	case 'T':
_0x7B:
	CPI  R30,LOW(0x54)
	BRNE _0x7C
;    1292    	WR=0;
	CBI  0x1B,5
;    1293        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1294        	WR=1;
	SBI  0x1B,5
;    1295        	WR=0;
	CBI  0x1B,5
;    1296        	Display_data=0x01;
	OUT  0x15,R30
;    1297        	WR=1;
	SBI  0x1B,5
;    1298        	WR=0;
	CBI  0x1B,5
;    1299        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1300        	WR=1;
	SBI  0x1B,5
;    1301        	WR=0;
	CBI  0x1B,5
;    1302        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1303        	WR=1;
	SBI  0x1B,5
;    1304        	WR=0;
	CBI  0x1B,5
;    1305        	Display_data=0x01;
	OUT  0x15,R30
;    1306        	WR=1;
	SBI  0x1B,5
;    1307        	WR=0;
	CBI  0x1B,5
;    1308        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1309        	WR=1;
	SBI  0x1B,5
;    1310        	return;
	RJMP _0x126
;    1311 	  
;    1312 	        
;    1313   	case 'U':
_0x7C:
	CPI  R30,LOW(0x55)
	BRNE _0x7D
;    1314    	WR=0;
	CBI  0x1B,5
;    1315        	Display_data=0x3F; 
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1316        	WR=1;
	SBI  0x1B,5
;    1317        	WR=0;
	CBI  0x1B,5
;    1318        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1319        	WR=1;
	SBI  0x1B,5
;    1320        	WR=0;
	CBI  0x1B,5
;    1321        	Display_data=0x40;
	OUT  0x15,R30
;    1322        	WR=1;
	SBI  0x1B,5
;    1323        	WR=0;
	CBI  0x1B,5
;    1324        	Display_data=0x40; 
	OUT  0x15,R30
;    1325        	WR=1;
	SBI  0x1B,5
;    1326        	WR=0;
	CBI  0x1B,5
;    1327        	Display_data=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1328        	WR=1;
	SBI  0x1B,5
;    1329        	WR=0;
	CBI  0x1B,5
;    1330        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1331        	WR=1;
	SBI  0x1B,5
;    1332        	return;
	RJMP _0x126
;    1333                   
;    1334    	case 'V':
_0x7D:
	CPI  R30,LOW(0x56)
	BRNE _0x7E
;    1335     	WR=0;
	CBI  0x1B,5
;    1336        	Display_data=0x0F; 
	LDI  R30,LOW(15)
	OUT  0x15,R30
;    1337        	WR=1;
	SBI  0x1B,5
;    1338        	WR=0;
	CBI  0x1B,5
;    1339        	Display_data=0x30;
	LDI  R30,LOW(48)
	OUT  0x15,R30
;    1340        	WR=1;
	SBI  0x1B,5
;    1341        	WR=0;
	CBI  0x1B,5
;    1342        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1343        	WR=1;
	SBI  0x1B,5
;    1344        	WR=0;
	CBI  0x1B,5
;    1345        	Display_data=0x30; 
	LDI  R30,LOW(48)
	OUT  0x15,R30
;    1346        	WR=1;
	SBI  0x1B,5
;    1347        	WR=0;
	CBI  0x1B,5
;    1348        	Display_data=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
;    1349        	WR=1;
	SBI  0x1B,5
;    1350        	WR=0;
	CBI  0x1B,5
;    1351        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1352        	WR=1;
	SBI  0x1B,5
;    1353        	return;
	RJMP _0x126
;    1354                
;    1355      	case 'W':
_0x7E:
	CPI  R30,LOW(0x57)
	BRNE _0x7F
;    1356      	WR=0;
	CBI  0x1B,5
;    1357        	Display_data=0x1F; 
	LDI  R30,LOW(31)
	OUT  0x15,R30
;    1358        	WR=1;
	SBI  0x1B,5
;    1359        	WR=0;
	CBI  0x1B,5
;    1360        	Display_data=0x60;
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1361        	WR=1;
	SBI  0x1B,5
;    1362        	WR=0;
	CBI  0x1B,5
;    1363        	Display_data=0x0C;
	LDI  R30,LOW(12)
	OUT  0x15,R30
;    1364        	WR=1;
	SBI  0x1B,5
;    1365        	WR=0;
	CBI  0x1B,5
;    1366        	Display_data=0x60; 
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1367        	WR=1;
	SBI  0x1B,5
;    1368        	WR=0;
	CBI  0x1B,5
;    1369        	Display_data=0x1F;
	LDI  R30,LOW(31)
	OUT  0x15,R30
;    1370        	WR=1;
	SBI  0x1B,5
;    1371        	WR=0;
	CBI  0x1B,5
;    1372        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1373        	WR=1;
	SBI  0x1B,5
;    1374        	return;
	RJMP _0x126
;    1375        
;    1376         case 'X':
_0x7F:
	CPI  R30,LOW(0x58)
	BRNE _0x80
;    1377       	WR=0;
	CBI  0x1B,5
;    1378        	Display_data=0x41; 
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1379        	WR=1;
	SBI  0x1B,5
;    1380        	WR=0;
	CBI  0x1B,5
;    1381        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1382        	WR=1;
	SBI  0x1B,5
;    1383        	WR=0;
	CBI  0x1B,5
;    1384        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1385        	WR=1;
	SBI  0x1B,5
;    1386        	WR=0;
	CBI  0x1B,5
;    1387        	Display_data=0x36; 
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1388        	WR=1;
	SBI  0x1B,5
;    1389        	WR=0;
	CBI  0x1B,5
;    1390        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1391        	WR=1;
	SBI  0x1B,5
;    1392        	WR=0;
	CBI  0x1B,5
;    1393        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1394        	WR=1;
	SBI  0x1B,5
;    1395        	return;  
	RJMP _0x126
;    1396        
;    1397        	case 'Y':
_0x80:
	CPI  R30,LOW(0x59)
	BRNE _0x81
;    1398       	WR=0;
	CBI  0x1B,5
;    1399        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1400        	WR=1;
	SBI  0x1B,5
;    1401        	WR=0;
	CBI  0x1B,5
;    1402        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1403        	WR=1;
	SBI  0x1B,5
;    1404        	WR=0;
	CBI  0x1B,5
;    1405        	Display_data=0x78;
	LDI  R30,LOW(120)
	OUT  0x15,R30
;    1406        	WR=1;
	SBI  0x1B,5
;    1407        	WR=0;
	CBI  0x1B,5
;    1408        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1409        	WR=1;
	SBI  0x1B,5
;    1410        	WR=0;
	CBI  0x1B,5
;    1411        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1412        	WR=1;
	SBI  0x1B,5
;    1413        	WR=0;
	CBI  0x1B,5
;    1414        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1415        	WR=1;
	SBI  0x1B,5
;    1416        	return;   
	RJMP _0x126
;    1417        
;    1418        	case 'Z':
_0x81:
	CPI  R30,LOW(0x5A)
	BRNE _0x82
;    1419    	WR=0;
	CBI  0x1B,5
;    1420        	Display_data=0x61; 
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1421        	WR=1;
	SBI  0x1B,5
;    1422        	WR=0;
	CBI  0x1B,5
;    1423        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;    1424        	WR=1;
	SBI  0x1B,5
;    1425        	WR=0;
	CBI  0x1B,5
;    1426        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1427        	WR=1;
	SBI  0x1B,5
;    1428        	WR=0;
	CBI  0x1B,5
;    1429        	Display_data=0x45; 
	LDI  R30,LOW(69)
	OUT  0x15,R30
;    1430        	WR=1;
	SBI  0x1B,5
;    1431        	WR=0;
	CBI  0x1B,5
;    1432        	Display_data=0x43;
	LDI  R30,LOW(67)
	OUT  0x15,R30
;    1433        	WR=1;
	SBI  0x1B,5
;    1434        	WR=0;
	CBI  0x1B,5
;    1435        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1436        	WR=1;
	SBI  0x1B,5
;    1437        	return;   
	RJMP _0x126
;    1438                
;    1439     	case 'd'://degree sign
_0x82:
	CPI  R30,LOW(0x64)
	BRNE _0x83
;    1440      	WR=0;
	CBI  0x1B,5
;    1441        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1442        	WR=1;
	SBI  0x1B,5
;    1443        	WR=0;
	CBI  0x1B,5
;    1444        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1445        	WR=1;
	SBI  0x1B,5
;    1446        	WR=0;
	CBI  0x1B,5
;    1447        	Display_data=0x09;
	OUT  0x15,R30
;    1448        	WR=1;
	SBI  0x1B,5
;    1449        	WR=0;
	CBI  0x1B,5
;    1450        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1451        	WR=1;
	SBI  0x1B,5
;    1452        	WR=0;
	CBI  0x1B,5
;    1453        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1454        	WR=1;
	SBI  0x1B,5
;    1455        	WR=0;
	CBI  0x1B,5
;    1456        	Display_data=0x00;
	OUT  0x15,R30
;    1457        	WR=1;
	SBI  0x1B,5
;    1458        	return;  
	RJMP _0x126
;    1459        
;    1460        	case ',':
_0x83:
	CPI  R30,LOW(0x2C)
	BRNE _0x84
;    1461       	WR=0;
	CBI  0x1B,5
;    1462        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1463        	WR=1;
	SBI  0x1B,5
;    1464        	WR=0;
	CBI  0x1B,5
;    1465        	Display_data=0x00;
	OUT  0x15,R30
;    1466        	WR=1;
	SBI  0x1B,5
;    1467        	WR=0;
	CBI  0x1B,5
;    1468        	Display_data=0xB0;
	LDI  R30,LOW(176)
	OUT  0x15,R30
;    1469        	WR=1;
	SBI  0x1B,5
;    1470        	WR=0;
	CBI  0x1B,5
;    1471        	Display_data=0x70; 
	LDI  R30,LOW(112)
	OUT  0x15,R30
;    1472        	WR=1;
	SBI  0x1B,5
;    1473        	WR=0;
	CBI  0x1B,5
;    1474        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1475        	WR=1;
	SBI  0x1B,5
;    1476        	WR=0;
	CBI  0x1B,5
;    1477        	Display_data=0x00;
	OUT  0x15,R30
;    1478        	WR=1;
	SBI  0x1B,5
;    1479        	return;      
	RJMP _0x126
;    1480        	
;    1481        	case ':':
_0x84:
	CPI  R30,LOW(0x3A)
	BRNE _0x85
;    1482       	WR=0;
	CBI  0x1B,5
;    1483        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1484        	WR=1;
	SBI  0x1B,5
;    1485        	WR=0;
	CBI  0x1B,5
;    1486        	Display_data=0x00;
	OUT  0x15,R30
;    1487        	WR=1;
	SBI  0x1B,5
;    1488        	WR=0;
	CBI  0x1B,5
;    1489        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1490        	WR=1;
	SBI  0x1B,5
;    1491        	WR=0;
	CBI  0x1B,5
;    1492        	Display_data=0x36; 
	OUT  0x15,R30
;    1493        	WR=1;
	SBI  0x1B,5
;    1494        	WR=0;
	CBI  0x1B,5
;    1495        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1496        	WR=1;
	SBI  0x1B,5
;    1497        	WR=0;
	CBI  0x1B,5
;    1498        	Display_data=0x00;
	OUT  0x15,R30
;    1499        	WR=1;
	SBI  0x1B,5
;    1500        	return;  
	RJMP _0x126
;    1501        	
;    1502        	case '.':
_0x85:
	CPI  R30,LOW(0x2E)
	BRNE _0x86
;    1503       	WR=0;
	CBI  0x1B,5
;    1504        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1505        	WR=1;
	SBI  0x1B,5
;    1506        	WR=0;
	CBI  0x1B,5
;    1507        	Display_data=0x00;
	OUT  0x15,R30
;    1508        	WR=1;
	SBI  0x1B,5
;    1509        	WR=0;
	CBI  0x1B,5
;    1510        	Display_data=0x60;
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1511        	WR=1;
	SBI  0x1B,5
;    1512        	WR=0;
	CBI  0x1B,5
;    1513        	Display_data=0x60; 
	OUT  0x15,R30
;    1514        	WR=1;
	SBI  0x1B,5
;    1515        	WR=0;
	CBI  0x1B,5
;    1516        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1517        	WR=1;
	SBI  0x1B,5
;    1518        	WR=0;
	CBI  0x1B,5
;    1519        	Display_data=0x00;
	OUT  0x15,R30
;    1520        	WR=1;
	SBI  0x1B,5
;    1521        	return;  
	RJMP _0x126
;    1522        	
;    1523        	case ';':
_0x86:
	CPI  R30,LOW(0x3B)
	BRNE _0x87
;    1524       	WR=0;
	CBI  0x1B,5
;    1525        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1526        	WR=1;
	SBI  0x1B,5
;    1527        	WR=0;
	CBI  0x1B,5
;    1528        	Display_data=0x00;
	OUT  0x15,R30
;    1529        	WR=1;
	SBI  0x1B,5
;    1530        	WR=0;
	CBI  0x1B,5
;    1531        	Display_data=0xB6;
	LDI  R30,LOW(182)
	OUT  0x15,R30
;    1532        	WR=1;
	SBI  0x1B,5
;    1533        	WR=0;
	CBI  0x1B,5
;    1534        	Display_data=0x76; 
	LDI  R30,LOW(118)
	OUT  0x15,R30
;    1535        	WR=1;
	SBI  0x1B,5
;    1536        	WR=0;
	CBI  0x1B,5
;    1537        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1538        	WR=1;
	SBI  0x1B,5
;    1539        	WR=0;
	CBI  0x1B,5
;    1540        	Display_data=0x00;
	OUT  0x15,R30
;    1541        	WR=1;
	SBI  0x1B,5
;    1542        	return;
	RJMP _0x126
;    1543        	
;    1544 	case '-':
_0x87:
	CPI  R30,LOW(0x2D)
	BRNE _0x5D
;    1545       	WR=0;
	CBI  0x1B,5
;    1546        	Display_data=0x10; 
	LDI  R30,LOW(16)
	OUT  0x15,R30
;    1547        	WR=1;
	SBI  0x1B,5
;    1548        	WR=0;
	CBI  0x1B,5
;    1549        	Display_data=0x10;
	OUT  0x15,R30
;    1550        	WR=1;
	SBI  0x1B,5
;    1551        	WR=0;
	CBI  0x1B,5
;    1552        	Display_data=0x10;
	OUT  0x15,R30
;    1553        	WR=1;
	SBI  0x1B,5
;    1554        	WR=0;
	CBI  0x1B,5
;    1555        	Display_data=0x10; 
	OUT  0x15,R30
;    1556        	WR=1;
	SBI  0x1B,5
;    1557        	WR=0;
	CBI  0x1B,5
;    1558        	Display_data=0x10;
	OUT  0x15,R30
;    1559        	WR=1;
	SBI  0x1B,5
;    1560        	WR=0;
	CBI  0x1B,5
;    1561        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1562        	WR=1;
	SBI  0x1B,5
;    1563        	return;        	        
;    1564 	} 	
_0x5D:
;    1565 } 
_0x126:
	ADIW R28,5
	RET
;    1566 
;    1567 //Clear display
;    1568 void clear_display(void)
;    1569 {
_clear_display:
;    1570 unsigned char i, j;
;    1571 
;    1572 for(j=0;j<8;j++)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16
;	j -> R17
	LDI  R17,LOW(0)
_0x8B:
	CPI  R17,8
	BRSH _0x8C
;    1573 	{
;    1574 	for(i=0;i<18;i++)
	LDI  R16,LOW(0)
_0x8E:
	CPI  R16,18
	BRSH _0x8F
;    1575  		{
;    1576         	Write(' ', j, i);
	LDI  R30,LOW(32)
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1577         	}
	SUBI R16,-1
	RJMP _0x8E
_0x8F:
;    1578 	}  
	SUBI R17,-1
	RJMP _0x8B
_0x8C:
;    1579 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1580 
;    1581 
;    1582 // Writes an unsigned int to the display
;    1583 void lcdprint( unsigned short int n, unsigned char page, unsigned char start_pos)
;    1584 {
_lcdprint:
;    1585 unsigned char d4, d3, d2, d1, q;
;    1586 unsigned short int d0;
;    1587 
;    1588 if ((start_pos < 12) && (page < 8))   //Sjekke om vi har 
	SBIW R28,2
	CALL __SAVELOCR5
;	n -> Y+9
;	page -> Y+8
;	start_pos -> Y+7
;	d4 -> R16
;	d3 -> R17
;	d2 -> R18
;	d1 -> R19
;	q -> R20
;	d0 -> Y+5
	LDD  R26,Y+7
	CPI  R26,LOW(0xC)
	BRSH _0x92
	LDD  R26,Y+8
	CPI  R26,LOW(0x8)
	BRLO _0x93
_0x92:
	RJMP _0x91
_0x93:
;    1589         {
;    1590         d0 = n       & 0xF;
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	STD  Y+5,R30
	STD  Y+5+1,R31
;    1591         d1 = (n>>4)  & 0xF;
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL __LSRW4
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	MOV  R19,R30
;    1592         d2 = (n>>8)  & 0xF;
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	MOV  R30,R31
	CLR  R31
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	MOV  R18,R30
;    1593         d3 = (n>>12) & 0xF;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	LDI  R30,LOW(12)
	CALL __LSRW12
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	MOV  R17,R30
;    1594         
;    1595         d0 = 6*(d3 + d2 + d1) + d0;
	MOV  R30,R18
	ADD  R30,R17
	ADD  R30,R19
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R26,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	CLR  R27
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+5,R30
	STD  Y+5+1,R31
;    1596         q = d0 / 10;
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOV  R20,R30
;    1597         d0 = d0 % 10;
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	STD  Y+5,R30
	STD  Y+5+1,R31
;    1598         
;    1599         d1 = q + 9*d3 + 5*d2 + d1;
	MOV  R30,R17
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOV  R30,R0
	ADD  R30,R20
	PUSH R30
	MOV  R30,R18
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOV  R30,R0
	POP  R26
	ADD  R30,R26
	ADD  R19,R30
;    1600         q = d1 / 10;
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __DIVB21
	MOV  R20,R30
;    1601         d1 = d1 % 10;
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __MODB21U
	MOV  R19,R30
;    1602         
;    1603         d2 = q + 2*d2;
	MOV  R30,R18
	LSL  R30
	ADD  R30,R20
	MOV  R18,R30
;    1604         q = d2 / 10;
	MOV  R26,R18
	LDI  R30,LOW(10)
	CALL __DIVB21
	MOV  R20,R30
;    1605         d2 = d2 % 10;
	MOV  R26,R18
	LDI  R30,LOW(10)
	CALL __MODB21U
	MOV  R18,R30
;    1606         
;    1607         d3 = q + 4*d3;
	MOV  R30,R17
	LSL  R30
	LSL  R30
	ADD  R30,R20
	MOV  R17,R30
;    1608         q = d3 / 10;
	MOV  R26,R17
	LDI  R30,LOW(10)
	CALL __DIVB21
	MOV  R20,R30
;    1609         d3 = d3 % 10;
	MOV  R26,R17
	LDI  R30,LOW(10)
	CALL __MODB21U
	MOV  R17,R30
;    1610         
;    1611         d4 = q;
	MOV  R16,R20
;    1612         
;    1613         Write(d4 + '0',page,start_pos );
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDD  R30,Y+9
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1614         Write(d3 + '0',page,start_pos + 1 );
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDD  R30,Y+9
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	SUBI R30,-LOW(1)
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1615         Write(d2 + '0',page,start_pos + 2 );
	MOV  R30,R18
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDD  R30,Y+9
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	SUBI R30,-LOW(2)
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1616         Write(d1 + '0',page,start_pos + 3 );
	MOV  R30,R19
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDD  R30,Y+9
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	SUBI R30,-LOW(3)
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1617         Write(d0 + '0',page,start_pos + 4 );
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,48
	ST   -Y,R30
	LDD  R30,Y+9
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	SUBI R30,-LOW(4)
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    1618         }
;    1619 }
_0x91:
	CALL __LOADLOCR5
	ADIW R28,11
	RET
;    1620 /************************************************************************** 
;    1621 Name: 		imu.c
;    1622 Comments:	Intializing and reading the sensors
;    1623 **************************************************************************/
;    1624 
;    1625 #include "imu.h"
;    1626 //#include <spi.h>
;    1627 #include <stdio.h>
;    1628 #include <mega128.h>
;    1629 
;    1630 //Read the gyros (X-, Y- and Zaxis)
;    1631 void read_gyros(void)
;    1632 {                    
_read_gyros:
;    1633 unsigned char i = 0;
;    1634 gyro_X_H_akse = 0;	
	ST   -Y,R16
;	i -> R16
	LDI  R16,0
	CLR  R30
	STS  _gyro_X_H_akse,R30
	STS  _gyro_X_H_akse+1,R30
;    1635 gyro_X_L_akse = 0;	
	CLR  R30
	STS  _gyro_X_L_akse,R30
	STS  _gyro_X_L_akse+1,R30
;    1636 gyro_Y_H_akse = 0;
	CLR  R30
	STS  _gyro_Y_H_akse,R30
	STS  _gyro_Y_H_akse+1,R30
;    1637 gyro_Y_L_akse = 0;
	CLR  R30
	STS  _gyro_Y_L_akse,R30
	STS  _gyro_Y_L_akse+1,R30
;    1638 gyro_Z_H_akse = 0;
	CLR  R10
	CLR  R11
;    1639 gyro_Z_L_akse = 0;
	CLR  R12
	CLR  R13
;    1640 
;    1641         for(i=0; i<gyro_measurements; i++)
	LDI  R16,LOW(0)
_0xA5:
	CPI  R16,1
	BRLO PC+3
	JMP _0xA6
;    1642         	{              
;    1643                 //ADC, gyro Z  
;    1644                 PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1645                 gyro_z_h[i] = spi(0b10001011); //Init. next conversion, i.e. gyro Y
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_h)
	LDI  R27,HIGH(_gyro_z_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(139)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1646                 gyro_z_h[i] = gyro_z_h[i] & 0x0F;
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_h)
	LDI  R27,HIGH(_gyro_z_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_h)
	LDI  R27,HIGH(_gyro_z_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;    1647                 gyro_z_l[i] = spi(0b00010000); //cont. init. (ctrl-reg is 12 bit).
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_l)
	LDI  R27,HIGH(_gyro_z_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1648                 PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1649                 //ADC, gyro Y 
;    1650                 PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1651                 gyro_y_h[i] = spi(0b10010011); //Init next conversion, i.e. gyro X
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_h)
	LDI  R27,HIGH(_gyro_y_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(147)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1652                 gyro_y_h[i] = gyro_y_h[i] & 0x0F;
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_h)
	LDI  R27,HIGH(_gyro_y_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_h)
	LDI  R27,HIGH(_gyro_y_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;    1653                 gyro_y_l[i] = spi(0b00010000);
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_l)
	LDI  R27,HIGH(_gyro_y_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1654                 PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1655                 //ADC, gyro X 
;    1656                 PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1657                 gyro_x_h[i] = spi(0b10000011); //Init next conversion, i.e. gyro Z
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_h)
	LDI  R27,HIGH(_gyro_x_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(131)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1658                 gyro_x_h[i] = gyro_x_h[i] & 0x0F;
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_h)
	LDI  R27,HIGH(_gyro_x_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_h)
	LDI  R27,HIGH(_gyro_x_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;    1659                 gyro_x_l[i] = spi(0b00010000);
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_l)
	LDI  R27,HIGH(_gyro_x_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	CLR  R31
	ST   X+,R30
	ST   X,R31
;    1660                 PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1661         	}
	SUBI R16,-1
	RJMP _0xA5
_0xA6:
;    1662         	
;    1663         //Sum all measurements
;    1664         for(i=0; i<gyro_measurements; i++)
	LDI  R16,LOW(0)
_0xA8:
	CPI  R16,1
	BRLO PC+3
	JMP _0xA9
;    1665         	{
;    1666 		gyro_X_H_akse = gyro_X_H_akse + gyro_x_h[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_h)
	LDI  R27,HIGH(_gyro_x_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_gyro_X_H_akse
	LDS  R27,_gyro_X_H_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_X_H_akse,R30
	STS  _gyro_X_H_akse+1,R31
;    1667         	gyro_X_L_akse = gyro_X_L_akse + gyro_x_l[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_x_l)
	LDI  R27,HIGH(_gyro_x_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_gyro_X_L_akse
	LDS  R27,_gyro_X_L_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_X_L_akse,R30
	STS  _gyro_X_L_akse+1,R31
;    1668                 gyro_Y_H_akse = gyro_Y_H_akse + gyro_y_h[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_h)
	LDI  R27,HIGH(_gyro_y_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_gyro_Y_H_akse
	LDS  R27,_gyro_Y_H_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_Y_H_akse,R30
	STS  _gyro_Y_H_akse+1,R31
;    1669                 gyro_Y_L_akse = gyro_Y_L_akse + gyro_y_l[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_y_l)
	LDI  R27,HIGH(_gyro_y_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_gyro_Y_L_akse
	LDS  R27,_gyro_Y_L_akse+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _gyro_Y_L_akse,R30
	STS  _gyro_Y_L_akse+1,R31
;    1670                 gyro_Z_H_akse = gyro_Z_H_akse + gyro_z_h[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_h)
	LDI  R27,HIGH(_gyro_z_h)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__ADDWRR 10,11,30,31
;    1671                 gyro_Z_L_akse = gyro_Z_L_akse + gyro_z_l[i];
	MOV  R30,R16
	LDI  R26,LOW(_gyro_z_l)
	LDI  R27,HIGH(_gyro_z_l)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__ADDWRR 12,13,30,31
;    1672                 }                                              
	SUBI R16,-1
	RJMP _0xA8
_0xA9:
;    1673                 
;    1674         //Divide by number of measurment        
;    1675 	gyro_X_H_akse = gyro_X_H_akse / gyro_measurements;
	LDS  R30,_gyro_X_H_akse
	LDS  R31,_gyro_X_H_akse+1
	STS  _gyro_X_H_akse,R30
	STS  _gyro_X_H_akse+1,R31
;    1676 	gyro_X_L_akse = gyro_X_L_akse / gyro_measurements;
	LDS  R30,_gyro_X_L_akse
	LDS  R31,_gyro_X_L_akse+1
	STS  _gyro_X_L_akse,R30
	STS  _gyro_X_L_akse+1,R31
;    1677         gyro_Y_H_akse = gyro_Y_H_akse / gyro_measurements;
	LDS  R30,_gyro_Y_H_akse
	LDS  R31,_gyro_Y_H_akse+1
	STS  _gyro_Y_H_akse,R30
	STS  _gyro_Y_H_akse+1,R31
;    1678         gyro_Y_L_akse = gyro_Y_L_akse / gyro_measurements;
	LDS  R30,_gyro_Y_L_akse
	LDS  R31,_gyro_Y_L_akse+1
	STS  _gyro_Y_L_akse,R30
	STS  _gyro_Y_L_akse+1,R31
;    1679         gyro_Z_H_akse = gyro_Z_H_akse / gyro_measurements;
	__MOVEWRR 10,11,10,11
;    1680         gyro_Z_L_akse = gyro_Z_L_akse / gyro_measurements;                
	__MOVEWRR 12,13,12,13
;    1681          
;    1682 	//Read gyro temperature
;    1683 	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1684 	spi(0b10000111);			//Init. reading of temp Z (Vin1)
	LDI  R30,LOW(135)
	ST   -Y,R30
	CALL _spi
;    1685 	spi(0b00010000);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
;    1686 	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer                                     
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1687 	
;    1688 	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1689 	gyro_temp_z_h = spi(0b10001111); 	//Init. reading of temp Y (Vin3)
	LDI  R30,LOW(143)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_z_h,R30
	STS  _gyro_temp_z_h+1,R31
;    1690 	gyro_temp_z_h = gyro_temp_z_h & 0x0F;
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	STS  _gyro_temp_z_h,R30
	STS  _gyro_temp_z_h+1,R31
;    1691 	gyro_temp_z_l = spi(0b00010000);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_z_l,R30
	STS  _gyro_temp_z_l+1,R31
;    1692 	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1693 	
;    1694 	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1695 	gyro_temp_y_h = spi(0b10010111);	//Init. reading of temp X (Vin5)
	LDI  R30,LOW(151)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_y_h,R30
	STS  _gyro_temp_y_h+1,R31
;    1696 	gyro_temp_y_h = gyro_temp_y_h & 0x0F;
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	STS  _gyro_temp_y_h,R30
	STS  _gyro_temp_y_h+1,R31
;    1697 	gyro_temp_y_l = spi(0b00010000);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_y_l,R30
	STS  _gyro_temp_y_l+1,R31
;    1698 	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1699 	
;    1700 	PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1701 	gyro_temp_x_h = spi(0b10000011);	//Init. reading of gyro Z
	LDI  R30,LOW(131)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_x_h,R30
	STS  _gyro_temp_x_h+1,R31
;    1702 	gyro_temp_x_h = gyro_temp_x_h & 0x0F;
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	STS  _gyro_temp_x_h,R30
	STS  _gyro_temp_x_h+1,R31
;    1703 	gyro_temp_x_l = spi(0b00010000);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _gyro_temp_x_l,R30
	STS  _gyro_temp_x_l+1,R31
;    1704 	PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer 
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1705   
;    1706 }                                              
	LD   R16,Y+
	RET
;    1707 
;    1708 
;    1709 //Init. the AD7927 ADC. We use ADC in normal mode and no sequencer operation
;    1710 void init_ADC(void)
;    1711 {
_init_ADC:
;    1712         PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1713         spi(0xFF);		//Dummy conversion
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
;    1714         spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
;    1715         PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1716         delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1717         PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1718         spi(0xFF);		//Dummy conversion
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
;    1719         spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
;    1720         PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1721         delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1722         PORTF = 0b00011001;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(25)
	STS  0x62,R30
;    1723         spi(0b10000011);        //Put ADC in the right mode and init. conversion of gyro X
	LDI  R30,LOW(131)
	ST   -Y,R30
	CALL _spi
;    1724         spi(0b00010000);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _spi
;    1725         PORTF = 0b00011101;  //CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1726         delay_ms(5); 
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1727 }
	RET
;    1728 
;    1729 //Init. the HMC6352 compass. Operational mode: 10Hz update (in cont. mode), periodic S/R on, standby mode
;    1730 void init_compass(void)
;    1731 {
_init_compass:
;    1732         i2c_start();
	CALL _i2c_start
;    1733         i2c_write(0x42);  	//write to kompass
	LDI  R30,LOW(66)
	ST   -Y,R30
	CALL _i2c_write
;    1734         i2c_write(0x47);  	//write to RAM ('G'-command)
	LDI  R30,LOW(71)
	ST   -Y,R30
	CALL _i2c_write
;    1735         delay_us(70);
	__DELAY_USB 187
;    1736         i2c_write(0x74);  	//write data to RAM-register 0x74 (Operational mode)
	LDI  R30,LOW(116)
	ST   -Y,R30
	CALL _i2c_write
;    1737         delay_us(70);
	__DELAY_USB 187
;    1738         i2c_write(0b01010000);  //Operational mode: 10Hz update (in cont. mode), periodic S/R on, standby mode
	LDI  R30,LOW(80)
	ST   -Y,R30
	CALL _i2c_write
;    1739         delay_us(70);
	__DELAY_USB 187
;    1740         i2c_stop();
	CALL _i2c_stop
;    1741         
;    1742         i2c_start();
	CALL _i2c_start
;    1743         i2c_write(0x42);  	//write to kompass
	LDI  R30,LOW(66)
	ST   -Y,R30
	CALL _i2c_write
;    1744         i2c_write(0x47);  	//write to RAM ('G'-command)
	LDI  R30,LOW(71)
	ST   -Y,R30
	CALL _i2c_write
;    1745         delay_us(70);
	__DELAY_USB 187
;    1746         i2c_write(0x4E);  	//write data to RAM-register 0x4E (output mode)
	LDI  R30,LOW(78)
	ST   -Y,R30
	CALL _i2c_write
;    1747         delay_us(70);
	__DELAY_USB 187
;    1748         i2c_write(0b00000000);  //Output mode: Heading
	CLR  R30
	ST   -Y,R30
	CALL _i2c_write
;    1749         delay_us(70);
	__DELAY_USB 187
;    1750         i2c_stop();
	CALL _i2c_stop
;    1751               
;    1752 	i2c_start();
	CALL _i2c_start
;    1753         i2c_write(0x42);  	// write to kompass
	LDI  R30,LOW(66)
	ST   -Y,R30
	CALL _i2c_write
;    1754         i2c_write(0x4F);  	// S/R now
	LDI  R30,LOW(79)
	ST   -Y,R30
	CALL _i2c_write
;    1755         delay_ms(8);
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1756         i2c_stop();
	CALL _i2c_stop
;    1757                 
;    1758 }                   
	RET
;    1759 
;    1760 //Read compass
;    1761 unsigned int read_compass(void)
;    1762 {
;    1763 unsigned char kompass_dum_h;
;    1764 unsigned char kompass_dum_l; 
;    1765 unsigned int kompass_dum;
;    1766                       
;    1767         i2c_start();
;	kompass_dum_h -> R16
;	kompass_dum_l -> R17
;	kompass_dum -> R18,R19
;    1768         delay_ms(1);
;    1769         i2c_write(0x42);  //Write to I2c slave 
;    1770         delay_ms(6);
;    1771         i2c_write(0x41);  // 'A'-command
;    1772         i2c_stop();        
;    1773         delay_ms(6);
;    1774         
;    1775         i2c_start();
;    1776         i2c_ack = i2c_write(0x43);  //Read from slave
;    1777         delay_ms(6);
;    1778         if(i2c_ack == 1)
;    1779                 {
;    1780                 kompass_dum_h = i2c_read(1);	  //read, og sender en ack-bit for  signalisere at jeg vil lese mer    
;    1781                 delay_ms(1);
;    1782                 kompass_dum_l = i2c_read(0);	  //read, 
;    1783                 delay_ms(1); 
;    1784                 }
;    1785         i2c_stop();
;    1786         delay_ms(1); 
;    1787         
;    1788         kompass_dum_h = kompass_dum_h & 0x0F;
;    1789         kompass_dum = (kompass_dum_h*256) + kompass_dum_l;
;    1790                      
;    1791  
;    1792 return kompass_dum;        
;    1793 }
;    1794 
;    1795 
;    1796 //Init accelerometer
;    1797 void init_aks(void)
;    1798 {
_init_aks:
;    1799       PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(28)
	STS  0x62,R30
;    1800       spi(0x20); 		//write ctrl1
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _spi
;    1801       spi(0xD7); 		//0xD7 in ctrl1
	LDI  R30,LOW(215)
	ST   -Y,R30
	CALL _spi
;    1802       PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1803       
;    1804       PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(28)
	STS  0x62,R30
;    1805       spi(0x21);  		//write ctrl2
	LDI  R30,LOW(33)
	ST   -Y,R30
	CALL _spi
;    1806       spi(0x40);  		//0x40 in ctrl2
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _spi
;    1807       PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1808 }
	RET
;    1809 
;    1810 //Read accelerometerdata
;    1811 void read_acc(void)
;    1812 {
_read_acc:
;    1813       PORTF = 0b00011100;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(28)
	STS  0x62,R30
;    1814       spi(0xE8); 		//read, with auto increment 
	LDI  R30,LOW(232)
	ST   -Y,R30
	CALL _spi
;    1815       acc_dum_l_x = spi(0x00);	//read OUTX_L
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_l_x,R30
	STS  _acc_dum_l_x+1,R31
;    1816       acc_dum_h_x = spi(0x00);	//read OUTX_H
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_h_x,R30
	STS  _acc_dum_h_x+1,R31
;    1817       acc_dum_l_y = spi(0x00);	//read OUTY_L
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_l_y,R30
	STS  _acc_dum_l_y+1,R31
;    1818       acc_dum_h_y = spi(0x00);	//read OUTY_H
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_h_y,R30
	STS  _acc_dum_h_y+1,R31
;    1819       acc_dum_l_z = spi(0x00);	//read OUTZ_L
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_l_z,R30
	STS  _acc_dum_l_z+1,R31
;    1820       acc_dum_h_z = spi(0x00);	//read OUTZ_H	
	CLR  R30
	ST   -Y,R30
	CALL _spi
	CLR  R31
	STS  _acc_dum_h_z,R30
	STS  _acc_dum_h_z+1,R31
;    1821       PORTF = 0b00011101;  	//CS on the voltage regulators, ADC and accelerometer
	LDI  R30,LOW(29)
	STS  0x62,R30
;    1822 }
	RET
;    1823 /************************************************************************** 
;    1824 Name: 		filter.c
;    1825 Comments:	Moving average routines
;    1826 **************************************************************************/
;    1827 
;    1828 #include "filter.h"
;    1829 
;    1830 void moving_average_gyro(void)
;    1831 {
;    1832 gyro_X_H_akse = average_1(gyro_X_H_akse);
;    1833 gyro_X_L_akse = average_2(gyro_X_L_akse);	
;    1834 gyro_Y_H_akse = average_3(gyro_Y_H_akse);
;    1835 gyro_Y_L_akse = average_4(gyro_Y_L_akse);
;    1836 gyro_Z_H_akse = average_5(gyro_Z_H_akse);
;    1837 gyro_Z_L_akse = average_6(gyro_Z_L_akse);
;    1838 }
;    1839 
;    1840 
;    1841 /*
;    1842 // 5-point moving average
;    1843  
;    1844 unsigned short int average_1(unsigned short int data)
;    1845 {
;    1846 unsigned short int average_data;
;    1847 
;    1848 gyro_vekt_1[4] = gyro_vekt_1[3];
;    1849 gyro_vekt_1[3] = gyro_vekt_1[2];
;    1850 gyro_vekt_1[2] = gyro_vekt_1[1];
;    1851 gyro_vekt_1[1] = gyro_vekt_1[0];
;    1852 gyro_vekt_1[0] = data;
;    1853 average_data = ( gyro_vekt_1[0] + gyro_vekt_1[1] + gyro_vekt_1[2] + gyro_vekt_1[3] + gyro_vekt_1[4] )/5;//  + gyro_vekt_1[5] + gyro_vekt_1[6] + gyro_vekt_1[7] + gyro_vekt_1[8] + gyro_vekt_1[9] ) /10;
;    1854 return average_data;
;    1855 }
;    1856 
;    1857 unsigned short int average_2(unsigned short int data)
;    1858 {
;    1859 unsigned short int average_data;
;    1860 
;    1861 gyro_vekt_2[4] = gyro_vekt_2[3];
;    1862 gyro_vekt_2[3] = gyro_vekt_2[2];
;    1863 gyro_vekt_2[2] = gyro_vekt_2[1];
;    1864 gyro_vekt_2[1] = gyro_vekt_2[0];
;    1865 gyro_vekt_2[0] = data;
;    1866 average_data = ( gyro_vekt_2[0] + gyro_vekt_2[1] + gyro_vekt_2[2] + gyro_vekt_2[3] + gyro_vekt_2[4] )/5;// + gyro_vekt_2[5] + gyro_vekt_2[6] + gyro_vekt_2[7] + gyro_vekt_2[8] + gyro_vekt_2[9] ) /
;    1867 return average_data;
;    1868 }
;    1869 
;    1870 unsigned short int average_3(unsigned short int data)
;    1871 {
;    1872 unsigned short int average_data;
;    1873 
;    1874 gyro_vekt_3[4] = gyro_vekt_3[3];
;    1875 gyro_vekt_3[3] = gyro_vekt_3[2];
;    1876 gyro_vekt_3[2] = gyro_vekt_3[1];
;    1877 gyro_vekt_3[1] = gyro_vekt_3[0];
;    1878 gyro_vekt_3[0] = data;
;    1879 average_data = ( gyro_vekt_3[0] + gyro_vekt_3[1] + gyro_vekt_3[2] + gyro_vekt_3[3] + gyro_vekt_3[4] )/5;// + gyro_vekt_3[5] + gyro_vekt_3[6] + gyro_vekt_3[7] + gyro_vekt_3[8] + gyro_vekt_3[9] ) /10;
;    1880 return average_data;
;    1881 }
;    1882 
;    1883 unsigned short int average_4(unsigned short int data)
;    1884 {
;    1885 unsigned short int average_data;
;    1886 
;    1887 gyro_vekt_4[4] = gyro_vekt_4[3];
;    1888 gyro_vekt_4[3] = gyro_vekt_4[2];
;    1889 gyro_vekt_4[2] = gyro_vekt_4[1];
;    1890 gyro_vekt_4[1] = gyro_vekt_4[0];
;    1891 gyro_vekt_4[0] = data;
;    1892 average_data = ( gyro_vekt_4[0] + gyro_vekt_4[1] + gyro_vekt_4[2] + gyro_vekt_4[3] + gyro_vekt_4[4] )/5;// + gyro_vekt_4[5] + gyro_vekt_4[6] + gyro_vekt_4[7] + gyro_vekt_4[8] + gyro_vekt_4[9] ) /10;
;    1893 return average_data;
;    1894 }
;    1895 
;    1896 unsigned short int average_5(unsigned short int data)
;    1897 {
;    1898 unsigned short int average_data;
;    1899 
;    1900 gyro_vekt_5[4] = gyro_vekt_5[3];
;    1901 gyro_vekt_5[3] = gyro_vekt_5[2];
;    1902 gyro_vekt_5[2] = gyro_vekt_5[1];
;    1903 gyro_vekt_5[1] = gyro_vekt_5[0];
;    1904 gyro_vekt_5[0] = data;
;    1905 average_data = ( gyro_vekt_5[0] + gyro_vekt_5[1] + gyro_vekt_5[2] + gyro_vekt_5[3] + gyro_vekt_5[4] )/5;// + gyro_vekt_5[5] + gyro_vekt_5[6] + gyro_vekt_5[7] + gyro_vekt_5[8] + gyro_vekt_5[9] ) /10;
;    1906 return average_data;
;    1907 }   
;    1908 
;    1909 unsigned short int average_6(unsigned short int data)
;    1910 {
;    1911 unsigned short int average_data;
;    1912 
;    1913 gyro_vekt_6[4] = gyro_vekt_6[3];
;    1914 gyro_vekt_6[3] = gyro_vekt_6[2];
;    1915 gyro_vekt_6[2] = gyro_vekt_6[1];
;    1916 gyro_vekt_6[1] = gyro_vekt_6[0];
;    1917 gyro_vekt_6[0] = data;
;    1918 average_data = ( gyro_vekt_6[0] + gyro_vekt_6[1] + gyro_vekt_6[2] + gyro_vekt_6[3] + gyro_vekt_6[4] )/5;// + gyro_vekt_6[5] + gyro_vekt_6[6] + gyro_vekt_6[7] + gyro_vekt_6[8] + gyro_vekt_6[9] ) /10;
;    1919 return average_data;
;    1920 }
;    1921    */  
;    1922 
;    1923 
;    1924 // 10-point moving average
;    1925  
;    1926 unsigned short int average_1(unsigned short int data)
;    1927 {
;    1928 unsigned short int average_data;
;    1929 
;    1930 gyro_vekt_1[9] = gyro_vekt_1[8];
;	data -> Y+2
;	average_data -> R16,R17
;    1931 gyro_vekt_1[8] = gyro_vekt_1[7];
;    1932 gyro_vekt_1[7] = gyro_vekt_1[6];
;    1933 gyro_vekt_1[6] = gyro_vekt_1[5];
;    1934 gyro_vekt_1[5] = gyro_vekt_1[4]; 
;    1935 gyro_vekt_1[4] = gyro_vekt_1[3];
;    1936 gyro_vekt_1[3] = gyro_vekt_1[2];
;    1937 gyro_vekt_1[2] = gyro_vekt_1[1];
;    1938 gyro_vekt_1[1] = gyro_vekt_1[0];
;    1939 gyro_vekt_1[0] = data;
;    1940 average_data = ( gyro_vekt_1[0] + gyro_vekt_1[1] + gyro_vekt_1[2] + gyro_vekt_1[3] + gyro_vekt_1[4]  + gyro_vekt_1[5] + gyro_vekt_1[6] + gyro_vekt_1[7] + gyro_vekt_1[8] + gyro_vekt_1[9] ) /10;
;    1941 return average_data;
;    1942 }
;    1943 
;    1944 unsigned short int average_2(unsigned short int data)
;    1945 {
;    1946 unsigned short int average_data;
;    1947 
;    1948 gyro_vekt_2[9] = gyro_vekt_2[8];
;	data -> Y+2
;	average_data -> R16,R17
;    1949 gyro_vekt_2[8] = gyro_vekt_2[7];
;    1950 gyro_vekt_2[7] = gyro_vekt_2[6];
;    1951 gyro_vekt_2[6] = gyro_vekt_2[5];
;    1952 gyro_vekt_2[5] = gyro_vekt_2[4]; 
;    1953 gyro_vekt_2[4] = gyro_vekt_2[3];
;    1954 gyro_vekt_2[3] = gyro_vekt_2[2];
;    1955 gyro_vekt_2[2] = gyro_vekt_2[1];
;    1956 gyro_vekt_2[1] = gyro_vekt_2[0];
;    1957 gyro_vekt_2[0] = data;
;    1958 average_data = ( gyro_vekt_2[0] + gyro_vekt_2[1] + gyro_vekt_2[2] + gyro_vekt_2[3] + gyro_vekt_2[4] + gyro_vekt_2[5] + gyro_vekt_2[6] + gyro_vekt_2[7] + gyro_vekt_2[8] + gyro_vekt_2[9] ) /10;
;    1959 return average_data;
;    1960 }
;    1961 
;    1962 unsigned short int average_3(unsigned short int data)
;    1963 {
;    1964 unsigned short int average_data;
;    1965 
;    1966 gyro_vekt_3[9] = gyro_vekt_3[8];
;	data -> Y+2
;	average_data -> R16,R17
;    1967 gyro_vekt_3[8] = gyro_vekt_3[7];
;    1968 gyro_vekt_3[7] = gyro_vekt_3[6];
;    1969 gyro_vekt_3[6] = gyro_vekt_3[5];
;    1970 gyro_vekt_3[5] = gyro_vekt_3[4];
;    1971 gyro_vekt_3[4] = gyro_vekt_3[3];
;    1972 gyro_vekt_3[3] = gyro_vekt_3[2];
;    1973 gyro_vekt_3[2] = gyro_vekt_3[1];
;    1974 gyro_vekt_3[1] = gyro_vekt_3[0];
;    1975 gyro_vekt_3[0] = data;
;    1976 average_data = ( gyro_vekt_3[0] + gyro_vekt_3[1] + gyro_vekt_3[2] + gyro_vekt_3[3] + gyro_vekt_3[4] + gyro_vekt_3[5] + gyro_vekt_3[6] + gyro_vekt_3[7] + gyro_vekt_3[8] + gyro_vekt_3[9] ) /10;
;    1977 return average_data;
;    1978 }
;    1979 
;    1980 unsigned short int average_4(unsigned short int data)
;    1981 {
;    1982 unsigned short int average_data;
;    1983 
;    1984 gyro_vekt_4[9] = gyro_vekt_4[8];
;	data -> Y+2
;	average_data -> R16,R17
;    1985 gyro_vekt_4[8] = gyro_vekt_4[7];
;    1986 gyro_vekt_4[7] = gyro_vekt_4[6];
;    1987 gyro_vekt_4[6] = gyro_vekt_4[5];
;    1988 gyro_vekt_4[5] = gyro_vekt_4[4]; 
;    1989 gyro_vekt_4[4] = gyro_vekt_4[3];
;    1990 gyro_vekt_4[3] = gyro_vekt_4[2];
;    1991 gyro_vekt_4[2] = gyro_vekt_4[1];
;    1992 gyro_vekt_4[1] = gyro_vekt_4[0];
;    1993 gyro_vekt_4[0] = data;
;    1994 average_data = ( gyro_vekt_4[0] + gyro_vekt_4[1] + gyro_vekt_4[2] + gyro_vekt_4[3] + gyro_vekt_4[4] + gyro_vekt_4[5] + gyro_vekt_4[6] + gyro_vekt_4[7] + gyro_vekt_4[8] + gyro_vekt_4[9] ) /10;
;    1995 return average_data;
;    1996 }
;    1997 
;    1998 unsigned short int average_5(unsigned short int data)
;    1999 {
;    2000 unsigned short int average_data;
;    2001 
;    2002 gyro_vekt_5[9] = gyro_vekt_5[8];
;	data -> Y+2
;	average_data -> R16,R17
;    2003 gyro_vekt_5[8] = gyro_vekt_5[7];
;    2004 gyro_vekt_5[7] = gyro_vekt_5[6];
;    2005 gyro_vekt_5[6] = gyro_vekt_5[5];
;    2006 gyro_vekt_5[5] = gyro_vekt_5[4]; 
;    2007 gyro_vekt_5[4] = gyro_vekt_5[3];
;    2008 gyro_vekt_5[3] = gyro_vekt_5[2];
;    2009 gyro_vekt_5[2] = gyro_vekt_5[1];
;    2010 gyro_vekt_5[1] = gyro_vekt_5[0];
;    2011 gyro_vekt_5[0] = data;
;    2012 average_data = ( gyro_vekt_5[0] + gyro_vekt_5[1] + gyro_vekt_5[2] + gyro_vekt_5[3] + gyro_vekt_5[4] + gyro_vekt_5[5] + gyro_vekt_5[6] + gyro_vekt_5[7] + gyro_vekt_5[8] + gyro_vekt_5[9] ) /10;
;    2013 return average_data;
;    2014 }   
;    2015 
;    2016 unsigned short int average_6(unsigned short int data)
;    2017 {
;    2018 unsigned short int average_data;
;    2019 
;    2020 gyro_vekt_6[9] = gyro_vekt_6[8];
;	data -> Y+2
;	average_data -> R16,R17
;    2021 gyro_vekt_6[8] = gyro_vekt_6[7];
;    2022 gyro_vekt_6[7] = gyro_vekt_6[6];
;    2023 gyro_vekt_6[6] = gyro_vekt_6[5];
;    2024 gyro_vekt_6[5] = gyro_vekt_6[4]; 
;    2025 gyro_vekt_6[4] = gyro_vekt_6[3];
;    2026 gyro_vekt_6[3] = gyro_vekt_6[2];
;    2027 gyro_vekt_6[2] = gyro_vekt_6[1];
;    2028 gyro_vekt_6[1] = gyro_vekt_6[0];
;    2029 gyro_vekt_6[0] = data;
;    2030 average_data = ( gyro_vekt_6[0] + gyro_vekt_6[1] + gyro_vekt_6[2] + gyro_vekt_6[3] + gyro_vekt_6[4] + gyro_vekt_6[5] + gyro_vekt_6[6] + gyro_vekt_6[7] + gyro_vekt_6[8] + gyro_vekt_6[9] ) /10;
;    2031 return average_data;
;    2032 }
;    2033 /************************************************************************** 
;    2034 Name: 		isr.c
;    2035 Comments:	All ISR's (Interrupt Service Routine)
;    2036 **************************************************************************/
;    2037 
;    2038 #include "isr.h"
;    2039 #include "imu.h"
;    2040 #include <stdio.h>
;    2041 #include <mega128.h>
;    2042 //#include "flash.h"
;    2043 
;    2044 extern volatile unsigned int samples_teller;
;    2045 
;    2046 volatile unsigned char rec_matlab = 0;

	.DSEG
_rec_matlab:
	.BYTE 0x1
;    2047 
;    2048 // External Interrupt 4 service routine
;    2049 interrupt [EXT_INT4] void ext_int4_isr(void)
;    2050 {

	.CSEG
_ext_int4_isr:
	CALL __SAVEISR
;    2051 
;    2052 delay_ms(500);	//delay to prevent the issues from button-bouncing
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    2053 rec_matlab = start_send;
	LDI  R30,LOW(55)
	STS  _rec_matlab,R30
;    2054 start_of_transmission = 1;
	SET
	BLD  R2,0
;    2055 samples_teller = 0;
	CLR  R30
	STS  _samples_teller,R30
	STS  _samples_teller+1,R30
;    2056 ms = 0;
	CLR  R30
	STS  _ms,R30
	STS  _ms+1,R30
;    2057 TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;    2058 }
	CALL __LOADISR
	RETI
;    2059 
;    2060 // External Interrupt 5 service routine
;    2061 interrupt [EXT_INT5] void ext_int5_isr(void)
;    2062 {
_ext_int5_isr:
	CALL __SAVEISR
;    2063 rec_matlab = stop_send;
	LDI  R30,LOW(56)
	STS  _rec_matlab,R30
;    2064 
;    2065 
;    2066 }
	CALL __LOADISR
	RETI
;    2067 
;    2068 // External Interrupt 6 service routine
;    2069 interrupt [EXT_INT6] void ext_int6_isr(void)
;    2070 {
_ext_int6_isr:
	CALL __SAVEISR
;    2071 
;    2072 }
	CALL __LOADISR
	RETI
;    2073 
;    2074 // External Interrupt 7 service routine
;    2075 interrupt [EXT_INT7] void ext_int7_isr(void)
;    2076 {
_ext_int7_isr:
	CALL __SAVEISR
;    2077 
;    2078 
;    2079 }
	CALL __LOADISR
	RETI
;    2080 
;    2081 
;    2082 // USART1 Receiver interrupt service routine
;    2083 // Recieve from PC(Matlab) via USB
;    2084 #pragma savereg-
;    2085 interrupt [USART1_RXC] void uart1_rx_isr(void)
;    2086 {
_uart1_rx_isr:
;    2087 char status,data;
;    2088 #asm
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	data -> R17
;    2089     push r26
    push r26
;    2090     push r27
    push r27
;    2091     push r30
    push r30
;    2092     push r31
    push r31
;    2093     in   r26,sreg
    in   r26,sreg
;    2094     push r26
    push r26
;    2095 #endasm

;    2096 status=UCSR1A;
	LDS  R16,155
;    2097 data=UDR1;
	LDS  R17,156
;    2098 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BRNE _0xD2
;    2099         {
;    2100         rec_matlab=data;
	STS  _rec_matlab,R17
;    2101         }
;    2102 if(rec_matlab == start_send)
_0xD2:
	LDS  R26,_rec_matlab
	CPI  R26,LOW(0x37)
	BRNE _0xD3
;    2103         {
;    2104         start_of_transmission = 1;
	SET
	BLD  R2,0
;    2105         samples_teller = 0;
	CLR  R30
	STS  _samples_teller,R30
	STS  _samples_teller+1,R30
;    2106         ms = 0;
	CLR  R30
	STS  _ms,R30
	STS  _ms+1,R30
;    2107         TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;    2108         }
;    2109 #asm
_0xD3:
;    2110     pop  r26
    pop  r26
;    2111     out  sreg,r26
    out  sreg,r26
;    2112     pop  r31
    pop  r31
;    2113     pop  r30
    pop  r30
;    2114     pop  r27
    pop  r27
;    2115     pop  r26
    pop  r26
;    2116 #endasm

;    2117 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;    2118 #pragma savereg+ 
;    2119 
;    2120 
;    2121         
;    2122 /// USART1 Transmitter interrupt service routine 
;    2123 // Transmit to PC via USB
;    2124 #pragma savereg-
;    2125 interrupt [USART1_DRE] void uart1_dre_isr(void)
;    2126 {
_uart1_dre_isr:
;    2127 #asm
;    2128     push r26
    push r26
;    2129     push r27
    push r27
;    2130     push r30
    push r30
;    2131     push r31
    push r31
;    2132     in   r26,sreg
    in   r26,sreg
;    2133     push r26
    push r26
;    2134 #endasm

;    2135 {
;    2136 UDR1 = imu_data[imu_data_teller];
	LDS  R30,_imu_data_teller
	CLR  R31
	SUBI R30,LOW(-_imu_data)
	SBCI R31,HIGH(-_imu_data)
	LD   R30,Z
	STS  0x9C,R30
;    2137 imu_data_teller++;
	LDS  R30,_imu_data_teller
	SUBI R30,-LOW(1)
	STS  _imu_data_teller,R30
;    2138 if(imu_data_teller > 11)//0 - 5 is acc data, 6 t.o.m. 11 er gyro data, 12 tom 17 er gyrtemp, 18 t.o.m 19 er samples_teller
	LDS  R26,_imu_data_teller
	LDI  R30,LOW(11)
	CP   R30,R26
	BRSH _0xD5
;    2139         {
;    2140         imu_data_teller  = 0;
	CLR  R30
	STS  _imu_data_teller,R30
;    2141 	UCSR1B = 0x98;	//disable UDR1E isr
	LDI  R30,LOW(152)
	STS  0x9A,R30
;    2142 	timer1_isr = 0;
	CLR  R30
	STS  _timer1_isr,R30
;    2143         }
;    2144 }
_0xD5:
;    2145        
;    2146 #asm
;    2147     pop  r26
    pop  r26
;    2148     out  sreg,r26
    out  sreg,r26
;    2149     pop  r31
    pop  r31
;    2150     pop  r30
    pop  r30
;    2151     pop  r27
    pop  r27
;    2152     pop  r26
    pop  r26
;    2153 #endasm 

;    2154 
;    2155 }
	RETI
;    2156 #pragma savereg+
;    2157             
;    2158 
;    2159 // Timer 1 output compare A interrupt service routine
;    2160 // Samples the sensors, 100 Hz.
;    2161 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;    2162 {             
_timer1_compa_isr:
	CALL __SAVEISR
;    2163 //Les gyro XYZ og midle 5 mlinger 
;    2164 SPCR=0x54;             
	LDI  R30,LOW(84)
	OUT  0xD,R30
;    2165 read_gyros();
	CALL _read_gyros
;    2166 //Read acc
;    2167 SPCR=0x5C;
	LDI  R30,LOW(92)
	OUT  0xD,R30
;    2168 read_acc();
	CALL _read_acc
;    2169 timer1_isr = 1;
	LDI  R30,LOW(1)
	STS  _timer1_isr,R30
;    2170 samples_teller++;
	LDS  R30,_samples_teller
	LDS  R31,_samples_teller+1
	ADIW R30,1
	STS  _samples_teller,R30
	STS  _samples_teller+1,R31
;    2171 
;    2172 }
	CALL __LOADISR
	RETI
;    2173 
;    2174 // Timer 0 output compare interrupt service routine 
;    2175 // RTC
;    2176 interrupt [TIM0_COMP] void timer0_comp_isr(void)
;    2177 {
_timer0_comp_isr:
	CALL __SAVEISR
;    2178 static char LeapMonth;

	.DSEG
_LeapMonth_S1B:
	.BYTE 0x1

	.CSEG
;    2179 
;    2180 ms++;
	LDS  R30,_ms
	LDS  R31,_ms+1
	ADIW R30,1
	STS  _ms,R30
	STS  _ms+1,R31
;    2181 if (ms == 10000)
	LDS  R26,_ms
	LDS  R27,_ms+1
	CPI  R26,LOW(0x2710)
	LDI  R30,HIGH(0x2710)
	CPC  R27,R30
	BRNE _0xD8
;    2182 	{
;    2183 	ms = 0;
	CLR  R30
	STS  _ms,R30
	STS  _ms+1,R30
;    2184        //	SECOND++;   // increment second
;    2185 	}
;    2186 /*
;    2187 if (SECOND == 60)
;    2188 	{
;    2189         SECOND = 0;
;    2190         MINUTE++;
;    2191         
;    2192         if (MINUTE > 59)
;    2193         	{
;    2194             	MINUTE = 0;
;    2195             	HOUR++;
;    2196             
;    2197             	if (HOUR > 23)
;    2198                     	{
;    2199                         HOUR = 0;
;    2200                         DAY++;
;    2201         
;    2202                         // Check for leap year if month == February
;    2203                         if (MONTH == 2)
;    2204                             	{
;    2205                             	if (!(YEAR & 0x0003))  
;    2206                                 	{
;    2207                                 	if (YEAR%100 == 0)
;    2208                                     		{
;    2209                                     		if (YEAR%400 == 0)
;    2210                                         		{LeapMonth = 1;}
;    2211         		                        else
;    2212                         		                {LeapMonth = 0;}
;    2213                                     		}
;    2214                                 	else
;    2215                                     		{LeapMonth = 1;}
;    2216                                 	}
;    2217                             	else
;    2218                                 	{LeapMonth = 0;}
;    2219                             	}
;    2220                         else
;    2221                             	{LeapMonth = 0;}
;    2222         
;    2223                         // Check for month length
;    2224                         if (DAY > (MonthLength[MONTH] + LeapMonth))
;    2225         	                {
;    2226                 	        DAY = 1;
;    2227                         	MONTH++;
;    2228         
;    2229                             	if (MONTH > 12)
;    2230                             		{
;    2231                                 	MONTH = 1;
;    2232                                 	YEAR++;
;    2233         		                }
;    2234                         	}
;    2235                     	}
;    2236         	}
;    2237     	}
;    2238     	*/
;    2239 }
_0xD8:
	CALL __LOADISR
	RETI
;    2240 /************************************************************************** 
;    2241 Name: 		flash.c
;    2242 Comments:	Functions for initializing, writing to and reading 
;    2243 		the M25P80 FLASH-memory from ST.
;    2244 **************************************************************************/ 
;    2245 
;    2246 #include <mega128.h>
;    2247 #include <delay.h>
;    2248 #include <spi.h>
;    2249 #include "flash.h"
;    2250 #include "isr.h"
;    2251 
;    2252 
;    2253 //Check the statusregister and wait until flash is ready
;    2254 void wait_flash_rdy(void)
;    2255 {
;    2256 unsigned char status = 0;
;    2257 unsigned char klar = 0x01;
;    2258 
;    2259 ACTIVATE_FLASH;
;	status -> R16
;	klar -> R17
;    2260 spi(RDSR);
;    2261 while (klar == 0x01)
;    2262 	{
;    2263 	status = spi(0x00);
;    2264 	klar = (status & 0x01);
;    2265 	}
;    2266 DEACTIVATE_FLASH;
;    2267 }
;    2268 
;    2269 
;    2270 //Write enable
;    2271 void write_enable(void)
;    2272 {
;    2273 ACTIVATE_FLASH;
;    2274 spi(WREN);
;    2275 DEACTIVATE_FLASH;
;    2276 }
;    2277 
;    2278 
;    2279 //Write disable   
;    2280 //Not in use
;    2281 void write_disable(void)
;    2282 {
;    2283 ACTIVATE_FLASH;
;    2284 spi(WRDI);
;    2285 DEACTIVATE_FLASH;
;    2286 }
;    2287 
;    2288 
;    2289 //Pageprogram in flash 
;    2290 //Programs one byte at a time.
;    2291 void PageProgram(char data, unsigned long int adress)
;    2292 {
;    2293 wait_flash_rdy();
;    2294 
;    2295 write_enable();
;    2296 
;    2297 ACTIVATE_FLASH;
;    2298 spi(PP);
;    2299 spi(adress>>16);
;    2300 spi(adress>>8);
;    2301 spi(adress);
;    2302 spi(data);	
;    2303 DEACTIVATE_FLASH;
;    2304 }
;    2305  
;    2306 
;    2307 //Delete the flash 
;    2308 //This takes a long time..    10+ sec
;    2309 void bulk_erase(void)
;    2310 {
;    2311 wait_flash_rdy();
;    2312 
;    2313 write_enable();
;    2314 
;    2315 //BULK ERASE
;    2316 ACTIVATE_FLASH;
;    2317 spi(BE);
;    2318 DEACTIVATE_FLASH;
;    2319 wait_flash_rdy();
;    2320 }
;    2321 
;    2322 
;    2323 //Read flash page by page (not in use).
;    2324 void flash_page_to_UART(int page_nr)
;    2325 {
;    2326 unsigned char i, data;
;    2327 unsigned long int start_adress;
;    2328 
;    2329 start_adress = (page_nr*256);
;	page_nr -> Y+6
;	i -> R16
;	data -> R17
;	start_adress -> Y+2
;    2330 
;    2331 wait_flash_rdy();
;    2332 
;    2333 ACTIVATE_FLASH;
;    2334 spi(READ);
;    2335 spi(start_adress>>16);
;    2336 spi(start_adress>>8);
;    2337 spi(start_adress);
;    2338 for(i=0; i<255; i++)
;    2339 	{
;    2340 	data=spi(0x00);
;    2341 	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
;    2342         UDR1=data;
;    2343 	}	
;    2344 DEACTIVATE_FLASH;
;    2345 }
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_spi:
	ld   r30,y+
	out  spdr,r30
__spi0:
	sbis spsr,7
	rjmp __spi0
	in   r30,spdr
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

