;CodeVisionAVR C Compiler V1.23.7 Standard
;(C) Copyright 1998-2002 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega128
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;Internal SRAM size  : 4096
;External SRAM size  : 0
;Data Stack size     : 1024
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C
	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 /**************************************************************************
;       2 Project : PicoTracker (Prosjektoppgave)
;       3 Version : 3
;       4 Date    : 14.11.2005
;       5 Author  : Tore Johan Hilund and Tor Ivar Hystad         
;       6 Company : NTNU and FFI  
;       7 Compiler: CodeVisionAVR V1.23.7 Standard
;       8 
;       9 Chip type           : ATmega128
;      10 Program type        : Application
;      11 Clock frequency     : 8,000000 MHz
;      12 Memory model        : Small
;      13 Internal SRAM size  : 4096
;      14 External SRAM size  : 0
;      15 Data Stack size     : 1024
;      16 **************************************************************************/
;      17 
;      18 #include <mega128.h>
;      19 #include <delay.h>
;      20 #include <spi.h>
;      21 #include <string.h>
;      22 #include <stdlib.h>
;      23 #include "flash.h"
;      24 #include "display.h"
;      25 #include "nmea.h"
;      26 #include "time.h"
;      27 
;      28 #define RXB8 1
;      29 #define TXB8 0
;      30 #define UPE 2
;      31 #define OVR 3
;      32 #define FE 4
;      33 //#define UDRE 5
;      34 #define RXC 7
;      35 
;      36 #define FRAMING_ERROR (1<<FE)
;      37 #define PARITY_ERROR (1<<UPE)
;      38 #define DATA_OVERRUN (1<<OVR)
;      39 //#define DATA_REGISTER_EMPTY (1<<UDRE)
;      40 #define RX_COMPLETE (1<<RXC)
;      41 
;      42 #define END_NMEA 0xA
;      43 #define CR 0xD
;      44 #define START_NMEA '$'
;      45 #define flash_size 1048500 //really 1048576 bytes, but use 1048500 for safety reasons
;      46 
;      47 //battery defines
;      48 #define charge_disable PORTB.7=1  
;      49 #define charge_enable PORTB.7=0
;      50 #define charge_current_high PORTG.1=1
;      51 #define charge_current_low PORTG.1=0
;      52 #define TTE_enable PORTB.6=0
;      53 #define TTE_disable PORTB.6=1
;      54 #define STAT1 PORTB.4
;      55 #define STAT2 PORTB.5
;      56 
;      57 //Functions in main.c
;      58 char CHAR2BCD2(char input);
;      59 void charger(void);
;      60 void check_batt(void);
;      61 
;      62 //BRUKES IKKE 
;      63 //void find_start_adresse(void); 
;      64 
;      65 // Global variables
;      66 unsigned char index1, nmeaID;
;      67 
;      68 //Variable til/fra ISR
;      69 volatile char nmea_data[82];
_nmea_data:
	.BYTE 0x52
;      70 volatile char index;
_index:
	.BYTE 0x1
;      71 volatile char temp_data[82];
_temp_data:
	.BYTE 0x52
;      72 volatile char i;
_i:
	.BYTE 0x1
;      73 volatile char tracking;
_tracking:
	.BYTE 0x1
;      74 volatile char flash_delete = 0;
_flash_delete:
	.BYTE 0x1
;      75 volatile char transmit_USB = 0;
_transmit_USB:
	.BYTE 0x1
;      76 volatile char transmit_USB_complete = 0;
_transmit_USB_complete:
	.BYTE 0x1
;      77 unsigned char start_transmit = 0;
;      78 
;      79 //Tracking variable
;      80 unsigned char tracking_pkt_buf[tracking_index];
_tracking_pkt_buf:
	.BYTE 0x27
;      81 unsigned char tracking_pkt[tracking_index];
_tracking_pkt:
	.BYTE 0x27
;      82 unsigned char UTC[6];
_UTC:
	.BYTE 0x6
;      83 unsigned char LAT[10];
_LAT:
	.BYTE 0xA
;      84 unsigned char LON[11];
_LON:
	.BYTE 0xB
;      85 unsigned char DATE[10];
_DATE:
	.BYTE 0xA
;      86 unsigned char SPEED[6];
_SPEED:
	.BYTE 0x6
;      87 unsigned char COURSE[5];
_COURSE:
	.BYTE 0x5
;      88 unsigned char valid_nmea = 0;
;      89 
;      90 unsigned char FLASH_full = 0;
;      91 volatile unsigned char new_msg = 0;
_new_msg:
	.BYTE 0x1
;      92 unsigned char new_nmea_data;
;      93 unsigned char unread_nmea_msg = 0;
;      94 volatile unsigned long int adresse; 
_adresse:
	.BYTE 0x4
;      95 
;      96 //This is the adress for storing in ext. flash, 
;      97 //this adress has to be stored in a non-volatile memory
;      98 volatile eeprom unsigned long int start_adresse;

	.ESEG
_start_adresse:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
;      99    
;     100 //Battery
;     101 volatile unsigned int volt;

	.DSEG
_volt:
	.BYTE 0x2
;     102 unsigned char charge = 0;
;     103 //RTC
;     104 unsigned char SECOND;
;     105 unsigned char MINUTE;
;     106 unsigned char HOUR;
;     107 unsigned char DAY;
_DAY:
	.BYTE 0x1
;     108 unsigned char MONTH;
_MONTH:
	.BYTE 0x1
;     109 unsigned int YEAR;
_YEAR:
	.BYTE 0x2
;     110 char MonthLength[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
_MonthLength:
	.BYTE 0xD
;     111 
;     112 
;     113 void main(void)
;     114 {

	.CSEG
_main:
;     115 #asm ("cli");	//Globaly disable interrupts (ISR) during initializing
	cli
;     116 
;     117 delay_ms(1000);    //wait for external 32KHz xtal to stabilize
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     118 
;     119 //0=inn 1=ut
;     120 
;     121 //PORTA er ut, kontrollsignaler til display
;     122 PORTA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     123 DDRA=0xFF;
	OUT  0x1A,R30
;     124 
;     125 // Port B initialization
;     126 PORTB=0xFF;
	OUT  0x18,R30
;     127 DDRB=0xC7;
	LDI  R30,LOW(199)
	OUT  0x17,R30
;     128 
;     129 // PORTC er ut, datasignaler til display
;     130 PORTC=0x00;
	CLR  R30
	OUT  0x15,R30
;     131 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     132 
;     133 // Port D initialization
;     134 PORTD=0x00;
	CLR  R30
	OUT  0x12,R30
;     135 DDRD=0x78;   //PD0 og PD1 PD4 er utgang
	LDI  R30,LOW(120)
	OUT  0x11,R30
;     136 
;     137 // Port E initialization
;     138 PORTE=0xFF;         //enable pull-ups
	LDI  R30,LOW(255)
	OUT  0x3,R30
;     139 DDRE=0x00;
	CLR  R30
	OUT  0x2,R30
;     140 
;     141 // Port F initialization   //for future INS use
;     142 PORTF=0x00;
	STS  0x62,R30
;     143 DDRF=0x00;
	STS  0x61,R30
;     144 
;     145 // Port G initialization   UT
;     146 PORTG=0x04;
	LDI  R30,LOW(4)
	STS  0x65,R30
;     147 DDRG=0x7;
	LDI  R30,LOW(7)
	STS  0x64,R30
;     148 
;     149 // Timer/Counter 0 initialization
;     150 // Clock source: TOSC1 pin
;     151 // Clock value: TOSC1/128
;     152 // Mode: Normal top=FFh
;     153 // OC0 output: Disconnected
;     154 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x30,R30
;     155 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     156 TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;     157 OCR0=0x00;
	OUT  0x31,R30
;     158 
;     159 // Timer(s)/Counter(s) Interrupt(s) initialization
;     160 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x37,R30
;     161 ETIMSK=0x00;
	CLR  R30
	STS  0x7D,R30
;     162 
;     163 // Timer/Counter 1 initialization
;     164 // Clock source: System Clock
;     165 // Clock value: Timer 1 Stopped
;     166 // Mode: Normal top=FFFFh
;     167 // OC1A output: Discon.
;     168 // OC1B output: Discon.
;     169 // OC1C output: Discon.
;     170 // Noise Canceler: Off
;     171 // Input Capture on Falling Edge
;     172 TCCR1A=0x00;
	OUT  0x2F,R30
;     173 TCCR1B=0x00;
	OUT  0x2E,R30
;     174 TCNT1H=0x00;
	OUT  0x2D,R30
;     175 TCNT1L=0x00;
	OUT  0x2C,R30
;     176 OCR1AH=0x00;
	OUT  0x2B,R30
;     177 OCR1AL=0x00;
	OUT  0x2A,R30
;     178 OCR1BH=0x00;
	OUT  0x29,R30
;     179 OCR1BL=0x00;
	OUT  0x28,R30
;     180 OCR1CH=0x00;
	STS  0x79,R30
;     181 OCR1CL=0x00;
	STS  0x78,R30
;     182 
;     183 // Timer/Counter 2 initialization
;     184 // Clock source: System Clock
;     185 // Clock value: Timer 2 Stopped
;     186 // Mode: Normal top=FFh
;     187 // OC2 output: Disconnected
;     188 TCCR2=0x00;
	OUT  0x25,R30
;     189 TCNT2=0x00;
	OUT  0x24,R30
;     190 OCR2=0x00;
	OUT  0x23,R30
;     191 
;     192 // Timer/Counter 3 initialization
;     193 // Clock source: System Clock
;     194 // Clock value: Timer 3 Stopped
;     195 // Mode: Normal top=FFFFh
;     196 // OC3A output: Discon.
;     197 // OC3B output: Discon.
;     198 // OC3C output: Discon.
;     199 TCCR3A=0x00;
	STS  0x8B,R30
;     200 TCCR3B=0x00;
	STS  0x8A,R30
;     201 TCNT3H=0x00;
	STS  0x89,R30
;     202 TCNT3L=0x00;
	STS  0x88,R30
;     203 OCR3AH=0x00;
	STS  0x87,R30
;     204 OCR3AL=0x00;
	STS  0x86,R30
;     205 OCR3BH=0x00;
	STS  0x85,R30
;     206 OCR3BL=0x00;
	STS  0x84,R30
;     207 OCR3CH=0x00;
	STS  0x83,R30
;     208 OCR3CL=0x00;
	STS  0x82,R30
;     209 
;     210 // External Interrupt(s) initialization
;     211 // INT0: Off
;     212 // INT1: Off
;     213 // INT2: Off
;     214 // INT3: Off
;     215 // INT4: On
;     216 // INT5: On
;     217 // INT6: On
;     218 // INT7: On
;     219 EICRA=0x00;
	STS  0x6A,R30
;     220 EICRB=0xAA;       //falling edge
	LDI  R30,LOW(170)
	OUT  0x3A,R30
;     221 EIMSK=0xF0;
	LDI  R30,LOW(240)
	OUT  0x39,R30
;     222 EIFR=0xF0;
	OUT  0x38,R30
;     223 
;     224 // USART0 initialization  mot GPSen
;     225 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     226 // USART0 Receiver: On
;     227 // USART0 Transmitter: On   //i tilfelle vi m konfigurer uPatch100
;     228 // USART0 Mode: Asynchronous
;     229 // USART0 Baud rate: 4800
;     230 UCSR0A=0x00;
	CLR  R30
	OUT  0xB,R30
;     231 UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     232 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  0x95,R30
;     233 UBRR0H=0x00;
	CLR  R30
	STS  0x90,R30
;     234 UBRR0L=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
;     235 
;     236 // USART1 initialization  mot USB/PC
;     237 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     238 // USART1 Receiver: On
;     239 // USART1 Transmitter: On
;     240 // USART1 Mode: Asynchronous
;     241 // USART1 Baud rate: 115200
;     242 UCSR1A=0x00;
	CLR  R30
	STS  0x9B,R30
;     243 UCSR1B=0x18;
	LDI  R30,LOW(24)
	STS  0x9A,R30
;     244 UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  0x9D,R30
;     245 UBRR1H=0x00;
	CLR  R30
	STS  0x98,R30
;     246 UBRR1L=0x33;             //0x33=9600 og 0x03=115200
	LDI  R30,LOW(51)
	STS  0x99,R30
;     247 
;     248 
;     249 // ADC initialization
;     250 // ADC Clock frequency: 125,000 kHz
;     251 // ADC Voltage Reference: Int., cap. on AREF
;     252 // ADC High Speed Mode: Off
;     253 ADMUX=0xE7;
	LDI  R30,LOW(231)
	OUT  0x7,R30
;     254 ADCSRA=0xEF; 
	LDI  R30,LOW(239)
	OUT  0x6,R30
;     255 SFIOR&=0xEF;   
	IN   R30,0x20
	ANDI R30,0xEF
	OUT  0x20,R30
;     256 
;     257 
;     258 // Analog Comparator initialization
;     259 // Analog Comparator: Off
;     260 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     261 // Analog Comparator Output: Off
;     262 ACSR=0x88;
	LDI  R30,LOW(136)
	OUT  0x8,R30
;     263 SFIOR=0x00;
	CLR  R30
	OUT  0x20,R30
;     264 
;     265 // SPI initialization
;     266 // SPI Type: Master
;     267 // SPI Clock Rate: 2000,000 kHz  x 2
;     268 // SPI Clock Phase: Cycle Half
;     269 // SPI Clock Polarity: Low
;     270 // SPI Data Order: MSB First
;     271 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     272 SPSR=0x01; 
	LDI  R30,LOW(1)
	OUT  0xE,R30
;     273 
;     274 
;     275 
;     276 //start     
;     277 
;     278 // initial clock and date setting for RTC
;     279 SECOND  = 0;
	CLR  R12
;     280 MINUTE  = 0;
	CLR  R13
;     281 HOUR    = 0;
	CLR  R14
;     282 DAY     = 0;
	CLR  R30
	STS  _DAY,R30
;     283 MONTH   = 0;
	STS  _MONTH,R30
;     284 YEAR    = 0;
	CLR  R30
	STS  _YEAR,R30
	STS  _YEAR+1,R30
;     285 
;     286 
;     287 init_display();		//Initialize the display
	CALL _init_display
;     288 
;     289 clear_display();	//Make sure there is nothing on the display in the beginning 
	CALL _clear_display
;     290 		
;     291 charge_enable;		//default: Enable charge
	CBI  0x18,7
;     292 TTE_enable;
	CBI  0x18,6
;     293 display_backlight = 1;  //default: display backlight off
	SBI  0x1B,7
;     294 DEACTIVATE_FLASH;
	SBI  0x12,4
;     295 
;     296 //Finds what adress to start at in ext. flash  
;     297 //IKKE I BRUK
;     298 //find_start_adresse();
;     299 
;     300 flash_delete = 0;
	CLR  R30
	STS  _flash_delete,R30
;     301 FLASH_full = 0;
	CLR  R8
;     302 unread_nmea_msg = 0;
	CLR  R10
;     303 new_msg = 0;
	STS  _new_msg,R30
;     304 tracking = 0;	// this is the variable for saving or not saving in FLASH
	CALL SUBOPT_0x0
;     305 Write('N', 6, 0); Write('O', 6, 1); Write(' ', 6, 2);
;     306 Write('T', 6, 3); Write('R', 6, 4); Write('K', 6, 5);  
;     307 
;     308 
;     309 #asm ("sei");	
	sei
;     310 
;     311 //main loop
;     312 while(1)
_0x47:
;     313 	{
;     314 	//Charges the battery if connected to USB
;     315 	//charger();
;     316         
;     317         //Monitores the voltage on the battery
;     318 	check_batt();
	CALL _check_batt
;     319 	
;     320         //Shows clock from the timer0-RTC
;     321         display_clock();
	CALL _display_clock
;     322         //Shows date from the timer0-RTC
;     323         display_date();
	CALL _display_date
;     324         
;     325         //Syncronize time and date every minute to GPS(UTC) time.
;     326         if (SECOND == 10)
	LDI  R30,LOW(10)
	CP   R30,R12
	BRNE _0x4A
;     327         	{
;     328         	adjust_time();
	CALL _adjust_time
;     329         	} 
;     330         
;     331 	//Always check for FLASH full
;     332 	if (start_adresse > flash_size)  
_0x4A:
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMRDD
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xFFFB4
	CALL __CPD12
	BRSH _0x4B
;     333       		{
;     334       		tracking = 0;
	CLR  R30
	STS  _tracking,R30
;     335       		FLASH_full = 1;
	LDI  R30,LOW(1)
	MOV  R8,R30
;     336       		//Write display: FULL
;     337               	Write('F', 5, 10);
	LDI  R30,LOW(70)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x2
;     338               	Write('U', 5, 11);
	LDI  R30,LOW(85)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x3
;     339               	Write('L', 5, 12);
	LDI  R30,LOW(76)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
;     340               	Write('L', 5, 13);
	LDI  R30,LOW(76)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x5
;     341       		}
;     342       	
;     343       	//Indicates if storing in FLASH is enabled or not
;     344       	if (tracking == 1)
_0x4B:
	LDS  R26,_tracking
	CPI  R26,LOW(0x1)
	BRNE _0x4C
;     345       		{
;     346       		//Display: TRK
;     347         	Write('T', 6, 0);
	CALL SUBOPT_0x6
	CALL SUBOPT_0x7
;     348         	Write('R', 6, 1);
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
;     349         	Write('K', 6, 2);
	LDI  R30,LOW(75)
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
;     350         	Write(' ', 6, 3);
	LDI  R30,LOW(32)
	CALL SUBOPT_0xA
	CALL SUBOPT_0xC
;     351         	Write(' ', 6, 4);
	LDI  R30,LOW(32)
	CALL SUBOPT_0xA
	CALL SUBOPT_0xD
;     352         	Write(' ', 6, 5);
	LDI  R30,LOW(32)
	RJMP _0x15A
;     353         	}
;     354       	else 
_0x4C:
;     355       		{
;     356       	        //Display: NO TRK
;     357                	Write('N', 6, 0);
	LDI  R30,LOW(78)
	CALL SUBOPT_0xA
	CALL SUBOPT_0x7
;     358         	Write('O', 6, 1);
	LDI  R30,LOW(79)
	CALL SUBOPT_0xA
	CALL SUBOPT_0x9
;     359         	Write(' ', 6, 2);
	LDI  R30,LOW(32)
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
;     360         	Write('T', 6, 3);
	CALL SUBOPT_0x6
	CALL SUBOPT_0xC
;     361         	Write('R', 6, 4);
	CALL SUBOPT_0x8
	CALL SUBOPT_0xD
;     362         	Write('K', 6, 5);
	LDI  R30,LOW(75)
_0x15A:
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0xE
;     363       	        }
;     364         	
;     365       	//Analyze data from the GPS reciever (i.e. NMEA messages)
;     366       	if (unread_nmea_msg == 1)
	LDI  R30,LOW(1)
	CP   R30,R10
	BRNE _0x4E
;     367               	{
;     368               	unread_nmea_msg = 0;
	CLR  R10
;     369               	
;     370               	//What type of NMEA msg is this?
;     371 		nmeaID = nmea_type(nmea_data[2], nmea_data[3], nmea_data[4]);
	__GETB1MN _nmea_data,2
	ST   -Y,R30
	__GETB1MN _nmea_data,3
	ST   -Y,R30
	__GETB1MN _nmea_data,4
	ST   -Y,R30
	CALL _nmea_type
	MOV  R5,R30
;     372 		
;     373 		//Parse nmea msg
;     374 		nmea_parse(nmeaID);
	ST   -Y,R5
	CALL _nmea_parse
;     375         	}
;     376         	
;     377  	//Writes LAT and LON on display
;     378 	display_nmea();
_0x4E:
	CALL _display_nmea
;     379         
;     380         //Delete FLASH  	
;     381 	if (flash_delete == 1)
	LDS  R26,_flash_delete
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x4F
;     382 		{
;     383 		tracking = 0;   //No storing in FLASH while deleting FLASH 
	CALL SUBOPT_0x0
;     384 		//Display: NO TRK
;     385                 Write('N', 6, 0); Write('O', 6, 1); Write(' ', 6, 2);
;     386                 Write('T', 6, 3); Write('R', 6, 4); Write('K', 6, 5);
;     387                 //Display: DELETE
;     388                 Write('D', 5, 0); Write('E', 5, 1); Write('L', 5, 2);
	LDI  R30,LOW(68)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x7
	LDI  R30,LOW(69)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x9
	LDI  R30,LOW(76)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xB
;     389                 Write('E', 5, 3); Write('T', 5, 4); Write('E', 5, 5); 
	LDI  R30,LOW(69)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xC
	LDI  R30,LOW(84)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xD
	LDI  R30,LOW(69)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xF
;     390                 bulk_erase();
	CALL _bulk_erase
;     391                 adresse = 0;
	CLR  R30
	STS  _adresse,R30
	STS  _adresse+1,R30
	STS  _adresse+2,R30
	STS  _adresse+3,R30
;     392                 start_adresse = 0;
	__GETD1N 0x0
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMWRD
;     393                 FLASH_full = 0;
	CLR  R8
;     394                 //Display: Delete letters ("DELETE")
;     395                 Write(' ', 5, 0); Write(' ', 5, 1); Write(' ', 5, 2);          
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x7
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x9
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xB
;     396                 Write(' ', 5, 3); Write(' ', 5, 4); Write(' ', 5, 5); 
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xC
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xD
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xF
;     397                 //Display: Delete letters ("FULL")
;     398                 Write(' ', 5, 10); Write(' ', 5, 11);
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x2
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x3
;     399               	Write(' ', 5, 12); Write(' ', 5, 13);
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x5
;     400                 flash_delete = 0;
	CLR  R30
	STS  _flash_delete,R30
;     401                 }
;     402 	
;     403 	//Transmit to PC via USB
;     404 	if (transmit_USB == 1)
_0x4F:
	LDS  R26,_transmit_USB
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x50
;     405 		{
;     406 		tracking = 0;	//No storing in FLASH while transmiting to PC 
	CALL SUBOPT_0x0
;     407                 //Display: NO TRK
;     408                 Write('N', 6, 0); Write('O', 6, 1); Write(' ', 6, 2);
;     409                 Write('T', 6, 3); Write('R', 6, 4); Write('K', 6, 5); 
;     410                 //Display: USB
;     411                 Write('U', 5, 0); Write('S', 5, 1); Write('B', 5, 2);
	LDI  R30,LOW(85)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x7
	LDI  R30,LOW(83)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x9
	LDI  R30,LOW(66)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xB
;     412                 if(start_transmit == 0)  //This should occour only once per transmit to PC
	TST  R6
	BRNE _0x51
;     413                 	{
;     414                 	wait_flash_rdy();
	CALL _wait_flash_rdy
;     415                         ACTIVATE_FLASH;
	CBI  0x12,4
;     416                         spi(READ);      //Read FLASH from start (adress 0)
	LDI  R30,LOW(3)
	CALL SUBOPT_0x10
;     417                         spi(0x00);      
	CALL SUBOPT_0x10
;     418                         spi(0x00);
	CALL SUBOPT_0x10
;     419                         spi(0x00);
	ST   -Y,R30
	CALL _spi
;     420                         UCSR1B = 0x38;	//Enable UDR1E isr
	LDI  R30,LOW(56)
	STS  0x9A,R30
;     421                         start_transmit = 1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     422                         }
;     423                 if (transmit_USB_complete == 1)
_0x51:
	LDS  R26,_transmit_USB_complete
	CPI  R26,LOW(0x1)
	BRNE _0x52
;     424                 	{
;     425                 	transmit_USB_complete = 0;
	CLR  R30
	STS  _transmit_USB_complete,R30
;     426                 	Write(' ', 5, 0); Write(' ', 5, 1); Write(' ', 5, 2);   //delete spots on display
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x7
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x9
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
	CALL SUBOPT_0xB
;     427                 	transmit_USB = 0; 
	CLR  R30
	STS  _transmit_USB,R30
;     428                 	start_transmit = 0;
	CLR  R6
;     429                 	}
;     430                 }       
_0x52:
;     431 		
;     432 	}//main loop end	
_0x50:
	RJMP _0x47
;     433 
;     434 }//main end
_0x53:
	RJMP _0x53
;     435 
;     436 
;     437 
;     438 // USART0 Receiver interrupt service routine
;     439 // Collects NMEA msg's
;     440 #pragma savereg-
;     441 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     442 {
_uart0_rx_isr:
;     443 char status,data; 
;     444 
;     445 #asm
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	data -> R17
;     446     push r26
    push r26
;     447     push r27
    push r27
;     448     push r30
    push r30
;     449     push r31
    push r31
;     450     in   r26,sreg
    in   r26,sreg
;     451     push r26
    push r26
;     452 #endasm

;     453 status=UCSR0A;
	IN   R16,11
;     454 data=UDR0;
	IN   R17,12
;     455 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BREQ PC+3
	JMP _0x55
;     456    	{    
;     457 	if ((data == START_NMEA) && (new_msg == 0))
	CPI  R17,36
	BRNE _0x57
	LDS  R26,_new_msg
	CPI  R26,LOW(0x0)
	BREQ _0x58
_0x57:
	RJMP _0x56
_0x58:
;     458 		{
;     459         	new_msg = 1;
	LDI  R30,LOW(1)
	STS  _new_msg,R30
;     460         	index = 0;
	CLR  R30
	STS  _index,R30
;     461         	}
;     462 	else if ((data != START_NMEA) && (data !=  END_NMEA) && (new_msg == 1))
	RJMP _0x59
_0x56:
	CPI  R17,36
	BREQ _0x5B
	CPI  R17,10
	BREQ _0x5B
	LDS  R26,_new_msg
	CPI  R26,LOW(0x1)
	BREQ _0x5C
_0x5B:
	RJMP _0x5A
_0x5C:
;     463 		{       
;     464 		temp_data[index] = data;
	LDS  R26,_index
	CLR  R27
	SUBI R26,LOW(-_temp_data)
	SBCI R27,HIGH(-_temp_data)
	ST   X,R17
;     465 		index++;
	LDS  R30,_index
	SUBI R30,-LOW(1)
	STS  _index,R30
;     466 		}
;     467 	else if ((data == END_NMEA) && (new_msg == 1))
	RJMP _0x5D
_0x5A:
	CPI  R17,10
	BRNE _0x5F
	LDS  R26,_new_msg
	CPI  R26,LOW(0x1)
	BREQ _0x60
_0x5F:
	RJMP _0x5E
_0x60:
;     468        		{       
;     469 		//copy temp_data to nmea_data
;     470 	     	for (i=0; i < 82; i++)
	CLR  R30
	STS  _i,R30
_0x62:
	LDS  R26,_i
	CPI  R26,LOW(0x52)
	BRSH _0x63
;     471 			{
;     472 			nmea_data[i] = temp_data[i];
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_nmea_data)
	SBCI R31,HIGH(-_nmea_data)
	PUSH R31
	PUSH R30
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_temp_data)
	SBCI R31,HIGH(-_temp_data)
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     473 			}
	CALL SUBOPT_0x11
	RJMP _0x62
_0x63:
;     474 		unread_nmea_msg = 1;
	LDI  R30,LOW(1)
	MOV  R10,R30
;     475 		index = 0;
	CLR  R30
	STS  _index,R30
;     476 		new_msg = 0;
	STS  _new_msg,R30
;     477        		}
;     478    	}
_0x5E:
_0x5D:
_0x59:
;     479 #asm
_0x55:
;     480     pop  r26
    pop  r26
;     481     out  sreg,r26
    out  sreg,r26
;     482     pop  r31
    pop  r31
;     483     pop  r30
    pop  r30
;     484     pop  r27
    pop  r27
;     485     pop  r26
    pop  r26
;     486 #endasm

;     487 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     488 #pragma savereg+
;     489 
;     490 
;     491 // USART1 Transmitter interrupt service routine 
;     492 // Transmit to PC via USB
;     493 #pragma savereg-
;     494 interrupt [USART1_DRE] void uart1_dre_isr(void)
;     495 {
_uart1_dre_isr:
;     496 unsigned char data;
;     497 #asm
	ST   -Y,R16
;	data -> R16
;     498     push r26
    push r26
;     499     push r27
    push r27
;     500     push r30
    push r30
;     501     push r31
    push r31
;     502     in   r26,sreg
    in   r26,sreg
;     503     push r26
    push r26
;     504 #endasm

;     505 data=spi(0x00);
	CALL SUBOPT_0x12
;     506 if (data == 0xFF)   	//0xFF means empty FLASH
	CPI  R16,255
	BRNE _0x65
;     507 	{
;     508 	UCSR1B = 0x18;	//disable UDR1E isr
	LDI  R30,LOW(24)
	STS  0x9A,R30
;     509 	DEACTIVATE_FLASH;
	SBI  0x12,4
;     510 	transmit_USB_complete = 1;
	LDI  R30,LOW(1)
	STS  _transmit_USB_complete,R30
;     511 	}                        
;     512 else
	RJMP _0x66
_0x65:
;     513         {
;     514         UDR1=data;
	STS  156,R16
;     515         }
_0x66:
;     516 
;     517 
;     518 #asm
;     519     pop  r26
    pop  r26
;     520     out  sreg,r26
    out  sreg,r26
;     521     pop  r31
    pop  r31
;     522     pop  r30
    pop  r30
;     523     pop  r27
    pop  r27
;     524     pop  r26
    pop  r26
;     525 #endasm

;     526 }
	LD   R16,Y+
	RETI
;     527 #pragma savereg+
;     528 
;     529  
;     530 
;     531 // External Interrupt 4 service routine 
;     532 // ON/OFF tracking (FLASH)
;     533 interrupt [EXT_INT4] void ext_int4_isr(void)
;     534 {
_ext_int4_isr:
	CALL __SAVEISR
;     535 if (tracking == 1) 
	LDS  R26,_tracking
	CPI  R26,LOW(0x1)
	BRNE _0x68
;     536         {
;     537         tracking = 0;      	//Tracking OFF
	CLR  R30
	STS  _tracking,R30
;     538         }
;     539 else if ((tracking == 0) && (FLASH_full == 0) && (flash_delete == 0))
	RJMP _0x69
_0x68:
	LDS  R26,_tracking
	CPI  R26,LOW(0x0)
	BRNE _0x6B
	CLR  R30
	CP   R30,R8
	BRNE _0x6B
	LDS  R26,_flash_delete
	CPI  R26,LOW(0x0)
	BREQ _0x6C
_0x6B:
	RJMP _0x6A
_0x6C:
;     540 	{                                            
;     541 	tracking = 1;		//Tracking ON
	LDI  R30,LOW(1)
	STS  _tracking,R30
;     542         }
;     543 }
_0x6A:
_0x69:
	CALL __LOADISR
	RETI
;     544 
;     545 
;     546 
;     547 // External Interrupt 5 service routine 
;     548 // Delete FLASH
;     549 interrupt [EXT_INT5] void ext_int5_isr(void)
;     550 {
_ext_int5_isr:
	CALL __SAVEISR
;     551 flash_delete = 1;  
	LDI  R30,LOW(1)
	STS  _flash_delete,R30
;     552 }
	CALL __LOADISR
	RETI
;     553 
;     554 
;     555 
;     556 // External Interrupt 6 service routine 
;     557 // Transmit data to PC
;     558 interrupt [EXT_INT6] void ext_int6_isr(void)
;     559 {
_ext_int6_isr:
	CALL __SAVEISR
;     560 transmit_USB = 1;
	LDI  R30,LOW(1)
	STS  _transmit_USB,R30
;     561 }
	CALL __LOADISR
	RETI
;     562 
;     563 
;     564 
;     565 // External Interrupt 7 service routine
;     566 // ON/OFF background light on display
;     567 interrupt [EXT_INT7] void ext_int7_isr(void)
;     568 {
_ext_int7_isr:
	CALL __SAVEISR
;     569 
;     570 if(display_backlight == 0)
	SBIC 0x1B,7
	RJMP _0x70
;     571 	{
;     572 	display_backlight = 1;         //disable background light
	SBI  0x1B,7
;     573 	}
;     574 else if (display_backlight == 1);
	RJMP _0x71
_0x70:
;     575 	{
_0x71:
;     576 	display_backlight = 0;		//enable background light	
	CBI  0x1B,7
;     577 	}
;     578 }
	CALL __LOADISR
	RETI
;     579  
;     580 
;     581 
;     582 // Timer 0 overflow interrupt service routine
;     583 // Saves tracking_pkt in FLASH every second and keeps RTC going
;     584 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     585 {
_timer0_ovf_isr:
	CALL __SAVEISR
;     586 
;     587 //increment the Real Time Clock
;     588 RTC();
	CALL _RTC
;     589 
;     590 //Store in FLASH  M25P80     
;     591 if ((tracking == 1) && (FLASH_full == 0) && (valid_nmea == 1))
	LDS  R26,_tracking
	CPI  R26,LOW(0x1)
	BRNE _0x75
	CLR  R30
	CP   R30,R8
	BRNE _0x75
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ _0x76
_0x75:
	RJMP _0x74
_0x76:
;     592 	{
;     593 	new_nmea_data = check_new_track();  //new_nmea_data=0 if no new LAT/LON data
	CALL _check_new_track
	MOV  R9,R30
;     594 	if (new_nmea_data != 0)
	TST  R9
	BRNE PC+3
	JMP _0x77
;     595         	{
;     596                 //Store in FLASH 
;     597                 i=0;
	CLR  R30
	STS  _i,R30
;     598                 for(adresse=start_adresse; adresse<(start_adresse+tracking_index); adresse++)
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMRDD
	STS  _adresse,R30
	STS  _adresse+1,R31
	STS  _adresse+2,R22
	STS  _adresse+3,R23
_0x79:
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMRDD
	__ADDD1N 39
	LDS  R26,_adresse
	LDS  R27,_adresse+1
	LDS  R24,_adresse+2
	LDS  R25,_adresse+3
	CALL __CPD21
	BRSH _0x7A
;     599                 	{
;     600                 	PageProgram(tracking_pkt[i], adresse);
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_tracking_pkt)
	SBCI R31,HIGH(-_tracking_pkt)
	LD   R30,Z
	ST   -Y,R30
	LDS  R30,_adresse
	LDS  R31,_adresse+1
	LDS  R22,_adresse+2
	LDS  R23,_adresse+3
	CALL __PUTPARD1
	CALL _PageProgram
;     601                         i++;	
	CALL SUBOPT_0x11
;     602                 	}
	LDS  R30,_adresse
	LDS  R31,_adresse+1
	LDS  R22,_adresse+2
	LDS  R23,_adresse+3
	__SUBD1N -1
	STS  _adresse,R30
	STS  _adresse+1,R31
	STS  _adresse+2,R22
	STS  _adresse+3,R23
	RJMP _0x79
_0x7A:
;     603                 start_adresse = start_adresse+tracking_index;
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMRDD
	__ADDD1N 39
	LDI  R26,LOW(_start_adresse)
	LDI  R27,HIGH(_start_adresse)
	CALL __EEPROMWRD
;     604                 }
;     605 	}
_0x77:
;     606 
;     607 
;     608 } 
_0x74:
	CALL __LOADISR
	RETI
;     609 
;     610 
;     611 
;     612 
;     613 // ADC interrupt service routine 
;     614 // Monitoring the battery
;     615 interrupt [ADC_INT] void adc_isr(void)
;     616 {
_adc_isr:
	CALL __SAVEISR
;     617 unsigned int adc_data;
;     618 
;     619 // Read the AD conversion result
;     620 //adc_data=ADCW;	
;     621 adc_data=ADCH; 	
	ST   -Y,R17
	ST   -Y,R16
;	adc_data -> R16,R17
	IN   R30,0x5
	CLR  R31
	__PUTW1R 16,17
;     622 adc_data=adc_data+8;	// offset
	__ADDWRN 16,17,8
;     623 volt=adc_data*2; 	// Voltage
	__GETW1R 16,17
	LSL  R30
	ROL  R31
	STS  _volt,R30
	STS  _volt+1,R31
;     624 
;     625 }
	LD   R16,Y+
	LD   R17,Y+
	CALL __LOADISR
	RETI
;     626 
;     627 //Displays the voltage of the battery
;     628 void check_batt(void)
;     629 {
_check_batt:
;     630 unsigned int tier;
;     631 unsigned int hundre;
;     632 unsigned int ener;
;     633 
;     634 Write('V',0,7);
	CALL __SAVELOCR6
;	tier -> R16,R17
;	hundre -> R18,R19
;	ener -> R20,R21
	LDI  R30,LOW(86)
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
;     635 //Write('O',0,8);
;     636 //Write('L',0,9);
;     637 //Write('T',0,10);
;     638 
;     639 if (volt<10)
	LDS  R26,_volt
	LDS  R27,_volt+1
	CPI  R26,LOW(0xA)
	LDI  R30,HIGH(0xA)
	CPC  R27,R30
	BRSH _0x7D
;     640 	{
;     641 	Write('0',0,3);
	LDI  R30,LOW(48)
	CALL SUBOPT_0x13
	CALL SUBOPT_0xC
;     642 	Write(',',0,4);
	LDI  R30,LOW(44)
	CALL SUBOPT_0x13
	CALL SUBOPT_0xD
;     643 	Write('0',0,5);
	LDI  R30,LOW(48)
	CALL SUBOPT_0x15
;     644 	Write(volt+48,0,6);
	LDS  R30,_volt
	LDS  R31,_volt+1
	ADIW R30,48
	CALL SUBOPT_0x13
	CALL SUBOPT_0x16
;     645 	}
;     646 else if ((volt>=10)&&(volt<100))
	RJMP _0x7E
_0x7D:
	LDS  R26,_volt
	LDS  R27,_volt+1
	CPI  R26,LOW(0xA)
	LDI  R30,HIGH(0xA)
	CPC  R27,R30
	BRLO _0x80
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLO _0x81
_0x80:
	RJMP _0x7F
_0x81:
;     647 	{
;     648 	Write('0',0,3);
	LDI  R30,LOW(48)
	CALL SUBOPT_0x13
	CALL SUBOPT_0xC
;     649 	Write(',',0,4);
	LDI  R30,LOW(44)
	CALL SUBOPT_0x13
	CALL SUBOPT_0xD
;     650 	tier=(volt/10);
	LDS  R26,_volt
	LDS  R27,_volt+1
	CALL SUBOPT_0x17
;     651 	Write(tier+48,0,5);
;     652 	Write((volt-(tier*10))+48,0,6);
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	RJMP _0x15B
;     653 	}
;     654 else
_0x7F:
;     655 	{
;     656 	hundre=(volt/100);
	LDS  R26,_volt
	LDS  R27,_volt+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	__PUTW1R 18,19
;     657 	Write(hundre+48,0,3);
	__GETW1R 18,19
	ADIW R30,48
	CALL SUBOPT_0x13
	CALL SUBOPT_0xC
;     658 	Write(',',0,4);
	LDI  R30,LOW(44)
	CALL SUBOPT_0x13
	CALL SUBOPT_0xD
;     659 	tier=(volt-(hundre*100))/10;
	CALL SUBOPT_0x1A
	LDS  R26,_volt
	LDS  R27,_volt+1
	SUB  R26,R30
	SBC  R27,R31
	CALL SUBOPT_0x17
;     660 	Write(tier+48,0,5);
;     661 	ener=volt-((hundre*100)+(tier*10));
	CALL SUBOPT_0x1A
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x18
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	CALL SUBOPT_0x19
	__PUTW1R 20,21
;     662 	Write(ener+48,0,6);
	__GETW1R 20,21
_0x15B:
	ADIW R30,48
	CALL SUBOPT_0x13
	CALL SUBOPT_0x16
;     663 	} 
_0x7E:
;     664 
;     665         
;     666 /*
;     667 if (volt=170)
;     668 	{
;     669 		Write('O',0,8);		// Skriver status ut p display
;     670       		Write('K',0,9);
;     671        		Write(' ',0,10);
;     672 	}
;     673 else if ((volt<170) && (volt>=165)) 
;     674 	{
;     675 		Write('L',0,8);
;     676       		Write('O',0,9);
;     677       		Write('W',0,10);
;     678 	}           
;     679 else
;     680 	{
;     681 		Write('O',0,8);
;     682 		Write('F',0,9);
;     683        		Write('F',0,10);
;     684 	}
;     685   */
;     686 }
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;     687 
;     688 
;     689 //Converts a value (0-99) to BCD
;     690 char CHAR2BCD2(char input)
;     691 {
_CHAR2BCD2:
;     692 char high = 0;
;     693 
;     694 while (input >= 10)    // Count tens
	ST   -Y,R16
;	input -> Y+1
;	high -> R16
	LDI  R16,0
_0x84:
	LDD  R26,Y+1
	CPI  R26,LOW(0xA)
	BRLO _0x86
;     695     	{
;     696 	high++;
	SUBI R16,-1
;     697 	input -= 10;
	LDD  R30,Y+1
	SUBI R30,LOW(10)
	STD  Y+1,R30
;     698 	}
	RJMP _0x84
_0x86:
;     699 
;     700 return  (high << 4) | input;        // Add ones and return answer
	MOV  R30,R16
	SWAP R30
	ANDI R30,0xF0
	LDD  R26,Y+1
	OR   R30,R26
	LDD  R16,Y+0
	ADIW R28,2
	RET
;     701 }
;     702 
;     703 
;     704 
;     705 //Just checking the STATx outputs of the BQ24013
;     706 //nothing comes out, not even on the oscilloscope.
;     707 void charger(void)
;     708 {
;     709 
;     710 if(STAT1 == 1)
;     711 	{
;     712 	Write('1',0,0);
;     713 	}
;     714 else if (STAT1 == 0)
;     715 	{
;     716 	Write('0',0,0);
;     717 	}
;     718 else
;     719 	{
;     720 	Write(' ',0,0);
;     721 	}
;     722 	
;     723 if(STAT2 == 1)
;     724 	{
;     725 	Write('1',0,1);
;     726 	}
;     727 else if(STAT2 == 0)
;     728 	{
;     729 	Write('0',0,1);
;     730 	}
;     731 else
;     732 	{
;     733 	Write(' ',0,1);
;     734 	}
;     735 }
;     736 /*
;     737 //Scans the external flashmemory and finds first empty space.
;     738 //The adress of this space is used as the first adress in the external flashmemory
;     739 //at start-up. 
;     740 //BRUKES IKKE
;     741 void find_start_adresse(void)
;     742 {
;     743 unsigned char data = 0;
;     744 unsigned char found_adress = 0;
;     745 
;     746 wait_flash_rdy();
;     747 ACTIVATE_FLASH;
;     748 spi(READ);      //Read FLASH from start (adress 0)
;     749 spi(0x00);      
;     750 spi(0x00);
;     751 spi(0x00);
;     752 while (found_adress == 0)
;     753 	{
;     754 	data=spi(0x00);
;     755         start_adresse++;
;     756         if (data == 0xFF)
;     757         	{
;     758         	found_adress = 1;
;     759         	}
;     760         }
;     761 DEACTIVATE_FLASH; 
;     762 }
;     763   */
;     764 /************************************************************************** 
;     765 Name: 		display.c
;     766 Comments:	Display functions
;     767 **************************************************************************/
;     768 
;     769 #include <mega128.h>
;     770 #include <delay.h>
;     771 #include "display.h"
;     772                       
;     773 
;     774 //Initialisation Display
;     775 void init_display()
;     776 {	
_init_display:
;     777 Reset=0;
	CBI  0x1B,0
;     778 delay_ms(10);
	CALL SUBOPT_0x1B
;     779 Reset=1;
	SBI  0x1B,0
;     780 delay_ms(10);
	CALL SUBOPT_0x1B
;     781 CS1=0; 
	CBI  0x1B,1
;     782 CS2=1;
	SBI  0x1B,2
;     783 C86=0;
	CBI  0x1B,3
;     784        
;     785 // Set display, start line
;     786 A0=0; 
	CBI  0x1B,4
;     787 RD=1; 
	SBI  0x1B,6
;     788 WR=0; 
	CBI  0x1B,5
;     789 Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;     790 WR=1;
	SBI  0x1B,5
;     791 delay_ms(10);
	CALL SUBOPT_0x1B
;     792        
;     793 // Set Normal / Reverse Display
;     794 WR=0; 
	CBI  0x1B,5
;     795 Display_data=0xA6;
	LDI  R30,LOW(166)
	OUT  0x15,R30
;     796 WR=1;
	SBI  0x1B,5
;     797 delay_ms(10);
	CALL SUBOPT_0x1B
;     798        
;     799 //Set all indicator
;     800 WR=0; 
	CBI  0x1B,5
;     801 Display_data=0xA4;
	LDI  R30,LOW(164)
	OUT  0x15,R30
;     802 WR=1;
	SBI  0x1B,5
;     803 delay_ms(10);
	CALL SUBOPT_0x1B
;     804        
;     805 //Set duty select
;     806 WR=0; 
	CBI  0x1B,5
;     807 Display_data=0xA9;
	LDI  R30,LOW(169)
	OUT  0x15,R30
;     808 WR=1;
	SBI  0x1B,5
;     809 delay_ms(10);
	CALL SUBOPT_0x1B
;     810                     
;     811 //Set ADC = 1
;     812 WR=0; 
	CBI  0x1B,5
;     813 Display_data=0xA1;
	LDI  R30,LOW(161)
	OUT  0x15,R30
;     814 WR=1;
	SBI  0x1B,5
;     815 delay_ms(10);
	CALL SUBOPT_0x1B
;     816        
;     817 //Output Status
;     818 WR=0; 
	CBI  0x1B,5
;     819 Display_data=0xCC;
	LDI  R30,LOW(204)
	OUT  0x15,R30
;     820 WR=1;
	SBI  0x1B,5
;     821 delay_ms(10);
	CALL SUBOPT_0x1B
;     822                     
;     823 //Set built in power supply
;     824 WR=0; 
	CBI  0x1B,5
;     825 Display_data=0x25;
	LDI  R30,LOW(37)
	OUT  0x15,R30
;     826 WR=1;
	SBI  0x1B,5
;     827 delay_ms(10);
	CALL SUBOPT_0x1B
;     828        
;     829 //Set power on completion
;     830 WR=0; 
	CBI  0x1B,5
;     831 Display_data=0xED;
	LDI  R30,LOW(237)
	OUT  0x15,R30
;     832 WR=1;
	SBI  0x1B,5
;     833 delay_ms(10);
	CALL SUBOPT_0x1B
;     834        
;     835 //Set electronic volume control
;     836 WR=0; 
	CBI  0x1B,5
;     837 Display_data=0x8F;
	LDI  R30,LOW(143)
	OUT  0x15,R30
;     838 WR=1;
	SBI  0x1B,5
;     839 delay_ms(10); 
	CALL SUBOPT_0x1B
;     840        
;     841 //Set Display ON
;     842 WR=0; 
	CBI  0x1B,5
;     843 Display_data=0xAF;
	LDI  R30,LOW(175)
	OUT  0x15,R30
;     844 WR=1;
	SBI  0x1B,5
;     845 delay_ms(10);
	CALL SUBOPT_0x1B
;     846        
;     847 //Set page adress
;     848 WR=0; 
	CBI  0x1B,5
;     849 Display_data=0xB0;
	LDI  R30,LOW(176)
	OUT  0x15,R30
;     850 WR=1;
	SBI  0x1B,5
;     851 delay_ms(10);
	CALL SUBOPT_0x1B
;     852         
;     853 //Set column adress high order 4-bits
;     854 WR=0; 
	CBI  0x1B,5
;     855 Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;     856 WR=1;
	SBI  0x1B,5
;     857 delay_ms(10);
	CALL SUBOPT_0x1B
;     858        
;     859 //Set column adress low order 4-bits
;     860 WR=0; 
	CBI  0x1B,5
;     861 Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     862 WR=1;
	SBI  0x1B,5
;     863 delay_ms(10);
	CALL SUBOPT_0x1B
;     864                  
;     865 /*//Read modify Write
;     866 RD=1; 
;     867 WR=0; 
;     868 Display_data=0xE0;
;     869 WR=1;
;     870 delay_ms(50);*/ 
;     871        
;     872        
;     873 /*//Display status          
;     874 A0=0;  
;     875 RD=0; 
;     876 WR=1; 
;     877 Display_data=0x00; 
;     878 WR=1;
;     879 delay_ms(50); 
;     880 DDRC=0x00; // Port C innport
;     881 delay_ms(50);*/
;     882 
;     883 } 
	RET
;     884                            
;     885 // Write to Display       
;     886 void Write(unsigned char letter, unsigned int page, unsigned int pos)
;     887 {         
_Write:
;     888 
;     889 if ((page>=0 && page<=8) && (pos>=0 && pos<=17))
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,0
	BRLO _0x98
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x99
_0x98:
	RJMP _0x9A
_0x99:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,0
	BRLO _0x9B
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x9C
_0x9B:
	RJMP _0x9A
_0x9C:
	RJMP _0x9D
_0x9A:
	RJMP _0x97
_0x9D:
;     890 	{        
;     891 	unsigned int adr;
;     892 	unsigned int colum;
;     893 	unsigned int colum_h;
;     894 	unsigned int colum_l;
;     895 	
;     896 	adr=0xB0+page;
	SBIW R28,8
;	letter -> Y+12
;	page -> Y+10
;	pos -> Y+8
;	adr -> Y+6
;	colum -> Y+4
;	colum_h -> Y+2
;	colum_l -> Y+0
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-176)
	SBCI R31,HIGH(-176)
	STD  Y+6,R30
	STD  Y+6+1,R31
;     897 	
;     898 	//Set Page adress
;     899 	A0=0;  
	CBI  0x1B,4
;     900  	RD=1; 
	SBI  0x1B,6
;     901   	WR=0; 
	CBI  0x1B,5
;     902        	Display_data=adr;
	OUT  0x15,R30
;     903        	WR=1;  
	SBI  0x1B,5
;     904         
;     905         colum=pos*6; 
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL __MULW12U
	STD  Y+4,R30
	STD  Y+4+1,R31
;     906         colum_h= (char)(colum >> 4) ; // high 4-bits
	CALL __LSRW4
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
;     907         colum_l=colum & 0x0F;   // low 4-bits
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	ST   Y,R30
	STD  Y+1,R31
;     908         colum_h=colum_h + 0x12;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,18
	STD  Y+2,R30
	STD  Y+2+1,R31
;     909         
;     910    	//Set column adress high order 4-bits
;     911        	WR=0; 
	CBI  0x1B,5
;     912        	Display_data=colum_h;
	OUT  0x15,R30
;     913        	WR=1;
	SBI  0x1B,5
;     914        	
;     915        	//Set column adress low order 4-bits 
;     916        	WR=0; 
	CBI  0x1B,5
;     917        	Display_data=colum_l;
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x15,R30
;     918        	WR=1;  
	SBI  0x1B,5
;     919        	}
	ADIW R28,8
;     920           
;     921 else
	RJMP _0x9E
_0x97:
;     922       	{
;     923       	//Illegal page adress or position. Page must be equal or bigger than 0 and less than 8.
;     924       	//Position must be equal or bigger than 0 and less than 16. Each letter is 6 pixels including
;     925       	//space, the display is 100 pixels wide, which gives 16 hole letters a line/page.
;     926        	return;  
	RJMP _0x159
;     927       	} 
_0x9E:
;     928       
;     929 //Display data write
;     930 A0=1;  
	SBI  0x1B,4
;     931 RD=1; 
	SBI  0x1B,6
;     932 WR=0;
	CBI  0x1B,5
;     933        
;     934 switch (letter)
	LDD  R30,Y+4
;     935 	{     
;     936  	case ' ':
	CPI  R30,LOW(0x20)
	BRNE _0xA2
;     937   	WR=0;
	CBI  0x1B,5
;     938    	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     939     	WR=1;
	SBI  0x1B,5
;     940      	WR=0;
	CBI  0x1B,5
;     941       	Display_data=0x00;
	OUT  0x15,R30
;     942        	WR=1;
	SBI  0x1B,5
;     943         WR=0;
	CBI  0x1B,5
;     944         Display_data=0x00;
	OUT  0x15,R30
;     945         WR=1;
	SBI  0x1B,5
;     946         WR=0;
	CBI  0x1B,5
;     947         Display_data=0x00;
	OUT  0x15,R30
;     948         WR=1;
	SBI  0x1B,5
;     949         WR=0;
	CBI  0x1B,5
;     950         Display_data=0x00;
	OUT  0x15,R30
;     951         WR=1; 
	SBI  0x1B,5
;     952         WR=0;
	CBI  0x1B,5
;     953         Display_data=0x00;
	OUT  0x15,R30
;     954         WR=1; 
	SBI  0x1B,5
;     955         return; 
	RJMP _0x159
;     956        
;     957        	case '0':
_0xA2:
	CPI  R30,LOW(0x30)
	BRNE _0xA3
;     958        	WR=0;
	CBI  0x1B,5
;     959        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;     960        	WR=1;
	SBI  0x1B,5
;     961        	WR=0;
	CBI  0x1B,5
;     962        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;     963        	WR=1;
	SBI  0x1B,5
;     964        	WR=0;
	CBI  0x1B,5
;     965        	Display_data=0x41;
	OUT  0x15,R30
;     966        	WR=1;
	SBI  0x1B,5
;     967        	WR=0;
	CBI  0x1B,5
;     968        	Display_data=0x41;
	OUT  0x15,R30
;     969        	WR=1;
	SBI  0x1B,5
;     970        	WR=0;
	CBI  0x1B,5
;     971        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;     972        	WR=1;
	SBI  0x1B,5
;     973        	WR=0;
	CBI  0x1B,5
;     974        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     975        	WR=1;
	SBI  0x1B,5
;     976 	return;	   
	RJMP _0x159
;     977        
;     978        	case '1':
_0xA3:
	CPI  R30,LOW(0x31)
	BRNE _0xA4
;     979        	WR=0;
	CBI  0x1B,5
;     980        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     981        	WR=1;
	SBI  0x1B,5
;     982        	WR=0;
	CBI  0x1B,5
;     983        	Display_data=0x00;
	OUT  0x15,R30
;     984        	WR=1;
	SBI  0x1B,5
;     985        	WR=0;
	CBI  0x1B,5
;     986        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;     987        	WR=1;
	SBI  0x1B,5
;     988        	WR=0;
	CBI  0x1B,5
;     989        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     990        	WR=1;
	SBI  0x1B,5
;     991        	WR=0;
	CBI  0x1B,5
;     992        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;     993        	WR=1;
	SBI  0x1B,5
;     994        	WR=0;
	CBI  0x1B,5
;     995        	Display_data=0x00;
	OUT  0x15,R30
;     996        	WR=1; 
	SBI  0x1B,5
;     997        	return;  
	RJMP _0x159
;     998        
;     999        	case '2':
_0xA4:
	CPI  R30,LOW(0x32)
	BRNE _0xA5
;    1000        	WR=0;
	CBI  0x1B,5
;    1001        	Display_data=0x42;
	LDI  R30,LOW(66)
	OUT  0x15,R30
;    1002        	WR=1;
	SBI  0x1B,5
;    1003        	WR=0;
	CBI  0x1B,5
;    1004        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1005        	WR=1;
	SBI  0x1B,5
;    1006        	WR=0;
	CBI  0x1B,5
;    1007        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;    1008        	WR=1;
	SBI  0x1B,5
;    1009        	WR=0;
	CBI  0x1B,5
;    1010        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1011        	WR=1;
	SBI  0x1B,5
;    1012        	WR=0;
	CBI  0x1B,5
;    1013        	Display_data=0x46;
	LDI  R30,LOW(70)
	OUT  0x15,R30
;    1014        	WR=1;
	SBI  0x1B,5
;    1015        	WR=0;
	CBI  0x1B,5
;    1016        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1017        	WR=1; 
	SBI  0x1B,5
;    1018        	return;    
	RJMP _0x159
;    1019                   
;    1020   	case '3':
_0xA5:
	CPI  R30,LOW(0x33)
	BRNE _0xA6
;    1021        	WR=0;
	CBI  0x1B,5
;    1022        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1023        	WR=1;
	SBI  0x1B,5
;    1024        	WR=0;
	CBI  0x1B,5
;    1025        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1026        	WR=1;
	SBI  0x1B,5
;    1027        	WR=0;
	CBI  0x1B,5
;    1028        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1029        	WR=1;
	SBI  0x1B,5
;    1030        	WR=0;
	CBI  0x1B,5
;    1031        	Display_data=0x49;
	OUT  0x15,R30
;    1032        	WR=1;
	SBI  0x1B,5
;    1033        	WR=0;
	CBI  0x1B,5
;    1034        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1035        	WR=1;
	SBI  0x1B,5
;    1036        	WR=0;
	CBI  0x1B,5
;    1037        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1038        	WR=1; 
	SBI  0x1B,5
;    1039        	return; 
	RJMP _0x159
;    1040        
;    1041        	case '4':
_0xA6:
	CPI  R30,LOW(0x34)
	BRNE _0xA7
;    1042        	WR=0;
	CBI  0x1B,5
;    1043        	Display_data=0x18;
	LDI  R30,LOW(24)
	OUT  0x15,R30
;    1044        	WR=1;
	SBI  0x1B,5
;    1045        	WR=0;
	CBI  0x1B,5
;    1046        	Display_data=0x14;
	LDI  R30,LOW(20)
	OUT  0x15,R30
;    1047        	WR=1;
	SBI  0x1B,5
;    1048        	WR=0;
	CBI  0x1B,5
;    1049        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;    1050        	WR=1;
	SBI  0x1B,5
;    1051        	WR=0;
	CBI  0x1B,5
;    1052        	Display_data=0x79;
	LDI  R30,LOW(121)
	OUT  0x15,R30
;    1053        	WR=1;
	SBI  0x1B,5
;    1054        	WR=0;
	CBI  0x1B,5
;    1055        	Display_data=0x10;
	LDI  R30,LOW(16)
	OUT  0x15,R30
;    1056        	WR=1;
	SBI  0x1B,5
;    1057        	WR=0;
	CBI  0x1B,5
;    1058        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1059        	WR=1; 
	SBI  0x1B,5
;    1060        	return; 
	RJMP _0x159
;    1061 
;    1062 	case '5':
_0xA7:
	CPI  R30,LOW(0x35)
	BRNE _0xA8
;    1063        	WR=0;
	CBI  0x1B,5
;    1064        	Display_data=0x2F;
	LDI  R30,LOW(47)
	OUT  0x15,R30
;    1065        	WR=1;
	SBI  0x1B,5
;    1066        	WR=0;
	CBI  0x1B,5
;    1067        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1068        	WR=1;
	SBI  0x1B,5
;    1069        	WR=0;
	CBI  0x1B,5
;    1070        	Display_data=0x49;
	OUT  0x15,R30
;    1071        	WR=1;
	SBI  0x1B,5
;    1072        	WR=0;
	CBI  0x1B,5
;    1073        	Display_data=0x49;
	OUT  0x15,R30
;    1074        	WR=1;
	SBI  0x1B,5
;    1075        	WR=0;
	CBI  0x1B,5
;    1076        	Display_data=0x31;
	LDI  R30,LOW(49)
	OUT  0x15,R30
;    1077        	WR=1;
	SBI  0x1B,5
;    1078        	WR=0;
	CBI  0x1B,5
;    1079        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1080        	WR=1; 
	SBI  0x1B,5
;    1081        	return;        
	RJMP _0x159
;    1082 
;    1083 	case '6':
_0xA8:
	CPI  R30,LOW(0x36)
	BRNE _0xA9
;    1084        	WR=0;
	CBI  0x1B,5
;    1085        	Display_data=0x3C;
	LDI  R30,LOW(60)
	OUT  0x15,R30
;    1086        	WR=1;
	SBI  0x1B,5
;    1087        	WR=0;
	CBI  0x1B,5
;    1088        	Display_data=0x4A;
	LDI  R30,LOW(74)
	OUT  0x15,R30
;    1089        	WR=1;
	SBI  0x1B,5
;    1090        	WR=0;
	CBI  0x1B,5
;    1091        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1092        	WR=1;
	SBI  0x1B,5
;    1093        	WR=0;
	CBI  0x1B,5
;    1094        	Display_data=0x49;
	OUT  0x15,R30
;    1095        	WR=1;
	SBI  0x1B,5
;    1096        	WR=0;
	CBI  0x1B,5
;    1097        	Display_data=0x30;
	LDI  R30,LOW(48)
	OUT  0x15,R30
;    1098        	WR=1;
	SBI  0x1B,5
;    1099        	WR=0;
	CBI  0x1B,5
;    1100        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1101        	WR=1; 
	SBI  0x1B,5
;    1102        	return;       
	RJMP _0x159
;    1103        
;    1104        	case '7':
_0xA9:
	CPI  R30,LOW(0x37)
	BRNE _0xAA
;    1105        	WR=0;
	CBI  0x1B,5
;    1106        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1107        	WR=1;
	SBI  0x1B,5
;    1108        	WR=0;
	CBI  0x1B,5
;    1109        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1110        	WR=1;
	SBI  0x1B,5
;    1111        	WR=0;
	CBI  0x1B,5
;    1112        	Display_data=0x11;
	LDI  R30,LOW(17)
	OUT  0x15,R30
;    1113        	WR=1;
	SBI  0x1B,5
;    1114        	WR=0;
	CBI  0x1B,5
;    1115        	Display_data=0x0D;
	LDI  R30,LOW(13)
	OUT  0x15,R30
;    1116        	WR=1;
	SBI  0x1B,5
;    1117        	WR=0;
	CBI  0x1B,5
;    1118        	Display_data=0x03;
	LDI  R30,LOW(3)
	OUT  0x15,R30
;    1119        	WR=1;
	SBI  0x1B,5
;    1120        	WR=0;
	CBI  0x1B,5
;    1121        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1122        	WR=1; 
	SBI  0x1B,5
;    1123        	return;   
	RJMP _0x159
;    1124        
;    1125        	case '8':
_0xAA:
	CPI  R30,LOW(0x38)
	BRNE _0xAB
;    1126        	WR=0;
	CBI  0x1B,5
;    1127        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1128        	WR=1;
	SBI  0x1B,5
;    1129        	WR=0;
	CBI  0x1B,5
;    1130        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1131        	WR=1;
	SBI  0x1B,5
;    1132        	WR=0;
	CBI  0x1B,5
;    1133        	Display_data=0x49;
	OUT  0x15,R30
;    1134        	WR=1;
	SBI  0x1B,5
;    1135        	WR=0;
	CBI  0x1B,5
;    1136        	Display_data=0x49;
	OUT  0x15,R30
;    1137        	WR=1;
	SBI  0x1B,5
;    1138        	WR=0;
	CBI  0x1B,5
;    1139        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1140        	WR=1;
	SBI  0x1B,5
;    1141        	WR=0;
	CBI  0x1B,5
;    1142        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1143        	WR=1; 
	SBI  0x1B,5
;    1144        	return;          
	RJMP _0x159
;    1145 
;    1146 	case '9':
_0xAB:
	CPI  R30,LOW(0x39)
	BRNE _0xAC
;    1147        	WR=0;
	CBI  0x1B,5
;    1148        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1149        	WR=1;
	SBI  0x1B,5
;    1150        	WR=0;
	CBI  0x1B,5
;    1151        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1152        	WR=1;
	SBI  0x1B,5
;    1153        	WR=0;
	CBI  0x1B,5
;    1154        	Display_data=0x29;
	LDI  R30,LOW(41)
	OUT  0x15,R30
;    1155        	WR=1;
	SBI  0x1B,5
;    1156        	WR=0;
	CBI  0x1B,5
;    1157        	Display_data=0x19;
	LDI  R30,LOW(25)
	OUT  0x15,R30
;    1158        	WR=1;
	SBI  0x1B,5
;    1159        	WR=0;
	CBI  0x1B,5
;    1160        	Display_data=0x0E;
	LDI  R30,LOW(14)
	OUT  0x15,R30
;    1161        	WR=1;
	SBI  0x1B,5
;    1162        	WR=0;
	CBI  0x1B,5
;    1163        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1164        	WR=1; 
	SBI  0x1B,5
;    1165        	return;     
	RJMP _0x159
;    1166        
;    1167        	case 'A':
_0xAC:
	CPI  R30,LOW(0x41)
	BRNE _0xAD
;    1168        	WR=0;
	CBI  0x1B,5
;    1169        	Display_data=0x7C;
	LDI  R30,LOW(124)
	OUT  0x15,R30
;    1170        	WR=1;
	SBI  0x1B,5
;    1171        	WR=0;
	CBI  0x1B,5
;    1172        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;    1173        	WR=1;
	SBI  0x1B,5
;    1174        	WR=0;
	CBI  0x1B,5
;    1175        	Display_data=0x11;
	LDI  R30,LOW(17)
	OUT  0x15,R30
;    1176        	WR=1;
	SBI  0x1B,5
;    1177        	WR=0;
	CBI  0x1B,5
;    1178        	Display_data=0x12;
	LDI  R30,LOW(18)
	OUT  0x15,R30
;    1179        	WR=1;
	SBI  0x1B,5
;    1180        	WR=0;
	CBI  0x1B,5
;    1181        	Display_data=0x7C;
	LDI  R30,LOW(124)
	OUT  0x15,R30
;    1182        	WR=1;
	SBI  0x1B,5
;    1183        	WR=0;
	CBI  0x1B,5
;    1184        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1185        	WR=1; 
	SBI  0x1B,5
;    1186        	return;      
	RJMP _0x159
;    1187        
;    1188  	case 'B':
_0xAD:
	CPI  R30,LOW(0x42)
	BRNE _0xAE
;    1189        	WR=0;
	CBI  0x1B,5
;    1190        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1191        	WR=1;
	SBI  0x1B,5
;    1192        	WR=0;
	CBI  0x1B,5
;    1193        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1194        	WR=1;
	SBI  0x1B,5
;    1195        	WR=0;
	CBI  0x1B,5
;    1196        	Display_data=0x49;
	OUT  0x15,R30
;    1197        	WR=1;
	SBI  0x1B,5
;    1198        	WR=0;
	CBI  0x1B,5
;    1199        	Display_data=0x49;
	OUT  0x15,R30
;    1200        	WR=1;
	SBI  0x1B,5
;    1201        	WR=0;
	CBI  0x1B,5
;    1202        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1203        	WR=1;
	SBI  0x1B,5
;    1204        	WR=0;
	CBI  0x1B,5
;    1205        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1206        	WR=1; 
	SBI  0x1B,5
;    1207        	return;           
	RJMP _0x159
;    1208        
;    1209        	case 'C':
_0xAE:
	CPI  R30,LOW(0x43)
	BRNE _0xAF
;    1210        	WR=0;
	CBI  0x1B,5
;    1211        	Display_data=0x1C;
	LDI  R30,LOW(28)
	OUT  0x15,R30
;    1212        	WR=1;
	SBI  0x1B,5
;    1213        	WR=0;
	CBI  0x1B,5
;    1214        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1215        	WR=1;
	SBI  0x1B,5
;    1216        	WR=0;
	CBI  0x1B,5
;    1217        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1218        	WR=1;
	SBI  0x1B,5
;    1219        	WR=0;
	CBI  0x1B,5
;    1220        	Display_data=0x41;
	OUT  0x15,R30
;    1221        	WR=1;
	SBI  0x1B,5
;    1222        	WR=0;
	CBI  0x1B,5
;    1223        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1224        	WR=1;
	SBI  0x1B,5
;    1225        	WR=0;
	CBI  0x1B,5
;    1226        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1227        	WR=1; 
	SBI  0x1B,5
;    1228        	return;           
	RJMP _0x159
;    1229        
;    1230        	case 'D':
_0xAF:
	CPI  R30,LOW(0x44)
	BRNE _0xB0
;    1231        	WR=0;
	CBI  0x1B,5
;    1232        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1233        	WR=1;
	SBI  0x1B,5
;    1234        	WR=0;
	CBI  0x1B,5
;    1235        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1236        	WR=1;
	SBI  0x1B,5
;    1237        	WR=0;
	CBI  0x1B,5
;    1238        	Display_data=0x41;
	OUT  0x15,R30
;    1239        	WR=1;
	SBI  0x1B,5
;    1240        	WR=0;
	CBI  0x1B,5
;    1241        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1242        	WR=1;
	SBI  0x1B,5
;    1243        	WR=0;
	CBI  0x1B,5
;    1244        	Display_data=0x1C;
	LDI  R30,LOW(28)
	OUT  0x15,R30
;    1245        	WR=1;
	SBI  0x1B,5
;    1246        	WR=0;
	CBI  0x1B,5
;    1247        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1248        	WR=1; 
	SBI  0x1B,5
;    1249        	return;           
	RJMP _0x159
;    1250                  
;    1251         case 'E':
_0xB0:
	CPI  R30,LOW(0x45)
	BRNE _0xB1
;    1252        	WR=0;
	CBI  0x1B,5
;    1253        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1254        	WR=1;
	SBI  0x1B,5
;    1255        	WR=0;
	CBI  0x1B,5
;    1256        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1257        	WR=1;
	SBI  0x1B,5
;    1258        	WR=0;
	CBI  0x1B,5
;    1259        	Display_data=0x49;
	OUT  0x15,R30
;    1260        	WR=1;
	SBI  0x1B,5
;    1261        	WR=0;
	CBI  0x1B,5
;    1262        	Display_data=0x49;
	OUT  0x15,R30
;    1263        	WR=1;
	SBI  0x1B,5
;    1264        	WR=0;
	CBI  0x1B,5
;    1265        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1266        	WR=1;
	SBI  0x1B,5
;    1267        	WR=0;
	CBI  0x1B,5
;    1268        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1269        	WR=1; 
	SBI  0x1B,5
;    1270        	return;  
	RJMP _0x159
;    1271        
;    1272        	case 'F':
_0xB1:
	CPI  R30,LOW(0x46)
	BRNE _0xB2
;    1273        	WR=0;
	CBI  0x1B,5
;    1274        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1275        	WR=1;
	SBI  0x1B,5
;    1276        	WR=0;
	CBI  0x1B,5
;    1277        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1278        	WR=1;
	SBI  0x1B,5
;    1279        	WR=0;
	CBI  0x1B,5
;    1280        	Display_data=0x09;
	OUT  0x15,R30
;    1281        	WR=1;
	SBI  0x1B,5
;    1282        	WR=0;
	CBI  0x1B,5
;    1283        	Display_data=0x09;
	OUT  0x15,R30
;    1284        	WR=1;
	SBI  0x1B,5
;    1285        	WR=0;
	CBI  0x1B,5
;    1286        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1287        	WR=1;
	SBI  0x1B,5
;    1288        	WR=0;
	CBI  0x1B,5
;    1289        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1290        	WR=1; 
	SBI  0x1B,5
;    1291        	return;
	RJMP _0x159
;    1292               
;    1293        	case 'G':
_0xB2:
	CPI  R30,LOW(0x47)
	BRNE _0xB3
;    1294        	WR=0;
	CBI  0x1B,5
;    1295        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1296        	WR=1;
	SBI  0x1B,5
;    1297        	WR=0;
	CBI  0x1B,5
;    1298        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1299        	WR=1;
	SBI  0x1B,5
;    1300        	WR=0;
	CBI  0x1B,5
;    1301        	Display_data=0x41;
	OUT  0x15,R30
;    1302        	WR=1;
	SBI  0x1B,5
;    1303        	WR=0;
	CBI  0x1B,5
;    1304        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;    1305        	WR=1;
	SBI  0x1B,5
;    1306        	WR=0;
	CBI  0x1B,5
;    1307        	Display_data=0x32;
	LDI  R30,LOW(50)
	OUT  0x15,R30
;    1308        	WR=1;
	SBI  0x1B,5
;    1309        	WR=0;
	CBI  0x1B,5
;    1310        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1311        	WR=1;  
	SBI  0x1B,5
;    1312        	return;
	RJMP _0x159
;    1313               
;    1314        	case 'H':
_0xB3:
	CPI  R30,LOW(0x48)
	BRNE _0xB4
;    1315        	WR=0;
	CBI  0x1B,5
;    1316        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1317        	WR=1;
	SBI  0x1B,5
;    1318        	WR=0;
	CBI  0x1B,5
;    1319        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1320        	WR=1;
	SBI  0x1B,5
;    1321        	WR=0;
	CBI  0x1B,5
;    1322        	Display_data=0x08;
	OUT  0x15,R30
;    1323        	WR=1;
	SBI  0x1B,5
;    1324        	WR=0;
	CBI  0x1B,5
;    1325        	Display_data=0x08;
	OUT  0x15,R30
;    1326        	WR=1;
	SBI  0x1B,5
;    1327        	WR=0;
	CBI  0x1B,5
;    1328        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1329        	WR=1;
	SBI  0x1B,5
;    1330        	WR=0;
	CBI  0x1B,5
;    1331        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1332        	WR=1;  
	SBI  0x1B,5
;    1333        	return;
	RJMP _0x159
;    1334            
;    1335        	case 'I':
_0xB4:
	CPI  R30,LOW(0x49)
	BRNE _0xB5
;    1336        	WR=0;
	CBI  0x1B,5
;    1337        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1338        	WR=1;
	SBI  0x1B,5
;    1339        	WR=0;
	CBI  0x1B,5
;    1340        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1341        	WR=1;
	SBI  0x1B,5
;    1342        	WR=0;
	CBI  0x1B,5
;    1343        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1344        	WR=1;
	SBI  0x1B,5
;    1345        	WR=0;
	CBI  0x1B,5
;    1346        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1347        	WR=1;
	SBI  0x1B,5
;    1348        	WR=0;
	CBI  0x1B,5
;    1349        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1350        	WR=0;
	CBI  0x1B,5
;    1351        	Display_data=0x00;
	OUT  0x15,R30
;    1352        	WR=1; 
	SBI  0x1B,5
;    1353        	return;  
	RJMP _0x159
;    1354        
;    1355        	case 'J':
_0xB5:
	CPI  R30,LOW(0x4A)
	BRNE _0xB6
;    1356        	WR=0;
	CBI  0x1B,5
;    1357        	Display_data=0x20;
	LDI  R30,LOW(32)
	OUT  0x15,R30
;    1358        	WR=1;
	SBI  0x1B,5
;    1359        	WR=0;
	CBI  0x1B,5
;    1360        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1361        	WR=1;
	SBI  0x1B,5
;    1362        	WR=0;
	CBI  0x1B,5
;    1363        	Display_data=0x40;
	OUT  0x15,R30
;    1364        	WR=1;
	SBI  0x1B,5
;    1365        	WR=0;
	CBI  0x1B,5
;    1366        	Display_data=0x40;
	OUT  0x15,R30
;    1367        	WR=1;
	SBI  0x1B,5
;    1368        	WR=0;
	CBI  0x1B,5
;    1369        	Display_data=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1370        	WR=1;
	SBI  0x1B,5
;    1371        	WR=0;
	CBI  0x1B,5
;    1372        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1373        	WR=1; 
	SBI  0x1B,5
;    1374        	return;
	RJMP _0x159
;    1375        
;    1376        	case 'K':
_0xB6:
	CPI  R30,LOW(0x4B)
	BRNE _0xB7
;    1377        	WR=0;
	CBI  0x1B,5
;    1378        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1379        	WR=1;
	SBI  0x1B,5
;    1380        	WR=0;
	CBI  0x1B,5
;    1381        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1382        	WR=1;
	SBI  0x1B,5
;    1383        	WR=0;
	CBI  0x1B,5
;    1384        	Display_data=0x14;
	LDI  R30,LOW(20)
	OUT  0x15,R30
;    1385        	WR=1;
	SBI  0x1B,5
;    1386        	WR=0;
	CBI  0x1B,5
;    1387        	Display_data=0x22;
	LDI  R30,LOW(34)
	OUT  0x15,R30
;    1388        	WR=1;
	SBI  0x1B,5
;    1389        	WR=0;
	CBI  0x1B,5
;    1390        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1391        	WR=1;
	SBI  0x1B,5
;    1392        	WR=0;
	CBI  0x1B,5
;    1393        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1394        	WR=1; 
	SBI  0x1B,5
;    1395        	return;
	RJMP _0x159
;    1396                  
;    1397        	case 'L':
_0xB7:
	CPI  R30,LOW(0x4C)
	BRNE _0xB8
;    1398        	WR=0;
	CBI  0x1B,5
;    1399        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1400        	WR=1;
	SBI  0x1B,5
;    1401        	WR=0;
	CBI  0x1B,5
;    1402        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1403        	WR=1;
	SBI  0x1B,5
;    1404        	WR=0;
	CBI  0x1B,5
;    1405        	Display_data=0x40;
	OUT  0x15,R30
;    1406        	WR=1;
	SBI  0x1B,5
;    1407        	WR=0;
	CBI  0x1B,5
;    1408        	Display_data=0x40;
	OUT  0x15,R30
;    1409        	WR=1;
	SBI  0x1B,5
;    1410        	WR=0;
	CBI  0x1B,5
;    1411        	Display_data=0x40;
	OUT  0x15,R30
;    1412        	WR=1;
	SBI  0x1B,5
;    1413        	WR=0;
	CBI  0x1B,5
;    1414        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1415        	WR=1; 
	SBI  0x1B,5
;    1416        	return; 
	RJMP _0x159
;    1417        
;    1418   	case 'M':
_0xB8:
	CPI  R30,LOW(0x4D)
	BRNE _0xB9
;    1419        	WR=0;
	CBI  0x1B,5
;    1420        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1421        	WR=1;
	SBI  0x1B,5
;    1422        	WR=0;
	CBI  0x1B,5
;    1423        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;    1424        	WR=1;
	SBI  0x1B,5
;    1425        	WR=0;
	CBI  0x1B,5
;    1426        	Display_data=0x04;
	LDI  R30,LOW(4)
	OUT  0x15,R30
;    1427        	WR=1;
	SBI  0x1B,5
;    1428        	WR=0;
	CBI  0x1B,5
;    1429        	Display_data=0x02;
	LDI  R30,LOW(2)
	OUT  0x15,R30
;    1430        	WR=1;
	SBI  0x1B,5
;    1431        	WR=0;
	CBI  0x1B,5
;    1432        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1433        	WR=1;
	SBI  0x1B,5
;    1434        	WR=0;
	CBI  0x1B,5
;    1435        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1436        	WR=1; 
	SBI  0x1B,5
;    1437        	return;
	RJMP _0x159
;    1438        
;    1439        	case 'N':
_0xB9:
	CPI  R30,LOW(0x4E)
	BRNE _0xBA
;    1440        	WR=0;
	CBI  0x1B,5
;    1441        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1442        	WR=1;
	SBI  0x1B,5
;    1443        	WR=0;
	CBI  0x1B,5
;    1444        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1445        	WR=1;
	SBI  0x1B,5
;    1446        	WR=0;
	CBI  0x1B,5
;    1447        	Display_data=0x18;
	LDI  R30,LOW(24)
	OUT  0x15,R30
;    1448        	WR=1;
	SBI  0x1B,5
;    1449        	WR=0;
	CBI  0x1B,5
;    1450        	Display_data=0x20;
	LDI  R30,LOW(32)
	OUT  0x15,R30
;    1451        	WR=1;
	SBI  0x1B,5
;    1452        	WR=0;
	CBI  0x1B,5
;    1453        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1454        	WR=1;
	SBI  0x1B,5
;    1455        	WR=0;
	CBI  0x1B,5
;    1456        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1457        	WR=1; 
	SBI  0x1B,5
;    1458        	return;
	RJMP _0x159
;    1459           
;    1460         case 'O':
_0xBA:
	CPI  R30,LOW(0x4F)
	BRNE _0xBB
;    1461        	WR=0;
	CBI  0x1B,5
;    1462        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1463        	WR=1;
	SBI  0x1B,5
;    1464        	WR=0;
	CBI  0x1B,5
;    1465        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1466        	WR=1;
	SBI  0x1B,5
;    1467        	WR=0;
	CBI  0x1B,5
;    1468        	Display_data=0x41;
	OUT  0x15,R30
;    1469        	WR=1;
	SBI  0x1B,5
;    1470        	WR=0;
	CBI  0x1B,5
;    1471        	Display_data=0x41;
	OUT  0x15,R30
;    1472        	WR=1;
	SBI  0x1B,5
;    1473        	WR=0;
	CBI  0x1B,5
;    1474        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1475        	WR=1;
	SBI  0x1B,5
;    1476        	WR=0;
	CBI  0x1B,5
;    1477        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1478        	WR=1;
	SBI  0x1B,5
;    1479 	return;	   
	RJMP _0x159
;    1480        
;    1481 	case 'P':
_0xBB:
	CPI  R30,LOW(0x50)
	BRNE _0xBC
;    1482  	WR=0;
	CBI  0x1B,5
;    1483        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1484        	WR=1;
	SBI  0x1B,5
;    1485        	WR=0;
	CBI  0x1B,5
;    1486        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1487        	WR=1;
	SBI  0x1B,5
;    1488        	WR=0;
	CBI  0x1B,5
;    1489        	Display_data=0x09;
	OUT  0x15,R30
;    1490        	WR=1;
	SBI  0x1B,5
;    1491        	WR=0;
	CBI  0x1B,5
;    1492        	Display_data=0x09;
	OUT  0x15,R30
;    1493        	WR=1;
	SBI  0x1B,5
;    1494        	WR=0;
	CBI  0x1B,5
;    1495        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1496        	WR=1; 
	SBI  0x1B,5
;    1497        	WR=0;
	CBI  0x1B,5
;    1498        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1499        	WR=1; 
	SBI  0x1B,5
;    1500        	return;
	RJMP _0x159
;    1501        
;    1502   	case 'Q':
_0xBC:
	CPI  R30,LOW(0x51)
	BRNE _0xBD
;    1503    	WR=0;
	CBI  0x1B,5
;    1504        	Display_data=0x3E;
	LDI  R30,LOW(62)
	OUT  0x15,R30
;    1505        	WR=1;
	SBI  0x1B,5
;    1506        	WR=0;
	CBI  0x1B,5
;    1507        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1508        	WR=1;
	SBI  0x1B,5
;    1509        	WR=0;
	CBI  0x1B,5
;    1510        	Display_data=0x41;
	OUT  0x15,R30
;    1511        	WR=1;
	SBI  0x1B,5
;    1512        	WR=0;
	CBI  0x1B,5
;    1513        	Display_data=0x61;
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1514        	WR=1;
	SBI  0x1B,5
;    1515        	WR=0;
	CBI  0x1B,5
;    1516        	Display_data=0x7E;
	LDI  R30,LOW(126)
	OUT  0x15,R30
;    1517        	WR=1;
	SBI  0x1B,5
;    1518        	WR=0;
	CBI  0x1B,5
;    1519        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1520        	WR=1;
	SBI  0x1B,5
;    1521 	return;	   
	RJMP _0x159
;    1522       
;    1523 	
;    1524 	case 'R':
_0xBD:
	CPI  R30,LOW(0x52)
	BRNE _0xBE
;    1525  	WR=0;
	CBI  0x1B,5
;    1526        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1527        	WR=1;
	SBI  0x1B,5
;    1528        	WR=0;
	CBI  0x1B,5
;    1529        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1530        	WR=1;
	SBI  0x1B,5
;    1531        	WR=0;
	CBI  0x1B,5
;    1532        	Display_data=0x19;
	LDI  R30,LOW(25)
	OUT  0x15,R30
;    1533        	WR=1;
	SBI  0x1B,5
;    1534        	WR=0;
	CBI  0x1B,5
;    1535        	Display_data=0x29; 
	LDI  R30,LOW(41)
	OUT  0x15,R30
;    1536        	WR=1;
	SBI  0x1B,5
;    1537        	WR=0;
	CBI  0x1B,5
;    1538        	Display_data=0x46; 
	LDI  R30,LOW(70)
	OUT  0x15,R30
;    1539        	WR=1;  
	SBI  0x1B,5
;    1540        	WR=0;
	CBI  0x1B,5
;    1541        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1542        	WR=1; 
	SBI  0x1B,5
;    1543        	return;   
	RJMP _0x159
;    1544        
;    1545        	case 'S':
_0xBE:
	CPI  R30,LOW(0x53)
	BRNE _0xBF
;    1546   	WR=0;
	CBI  0x1B,5
;    1547        	Display_data=0x26;
	LDI  R30,LOW(38)
	OUT  0x15,R30
;    1548        	WR=1;
	SBI  0x1B,5
;    1549        	WR=0;
	CBI  0x1B,5
;    1550        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1551        	WR=1;
	SBI  0x1B,5
;    1552        	WR=0;
	CBI  0x1B,5
;    1553        	Display_data=0x49;
	OUT  0x15,R30
;    1554        	WR=1;
	SBI  0x1B,5
;    1555        	WR=0;
	CBI  0x1B,5
;    1556        	Display_data=0x49; 
	OUT  0x15,R30
;    1557        	WR=1; 
	SBI  0x1B,5
;    1558        	WR=0;
	CBI  0x1B,5
;    1559        	Display_data=0x32;
	LDI  R30,LOW(50)
	OUT  0x15,R30
;    1560        	WR=1; 
	SBI  0x1B,5
;    1561        	WR=0;
	CBI  0x1B,5
;    1562        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1563        	WR=1; 
	SBI  0x1B,5
;    1564        	return;
	RJMP _0x159
;    1565   
;    1566   	case 'T':
_0xBF:
	CPI  R30,LOW(0x54)
	BRNE _0xC0
;    1567    	WR=0;
	CBI  0x1B,5
;    1568        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1569        	WR=1;
	SBI  0x1B,5
;    1570        	WR=0;
	CBI  0x1B,5
;    1571        	Display_data=0x01;
	OUT  0x15,R30
;    1572        	WR=1;
	SBI  0x1B,5
;    1573        	WR=0;
	CBI  0x1B,5
;    1574        	Display_data=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;    1575        	WR=1;
	SBI  0x1B,5
;    1576        	WR=0;
	CBI  0x1B,5
;    1577        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1578        	WR=1;
	SBI  0x1B,5
;    1579        	WR=0;
	CBI  0x1B,5
;    1580        	Display_data=0x01;
	OUT  0x15,R30
;    1581        	WR=1;
	SBI  0x1B,5
;    1582        	WR=0;
	CBI  0x1B,5
;    1583        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1584        	WR=1;
	SBI  0x1B,5
;    1585        	return;
	RJMP _0x159
;    1586 	  
;    1587 	        
;    1588   	case 'U':
_0xC0:
	CPI  R30,LOW(0x55)
	BRNE _0xC1
;    1589    	WR=0;
	CBI  0x1B,5
;    1590        	Display_data=0x3F; 
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1591        	WR=1;
	SBI  0x1B,5
;    1592        	WR=0;
	CBI  0x1B,5
;    1593        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1594        	WR=1;
	SBI  0x1B,5
;    1595        	WR=0;
	CBI  0x1B,5
;    1596        	Display_data=0x40;
	OUT  0x15,R30
;    1597        	WR=1;
	SBI  0x1B,5
;    1598        	WR=0;
	CBI  0x1B,5
;    1599        	Display_data=0x40; 
	OUT  0x15,R30
;    1600        	WR=1;
	SBI  0x1B,5
;    1601        	WR=0;
	CBI  0x1B,5
;    1602        	Display_data=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
;    1603        	WR=1;
	SBI  0x1B,5
;    1604        	WR=0;
	CBI  0x1B,5
;    1605        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1606        	WR=1;
	SBI  0x1B,5
;    1607        	return;
	RJMP _0x159
;    1608                   
;    1609    	case 'V':
_0xC1:
	CPI  R30,LOW(0x56)
	BRNE _0xC2
;    1610     	WR=0;
	CBI  0x1B,5
;    1611        	Display_data=0x0F; 
	LDI  R30,LOW(15)
	OUT  0x15,R30
;    1612        	WR=1;
	SBI  0x1B,5
;    1613        	WR=0;
	CBI  0x1B,5
;    1614        	Display_data=0x30;
	LDI  R30,LOW(48)
	OUT  0x15,R30
;    1615        	WR=1;
	SBI  0x1B,5
;    1616        	WR=0;
	CBI  0x1B,5
;    1617        	Display_data=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
;    1618        	WR=1;
	SBI  0x1B,5
;    1619        	WR=0;
	CBI  0x1B,5
;    1620        	Display_data=0x30; 
	LDI  R30,LOW(48)
	OUT  0x15,R30
;    1621        	WR=1;
	SBI  0x1B,5
;    1622        	WR=0;
	CBI  0x1B,5
;    1623        	Display_data=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
;    1624        	WR=1;
	SBI  0x1B,5
;    1625        	WR=0;
	CBI  0x1B,5
;    1626        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1627        	WR=1;
	SBI  0x1B,5
;    1628        	return;
	RJMP _0x159
;    1629                
;    1630      	case 'W':
_0xC2:
	CPI  R30,LOW(0x57)
	BRNE _0xC3
;    1631      	WR=0;
	CBI  0x1B,5
;    1632        	Display_data=0x1F; 
	LDI  R30,LOW(31)
	OUT  0x15,R30
;    1633        	WR=1;
	SBI  0x1B,5
;    1634        	WR=0;
	CBI  0x1B,5
;    1635        	Display_data=0x60;
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1636        	WR=1;
	SBI  0x1B,5
;    1637        	WR=0;
	CBI  0x1B,5
;    1638        	Display_data=0x0C;
	LDI  R30,LOW(12)
	OUT  0x15,R30
;    1639        	WR=1;
	SBI  0x1B,5
;    1640        	WR=0;
	CBI  0x1B,5
;    1641        	Display_data=0x60; 
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1642        	WR=1;
	SBI  0x1B,5
;    1643        	WR=0;
	CBI  0x1B,5
;    1644        	Display_data=0x1F;
	LDI  R30,LOW(31)
	OUT  0x15,R30
;    1645        	WR=1;
	SBI  0x1B,5
;    1646        	WR=0;
	CBI  0x1B,5
;    1647        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1648        	WR=1;
	SBI  0x1B,5
;    1649        	return;
	RJMP _0x159
;    1650        
;    1651         case 'X':
_0xC3:
	CPI  R30,LOW(0x58)
	BRNE _0xC4
;    1652       	WR=0;
	CBI  0x1B,5
;    1653        	Display_data=0x41; 
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1654        	WR=1;
	SBI  0x1B,5
;    1655        	WR=0;
	CBI  0x1B,5
;    1656        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1657        	WR=1;
	SBI  0x1B,5
;    1658        	WR=0;
	CBI  0x1B,5
;    1659        	Display_data=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
;    1660        	WR=1;
	SBI  0x1B,5
;    1661        	WR=0;
	CBI  0x1B,5
;    1662        	Display_data=0x36; 
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1663        	WR=1;
	SBI  0x1B,5
;    1664        	WR=0;
	CBI  0x1B,5
;    1665        	Display_data=0x41;
	LDI  R30,LOW(65)
	OUT  0x15,R30
;    1666        	WR=1;
	SBI  0x1B,5
;    1667        	WR=0;
	CBI  0x1B,5
;    1668        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1669        	WR=1;
	SBI  0x1B,5
;    1670        	return;  
	RJMP _0x159
;    1671        
;    1672        	case 'Y':
_0xC4:
	CPI  R30,LOW(0x59)
	BRNE _0xC5
;    1673       	WR=0;
	CBI  0x1B,5
;    1674        	Display_data=0x01; 
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1675        	WR=1;
	SBI  0x1B,5
;    1676        	WR=0;
	CBI  0x1B,5
;    1677        	Display_data=0x06;
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1678        	WR=1;
	SBI  0x1B,5
;    1679        	WR=0;
	CBI  0x1B,5
;    1680        	Display_data=0x78;
	LDI  R30,LOW(120)
	OUT  0x15,R30
;    1681        	WR=1;
	SBI  0x1B,5
;    1682        	WR=0;
	CBI  0x1B,5
;    1683        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1684        	WR=1;
	SBI  0x1B,5
;    1685        	WR=0;
	CBI  0x1B,5
;    1686        	Display_data=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
;    1687        	WR=1;
	SBI  0x1B,5
;    1688        	WR=0;
	CBI  0x1B,5
;    1689        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1690        	WR=1;
	SBI  0x1B,5
;    1691        	return;   
	RJMP _0x159
;    1692        
;    1693        	case 'Z':
_0xC5:
	CPI  R30,LOW(0x5A)
	BRNE _0xC6
;    1694    	WR=0;
	CBI  0x1B,5
;    1695        	Display_data=0x61; 
	LDI  R30,LOW(97)
	OUT  0x15,R30
;    1696        	WR=1;
	SBI  0x1B,5
;    1697        	WR=0;
	CBI  0x1B,5
;    1698        	Display_data=0x51;
	LDI  R30,LOW(81)
	OUT  0x15,R30
;    1699        	WR=1;
	SBI  0x1B,5
;    1700        	WR=0;
	CBI  0x1B,5
;    1701        	Display_data=0x49;
	LDI  R30,LOW(73)
	OUT  0x15,R30
;    1702        	WR=1;
	SBI  0x1B,5
;    1703        	WR=0;
	CBI  0x1B,5
;    1704        	Display_data=0x45; 
	LDI  R30,LOW(69)
	OUT  0x15,R30
;    1705        	WR=1;
	SBI  0x1B,5
;    1706        	WR=0;
	CBI  0x1B,5
;    1707        	Display_data=0x43;
	LDI  R30,LOW(67)
	OUT  0x15,R30
;    1708        	WR=1;
	SBI  0x1B,5
;    1709        	WR=0;
	CBI  0x1B,5
;    1710        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1711        	WR=1;
	SBI  0x1B,5
;    1712        	return;   
	RJMP _0x159
;    1713                
;    1714     	case 'd'://degree sign
_0xC6:
	CPI  R30,LOW(0x64)
	BRNE _0xC7
;    1715      	WR=0;
	CBI  0x1B,5
;    1716        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1717        	WR=1;
	SBI  0x1B,5
;    1718        	WR=0;
	CBI  0x1B,5
;    1719        	Display_data=0x09;
	LDI  R30,LOW(9)
	OUT  0x15,R30
;    1720        	WR=1;
	SBI  0x1B,5
;    1721        	WR=0;
	CBI  0x1B,5
;    1722        	Display_data=0x09;
	OUT  0x15,R30
;    1723        	WR=1;
	SBI  0x1B,5
;    1724        	WR=0;
	CBI  0x1B,5
;    1725        	Display_data=0x06; 
	LDI  R30,LOW(6)
	OUT  0x15,R30
;    1726        	WR=1;
	SBI  0x1B,5
;    1727        	WR=0;
	CBI  0x1B,5
;    1728        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1729        	WR=1;
	SBI  0x1B,5
;    1730        	WR=0;
	CBI  0x1B,5
;    1731        	Display_data=0x00;
	OUT  0x15,R30
;    1732        	WR=1;
	SBI  0x1B,5
;    1733        	return;  
	RJMP _0x159
;    1734        
;    1735        	case ',':
_0xC7:
	CPI  R30,LOW(0x2C)
	BRNE _0xC8
;    1736       	WR=0;
	CBI  0x1B,5
;    1737        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1738        	WR=1;
	SBI  0x1B,5
;    1739        	WR=0;
	CBI  0x1B,5
;    1740        	Display_data=0x00;
	OUT  0x15,R30
;    1741        	WR=1;
	SBI  0x1B,5
;    1742        	WR=0;
	CBI  0x1B,5
;    1743        	Display_data=0xB0;
	LDI  R30,LOW(176)
	OUT  0x15,R30
;    1744        	WR=1;
	SBI  0x1B,5
;    1745        	WR=0;
	CBI  0x1B,5
;    1746        	Display_data=0x70; 
	LDI  R30,LOW(112)
	OUT  0x15,R30
;    1747        	WR=1;
	SBI  0x1B,5
;    1748        	WR=0;
	CBI  0x1B,5
;    1749        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1750        	WR=1;
	SBI  0x1B,5
;    1751        	WR=0;
	CBI  0x1B,5
;    1752        	Display_data=0x00;
	OUT  0x15,R30
;    1753        	WR=1;
	SBI  0x1B,5
;    1754        	return;      
	RJMP _0x159
;    1755        	
;    1756        	case ':':
_0xC8:
	CPI  R30,LOW(0x3A)
	BRNE _0xC9
;    1757       	WR=0;
	CBI  0x1B,5
;    1758        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1759        	WR=1;
	SBI  0x1B,5
;    1760        	WR=0;
	CBI  0x1B,5
;    1761        	Display_data=0x00;
	OUT  0x15,R30
;    1762        	WR=1;
	SBI  0x1B,5
;    1763        	WR=0;
	CBI  0x1B,5
;    1764        	Display_data=0x36;
	LDI  R30,LOW(54)
	OUT  0x15,R30
;    1765        	WR=1;
	SBI  0x1B,5
;    1766        	WR=0;
	CBI  0x1B,5
;    1767        	Display_data=0x36; 
	OUT  0x15,R30
;    1768        	WR=1;
	SBI  0x1B,5
;    1769        	WR=0;
	CBI  0x1B,5
;    1770        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1771        	WR=1;
	SBI  0x1B,5
;    1772        	WR=0;
	CBI  0x1B,5
;    1773        	Display_data=0x00;
	OUT  0x15,R30
;    1774        	WR=1;
	SBI  0x1B,5
;    1775        	return;  
	RJMP _0x159
;    1776        	
;    1777        	case '.':
_0xC9:
	CPI  R30,LOW(0x2E)
	BRNE _0xCA
;    1778       	WR=0;
	CBI  0x1B,5
;    1779        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1780        	WR=1;
	SBI  0x1B,5
;    1781        	WR=0;
	CBI  0x1B,5
;    1782        	Display_data=0x00;
	OUT  0x15,R30
;    1783        	WR=1;
	SBI  0x1B,5
;    1784        	WR=0;
	CBI  0x1B,5
;    1785        	Display_data=0x60;
	LDI  R30,LOW(96)
	OUT  0x15,R30
;    1786        	WR=1;
	SBI  0x1B,5
;    1787        	WR=0;
	CBI  0x1B,5
;    1788        	Display_data=0x60; 
	OUT  0x15,R30
;    1789        	WR=1;
	SBI  0x1B,5
;    1790        	WR=0;
	CBI  0x1B,5
;    1791        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1792        	WR=1;
	SBI  0x1B,5
;    1793        	WR=0;
	CBI  0x1B,5
;    1794        	Display_data=0x00;
	OUT  0x15,R30
;    1795        	WR=1;
	SBI  0x1B,5
;    1796        	return;  
	RJMP _0x159
;    1797        	
;    1798        	case ';':
_0xCA:
	CPI  R30,LOW(0x3B)
	BRNE _0xA1
;    1799       	WR=0;
	CBI  0x1B,5
;    1800        	Display_data=0x00; 
	CLR  R30
	OUT  0x15,R30
;    1801        	WR=1;
	SBI  0x1B,5
;    1802        	WR=0;
	CBI  0x1B,5
;    1803        	Display_data=0x00;
	OUT  0x15,R30
;    1804        	WR=1;
	SBI  0x1B,5
;    1805        	WR=0;
	CBI  0x1B,5
;    1806        	Display_data=0xB6;
	LDI  R30,LOW(182)
	OUT  0x15,R30
;    1807        	WR=1;
	SBI  0x1B,5
;    1808        	WR=0;
	CBI  0x1B,5
;    1809        	Display_data=0x76; 
	LDI  R30,LOW(118)
	OUT  0x15,R30
;    1810        	WR=1;
	SBI  0x1B,5
;    1811        	WR=0;
	CBI  0x1B,5
;    1812        	Display_data=0x00;
	CLR  R30
	OUT  0x15,R30
;    1813        	WR=1;
	SBI  0x1B,5
;    1814        	WR=0;
	CBI  0x1B,5
;    1815        	Display_data=0x00;
	OUT  0x15,R30
;    1816        	WR=1;
	SBI  0x1B,5
;    1817        	return;        
;    1818 	} 	
_0xA1:
;    1819 } 
_0x159:
	ADIW R28,5
	RET
;    1820 
;    1821 //Clear display
;    1822 void clear_display(void)
;    1823 {
_clear_display:
;    1824 unsigned char i, j;
;    1825 
;    1826 for(j=0;j<8;j++)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16
;	j -> R17
	LDI  R17,LOW(0)
_0xCE:
	CPI  R17,8
	BRSH _0xCF
;    1827 	{
;    1828 	for(i=0;i<18;i++)
	LDI  R16,LOW(0)
_0xD1:
	CPI  R16,18
	BRSH _0xD2
;    1829  		{
;    1830         	Write(' ', j, i);
	LDI  R30,LOW(32)
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
;    1831         	}
	SUBI R16,-1
	RJMP _0xD1
_0xD2:
;    1832 	}  
	SUBI R17,-1
	RJMP _0xCE
_0xCF:
;    1833 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1834 /************************************************************************** 
;    1835 Name: 		nmea.c
;    1836 Comments:	NMEA functions
;    1837 **************************************************************************/  
;    1838 
;    1839 #include "display.h"
;    1840 #include "nmea.h"
;    1841 
;    1842 //Put navigation data on display
;    1843 void display_nmea(void)
;    1844 {
_display_nmea:
;    1845 
;    1846 //Indicates which nmea sentence we recievied according to def's in nmea.h, just for testing.
;    1847 //Write(nmeaID, 6, 15); 
;    1848 
;    1849 Write('L', 1, 0); Write('A', 1, 1); Write('T', 1, 2); Write(' ', 1, 3);
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x7
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x1C
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Write
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xB
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xC
;    1850 Write(' ', 1, 4);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xD
;    1851 Write('L', 2, 0); Write('O', 2, 1); Write('N', 2, 2); Write(' ', 2, 3); 
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x7
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x9
	LDI  R30,LOW(78)
	RCALL SUBOPT_0x1D
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xC
;    1852 
;    1853 //only put position data (LAT/LON) on the display if we recieve a valid NMEA msg
;    1854 if (valid_nmea == 1)
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ PC+3
	JMP _0xDB
;    1855         {
;    1856        //Display: LAT <latitude><N/S>
;    1857         Write(tracking_pkt_buf[0], 1, 5);
	LDS  R30,_tracking_pkt_buf
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0xE
;    1858         Write(tracking_pkt_buf[1], 1, 6);
	__GETB1MN _tracking_pkt_buf,1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x16
;    1859         Write('d', 1, 7);                  //degree sign
	LDI  R30,LOW(100)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x14
;    1860         Write(tracking_pkt_buf[2], 1, 8);
	__GETB1MN _tracking_pkt_buf,2
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1F
;    1861         Write(tracking_pkt_buf[3], 1, 9);
	__GETB1MN _tracking_pkt_buf,3
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x20
;    1862         Write(tracking_pkt_buf[4], 1, 10);
	__GETB1MN _tracking_pkt_buf,4
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x2
;    1863         Write(tracking_pkt_buf[5], 1, 11);
	__GETB1MN _tracking_pkt_buf,5
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x3
;    1864         Write(tracking_pkt_buf[6], 1, 12);
	__GETB1MN _tracking_pkt_buf,6
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x4
;    1865         Write(tracking_pkt_buf[7], 1, 13);
	__GETB1MN _tracking_pkt_buf,7
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x5
;    1866         Write(tracking_pkt_buf[8], 1, 14);   
	__GETB1MN _tracking_pkt_buf,8
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x21
;    1867         Write(tracking_pkt_buf[9], 1, 15); //N or S
	__GETB1MN _tracking_pkt_buf,9
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x22
;    1868         
;    1869         //Display: LON <longitude><E/W>
;    1870         if(tracking_pkt_buf[11] != '0')	//if it is a 0, don't write it, looks better on the display.
	__GETB1MN _tracking_pkt_buf,11
	CPI  R30,LOW(0x30)
	BREQ _0xDC
;    1871         	{
;    1872         	Write(tracking_pkt_buf[11], 2, 4);
	__GETB1MN _tracking_pkt_buf,11
	RJMP _0x15C
;    1873         	}
;    1874         else
_0xDC:
;    1875         	{
;    1876         	Write(' ', 2, 4);
	LDI  R30,LOW(32)
_0x15C:
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0xD
;    1877         	}
;    1878         Write(tracking_pkt_buf[12], 2, 5);
	__GETB1MN _tracking_pkt_buf,12
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0xE
;    1879         Write(tracking_pkt_buf[13], 2, 6);
	__GETB1MN _tracking_pkt_buf,13
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x16
;    1880         Write('d', 2, 7);                  //degree sign
	LDI  R30,LOW(100)
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x14
;    1881         Write(tracking_pkt_buf[14], 2, 8);
	__GETB1MN _tracking_pkt_buf,14
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1F
;    1882         Write(tracking_pkt_buf[15], 2, 9);
	__GETB1MN _tracking_pkt_buf,15
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x20
;    1883         Write(tracking_pkt_buf[16], 2, 10);
	__GETB1MN _tracking_pkt_buf,16
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x2
;    1884         Write(tracking_pkt_buf[17], 2, 11);
	__GETB1MN _tracking_pkt_buf,17
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x3
;    1885         Write(tracking_pkt_buf[18], 2, 12);
	__GETB1MN _tracking_pkt_buf,18
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x4
;    1886         Write(tracking_pkt_buf[19], 2, 13);
	__GETB1MN _tracking_pkt_buf,19
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x5
;    1887         Write(tracking_pkt_buf[20], 2, 14);  
	__GETB1MN _tracking_pkt_buf,20
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x21
;    1888         Write(tracking_pkt_buf[21], 2, 15); //E or W
	__GETB1MN _tracking_pkt_buf,21
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x22
;    1889       
;    1890         }
;    1891         
;    1892 }  
_0xDB:
	RET
;    1893 
;    1894 
;    1895 
;    1896 //Parse nmea messages GLL and RMC
;    1897 void nmea_parse(unsigned char nmea_msg_type)
;    1898 {
_nmea_parse:
;    1899  /*
;    1900 //Parse GLL message. Find LAT, LON, UTC. Parsing GLL msg is mainly used under SW development.
;    1901 //(Not really necessary.)
;    1902 if (nmea_msg_type == GLL)
;    1903 	{
;    1904 	i = 0;
;    1905 	index1 = 6;
;    1906 	if (nmea_data[index1] == ',')    //sjekk for komma, hvis komma, ugyldig melding
;    1907         	{
;    1908         	Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    1909         	valid_nmea = 0;
;    1910         	return;
;    1911         	}
;    1912 	
;    1913 	//find LAT
;    1914 	while (nmea_data[index1] != ',')
;    1915 		{
;    1916 		LAT[i] = nmea_data[index1];
;    1917 		index1++;
;    1918 		i++;
;    1919 		}
;    1920     	if(nmea_data[index1] == ',')
;    1921     		{
;    1922     		index1++;	//Jump over ','
;    1923     		}
;    1924     	else
;    1925     		{
;    1926     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    1927     		valid_nmea = 0;
;    1928     		return;
;    1929     		}  
;    1930     		
;    1931     	//find LAT N or S
;    1932     	while (nmea_data[index1] != ',')
;    1933 		{
;    1934 		LAT[i] = nmea_data[index1];
;    1935 		index1++;
;    1936 		i++;
;    1937 		}
;    1938     	if(nmea_data[index1] == ',')
;    1939     		{
;    1940     		index1++;	//Jump over ','
;    1941     		}
;    1942     	else
;    1943     		{
;    1944     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    1945     		valid_nmea = 0;
;    1946     		return;
;    1947     		}    		
;    1948     	    		
;    1949 	//Find LON
;    1950 	i=0;
;    1951     	while (nmea_data[index1] != ',')
;    1952 		{
;    1953 		LON[i] = nmea_data[index1];
;    1954 		index1++;
;    1955 		i++;
;    1956 		}
;    1957     	if(nmea_data[index1] == ',')
;    1958     		{
;    1959     		index1++;	//Jump over ','
;    1960     		}
;    1961     	else
;    1962     		{
;    1963     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    1964     		valid_nmea = 0;
;    1965     		return;
;    1966     		} 
;    1967     		   		
;    1968 	//Find LON E or W
;    1969 	while (nmea_data[index1] != ',')
;    1970 		{
;    1971 		LON[i] = nmea_data[index1];
;    1972 		index1++;
;    1973 		i++;
;    1974 		}
;    1975     	if(nmea_data[index1] == ',')
;    1976     		{
;    1977     		index1++;	//Jump over ','
;    1978     		}
;    1979     	else
;    1980     		{
;    1981     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    1982     		valid_nmea = 0;
;    1983     		return;
;    1984     		}    		
;    1985     	    		
;    1986 	//Find UTC
;    1987 	i=0;
;    1988     	while (nmea_data[index1] != ',')
;    1989 		{
;    1990 		UTC[i] = nmea_data[index1];
;    1991 		index1++;
;    1992 		i++;
;    1993 		}
;    1994     	if(nmea_data[index1] == ',')
;    1995     		{
;    1996     		index1++;	//Jump over ','
;    1997     		}
;    1998     	else
;    1999     		{
;    2000     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    2001     		valid_nmea = 0;
;    2002     		return;
;    2003     		}    		
;    2004 
;    2005     	//check for valid GLL dataset
;    2006     	if (nmea_data[index1] == 'A')	
;    2007     		{
;    2008     		Write('G',0,13); Write('P',0,14); Write('S',0,15);
;    2009     		valid_nmea = 1;
;    2010     		}
;    2011     	else
;    2012     		{
;    2013     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
;    2014     		valid_nmea = 0;
;    2015     		}
;    2016     	}	  	 
;    2017             */
;    2018 //Parse RMC message; Find LAT, LON, UTC, DATE (SPEED and COURSE)
;    2019 if (nmea_msg_type == RMC)
	LD   R26,Y
	CPI  R26,LOW(0x31)
	BREQ PC+3
	JMP _0xDF
;    2020 	{
;    2021 	i = 0;
	CLR  R30
	STS  _i,R30
;    2022 	index1 = 6;
	LDI  R30,LOW(6)
	MOV  R4,R30
;    2023 	if (nmea_data[index1] == ',')      //sjekk for komma, hvis komma, ugyldig melding
	RCALL SUBOPT_0x23
	BRNE _0xE0
;    2024 		{
;    2025 		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2026 		valid_nmea = 0;
	CLR  R7
;    2027 		return;
	RJMP _0x158
;    2028 		}
;    2029 		
;    2030 	//Find UTC
;    2031     	while (nmea_data[index1] != ',')           // endre til kun  steppe et stepp fra komma... if()
_0xE0:
_0xE1:
	RCALL SUBOPT_0x23
	BREQ _0xE3
;    2032 		{
;    2033 		UTC[i] = nmea_data[index1];
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_UTC)
	SBCI R31,HIGH(-_UTC)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2034 		index1++;
;    2035 		i++;
;    2036 		}
	RJMP _0xE1
_0xE3:
;    2037     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xE4
;    2038     		{
;    2039     		index1++;	//Jump over ','
	INC  R4
;    2040     		}
;    2041     	else
	RJMP _0xE5
_0xE4:
;    2042     		{
;    2043     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2044     		valid_nmea = 0;
	CLR  R7
;    2045     		return;
	RJMP _0x158
;    2046     		}    		
_0xE5:
;    2047     		
;    2048     	//check for valid RMC dataset
;    2049     	if (nmea_data[index1] == 'A')	
	RCALL SUBOPT_0x24
	CPI  R30,LOW(0x41)
	BRNE _0xE6
;    2050     		{
;    2051     		Write('G',0,13); Write('P',0,14); Write('S',0,15);
	LDI  R30,LOW(71)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x21
	LDI  R30,LOW(83)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2052     		valid_nmea = 1;
	LDI  R30,LOW(1)
	MOV  R7,R30
;    2053     		index1++;
	RJMP _0x15D
;    2054     		}
;    2055     	else
_0xE6:
;    2056     		{
;    2057     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2058     		valid_nmea = 0; 
	CLR  R7
;    2059     		index1++;
_0x15D:
	INC  R4
;    2060     		}
;    2061     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xE8
;    2062     		{
;    2063     		index1++;	//Jump over ','
	INC  R4
;    2064     		}
;    2065     	else
	RJMP _0xE9
_0xE8:
;    2066     		{
;    2067     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2068     		valid_nmea = 0;
	CLR  R7
;    2069     		return;
	RJMP _0x158
;    2070     		}    		                              
_0xE9:
;    2071 
;    2072 	//Find LAT
;    2073 	i=0;
	CLR  R30
	STS  _i,R30
;    2074     	while (nmea_data[index1] != ',')
_0xEA:
	RCALL SUBOPT_0x23
	BREQ _0xEC
;    2075 		{
;    2076 		LAT[i] = nmea_data[index1];
	RCALL SUBOPT_0x26
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2077 		index1++;
;    2078 		i++;
;    2079 		}
	RJMP _0xEA
_0xEC:
;    2080     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xED
;    2081     		{
;    2082     		index1++;	//Jump over ','
	INC  R4
;    2083     		}
;    2084     	else
	RJMP _0xEE
_0xED:
;    2085     		{
;    2086     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2087     		valid_nmea = 0;
	CLR  R7
;    2088     		return;
	RJMP _0x158
;    2089     		}
_0xEE:
;    2090     		    		
;    2091 	//Find LAT E or W
;    2092 	while (nmea_data[index1] != ',')
_0xEF:
	RCALL SUBOPT_0x23
	BREQ _0xF1
;    2093 		{
;    2094 		LAT[i] = nmea_data[index1];
	RCALL SUBOPT_0x26
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2095 		index1++;
;    2096 		i++;
;    2097 		}
	RJMP _0xEF
_0xF1:
;    2098     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xF2
;    2099     		{
;    2100     		index1++;	//Jump over ','
	INC  R4
;    2101     		}
;    2102     	else
	RJMP _0xF3
_0xF2:
;    2103     		{
;    2104     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2105     		valid_nmea = 0;
	CLR  R7
;    2106     		return;
	RJMP _0x158
;    2107     		}    		
_0xF3:
;    2108     		
;    2109 	//Find LON
;    2110 	i=0;
	CLR  R30
	STS  _i,R30
;    2111     	while (nmea_data[index1] != ',')
_0xF4:
	RCALL SUBOPT_0x23
	BREQ _0xF6
;    2112 		{
;    2113 		LON[i] = nmea_data[index1];
	RCALL SUBOPT_0x27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2114 		index1++;
;    2115 		i++;
;    2116 		}
	RJMP _0xF4
_0xF6:
;    2117     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xF7
;    2118     		{
;    2119     		index1++;	//Jump over ','
	INC  R4
;    2120     		}
;    2121     	else
	RJMP _0xF8
_0xF7:
;    2122     		{
;    2123     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2124     		valid_nmea = 0;
	CLR  R7
;    2125     		return;
	RJMP _0x158
;    2126     		}
_0xF8:
;    2127     		    		
;    2128 	//Find LON E or W
;    2129 	while (nmea_data[index1] != ',')
_0xF9:
	RCALL SUBOPT_0x23
	BREQ _0xFB
;    2130 		{
;    2131 		LON[i] = nmea_data[index1];
	RCALL SUBOPT_0x27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2132 		index1++;
;    2133 		i++;
;    2134 		}
	RJMP _0xF9
_0xFB:
;    2135     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0xFC
;    2136     		{
;    2137     		index1++;	//Jump over ','
	INC  R4
;    2138     		}
;    2139     	else
	RJMP _0xFD
_0xFC:
;    2140     		{
;    2141     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2142     		valid_nmea = 0;
	CLR  R7
;    2143     		return;
	RJMP _0x158
;    2144     		}    		
_0xFD:
;    2145     		
;    2146 	//Find SPEED         
;    2147 	i = 0;
	CLR  R30
	STS  _i,R30
;    2148 	while (nmea_data[index1] != ',')
_0xFE:
	RCALL SUBOPT_0x23
	BREQ _0x100
;    2149 		{
;    2150 		SPEED[i] = nmea_data[index1];
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_SPEED)
	SBCI R31,HIGH(-_SPEED)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2151 		index1++;
;    2152 		i++;
;    2153 		}
	RJMP _0xFE
_0x100:
;    2154     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0x101
;    2155     		{
;    2156     		index1++;	//Jump over ','
	INC  R4
;    2157     		}
;    2158     	else
	RJMP _0x102
_0x101:
;    2159     		{
;    2160     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2161     		valid_nmea = 0;
	CLR  R7
;    2162     		return;
	RJMP _0x158
;    2163     		}    		    		
_0x102:
;    2164    		
;    2165 	//Find COARSE
;    2166 	i = 0;
	CLR  R30
	STS  _i,R30
;    2167 	while (nmea_data[index1] != ',')
_0x103:
	RCALL SUBOPT_0x23
	BREQ _0x105
;    2168 		{
;    2169 		COURSE[i] = nmea_data[index1];
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_COURSE)
	SBCI R31,HIGH(-_COURSE)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2170 		index1++;
;    2171 		i++;
;    2172 		}
	RJMP _0x103
_0x105:
;    2173     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0x106
;    2174     		{
;    2175     		index1++;	//Jump over ','
	INC  R4
;    2176     		}
;    2177     	else
	RJMP _0x107
_0x106:
;    2178     		{
;    2179     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2180     		valid_nmea = 0;
	CLR  R7
;    2181     		return;
	RJMP _0x158
;    2182     		}    		   		
_0x107:
;    2183                 
;    2184 	//Find DATE
;    2185 	i = 0;
	CLR  R30
	STS  _i,R30
;    2186 	while (nmea_data[index1] != ',')
_0x108:
	RCALL SUBOPT_0x23
	BREQ _0x10A
;    2187 		{
;    2188 		DATE[i] = nmea_data[index1];
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_DATE)
	SBCI R31,HIGH(-_DATE)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	POP  R26
	POP  R27
	RCALL SUBOPT_0x25
;    2189 		index1++;
;    2190 		i++;
;    2191 		}
	RJMP _0x108
_0x10A:
;    2192     	if(nmea_data[index1] == ',')
	RCALL SUBOPT_0x23
	BRNE _0x10B
;    2193     		{
;    2194     		index1++;	//Jump over ','
	INC  R4
;    2195     		}
;    2196     	else
	RJMP _0x10C
_0x10B:
;    2197     		{
;    2198     		Write(' ',0,13); Write(' ',0,14); Write(' ',0,15);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x5
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x22
;    2199     		valid_nmea = 0;
	CLR  R7
;    2200     		return;
	RJMP _0x158
;    2201     		}    		    
_0x10C:
;    2202    	
;    2203 	}     
;    2204 	
;    2205 	  
;    2206 	  
;    2207 //Arrange the data from the NMEA-strings:
;    2208 //LAT,LON,UTC,DATE;
;    2209 tracking_pkt_buf[0] = LAT[0];
_0xDF:
	LDS  R30,_LAT
	STS  _tracking_pkt_buf,R30
;    2210 tracking_pkt_buf[1] = LAT[1];
	__GETB1MN _LAT,1
	__PUTB1MN _tracking_pkt_buf,1
;    2211 tracking_pkt_buf[2] = LAT[2];
	__GETB1MN _LAT,2
	__PUTB1MN _tracking_pkt_buf,2
;    2212 tracking_pkt_buf[3] = LAT[3];
	__GETB1MN _LAT,3
	__PUTB1MN _tracking_pkt_buf,3
;    2213 tracking_pkt_buf[4] = LAT[4];
	__GETB1MN _LAT,4
	__PUTB1MN _tracking_pkt_buf,4
;    2214 tracking_pkt_buf[5] = LAT[5];
	__GETB1MN _LAT,5
	__PUTB1MN _tracking_pkt_buf,5
;    2215 tracking_pkt_buf[6] = LAT[6];
	__GETB1MN _LAT,6
	__PUTB1MN _tracking_pkt_buf,6
;    2216 tracking_pkt_buf[7] = LAT[7];
	__GETB1MN _LAT,7
	__PUTB1MN _tracking_pkt_buf,7
;    2217 tracking_pkt_buf[8] = LAT[8];     
	__GETB1MN _LAT,8
	__PUTB1MN _tracking_pkt_buf,8
;    2218 tracking_pkt_buf[9] = LAT[9];     //N or S
	__GETB1MN _LAT,9
	__PUTB1MN _tracking_pkt_buf,9
;    2219 tracking_pkt_buf[10] = ',';
	LDI  R30,LOW(44)
	__PUTB1MN _tracking_pkt_buf,10
;    2220 tracking_pkt_buf[11] = LON[0];
	LDS  R30,_LON
	__PUTB1MN _tracking_pkt_buf,11
;    2221 tracking_pkt_buf[12] = LON[1];
	__GETB1MN _LON,1
	__PUTB1MN _tracking_pkt_buf,12
;    2222 tracking_pkt_buf[13] = LON[2];
	__GETB1MN _LON,2
	__PUTB1MN _tracking_pkt_buf,13
;    2223 tracking_pkt_buf[14] = LON[3];
	__GETB1MN _LON,3
	__PUTB1MN _tracking_pkt_buf,14
;    2224 tracking_pkt_buf[15] = LON[4];
	__GETB1MN _LON,4
	__PUTB1MN _tracking_pkt_buf,15
;    2225 tracking_pkt_buf[16] = LON[5];
	__GETB1MN _LON,5
	__PUTB1MN _tracking_pkt_buf,16
;    2226 tracking_pkt_buf[17] = LON[6];
	__GETB1MN _LON,6
	__PUTB1MN _tracking_pkt_buf,17
;    2227 tracking_pkt_buf[18] = LON[7];
	__GETB1MN _LON,7
	__PUTB1MN _tracking_pkt_buf,18
;    2228 tracking_pkt_buf[19] = LON[8];
	__GETB1MN _LON,8
	__PUTB1MN _tracking_pkt_buf,19
;    2229 tracking_pkt_buf[20] = LON[9];    
	__GETB1MN _LON,9
	__PUTB1MN _tracking_pkt_buf,20
;    2230 tracking_pkt_buf[21] = LON[10];    //E or W
	__GETB1MN _LON,10
	__PUTB1MN _tracking_pkt_buf,21
;    2231 tracking_pkt_buf[22] = ',';
	LDI  R30,LOW(44)
	__PUTB1MN _tracking_pkt_buf,22
;    2232 tracking_pkt_buf[23] = UTC[0];
	LDS  R30,_UTC
	__PUTB1MN _tracking_pkt_buf,23
;    2233 tracking_pkt_buf[24] = UTC[1];
	__GETB1MN _UTC,1
	__PUTB1MN _tracking_pkt_buf,24
;    2234 tracking_pkt_buf[25] = UTC[2];
	__GETB1MN _UTC,2
	__PUTB1MN _tracking_pkt_buf,25
;    2235 tracking_pkt_buf[26] = UTC[3];
	__GETB1MN _UTC,3
	__PUTB1MN _tracking_pkt_buf,26
;    2236 tracking_pkt_buf[27] = UTC[4];
	__GETB1MN _UTC,4
	__PUTB1MN _tracking_pkt_buf,27
;    2237 tracking_pkt_buf[28] = UTC[5];
	__GETB1MN _UTC,5
	__PUTB1MN _tracking_pkt_buf,28
;    2238 tracking_pkt_buf[29] = ',';
	LDI  R30,LOW(44)
	__PUTB1MN _tracking_pkt_buf,29
;    2239 tracking_pkt_buf[30] = DATE[0];
	LDS  R30,_DATE
	__PUTB1MN _tracking_pkt_buf,30
;    2240 tracking_pkt_buf[31] = DATE[1];
	__GETB1MN _DATE,1
	__PUTB1MN _tracking_pkt_buf,31
;    2241 tracking_pkt_buf[32] = DATE[2];
	__GETB1MN _DATE,2
	__PUTB1MN _tracking_pkt_buf,32
;    2242 tracking_pkt_buf[33] = DATE[3];
	__GETB1MN _DATE,3
	__PUTB1MN _tracking_pkt_buf,33
;    2243 tracking_pkt_buf[34] = DATE[4];
	__GETB1MN _DATE,4
	__PUTB1MN _tracking_pkt_buf,34
;    2244 tracking_pkt_buf[35] = DATE[5];
	__GETB1MN _DATE,5
	__PUTB1MN _tracking_pkt_buf,35
;    2245 tracking_pkt_buf[36] = ';';
	LDI  R30,LOW(59)
	__PUTB1MN _tracking_pkt_buf,36
;    2246 tracking_pkt_buf[37] = 0xD;	//ASCII CR
	LDI  R30,LOW(13)
	__PUTB1MN _tracking_pkt_buf,37
;    2247 tracking_pkt_buf[38] = 0xA;	//ASCII NL
	LDI  R30,LOW(10)
	__PUTB1MN _tracking_pkt_buf,38
;    2248 }
_0x158:
	ADIW R28,1
	RET
;    2249     		
;    2250   
;    2251 
;    2252  
;    2253 //Find out what type of NMEA msg
;    2254 char nmea_type(char id1, char id2, char id3)
;    2255 {
_nmea_type:
;    2256 char msg_type;
;    2257 if ((id1 == 'R') && (id2 == 'M') && (id3 == 'C'))
	ST   -Y,R16
;	id1 -> Y+3
;	id2 -> Y+2
;	id3 -> Y+1
;	msg_type -> R16
	LDD  R26,Y+3
	CPI  R26,LOW(0x52)
	BRNE _0x10F
	LDD  R26,Y+2
	CPI  R26,LOW(0x4D)
	BRNE _0x10F
	LDD  R26,Y+1
	CPI  R26,LOW(0x43)
	BREQ _0x110
_0x10F:
	RJMP _0x10E
_0x110:
;    2258 	{
;    2259 	msg_type = RMC;
	LDI  R16,LOW(49)
;    2260 	}
;    2261 else if ((id1 == 'G') && (id2 == 'G') && (id3 == 'A'))
	RJMP _0x111
_0x10E:
	LDD  R26,Y+3
	CPI  R26,LOW(0x47)
	BRNE _0x113
	LDD  R26,Y+2
	CPI  R26,LOW(0x47)
	BRNE _0x113
	LDD  R26,Y+1
	CPI  R26,LOW(0x41)
	BREQ _0x114
_0x113:
	RJMP _0x112
_0x114:
;    2262 	{
;    2263 	msg_type = GGA;
	LDI  R16,LOW(50)
;    2264 	}
;    2265 else if ((id1 == 'G') && (id2 == 'S') && (id3 == 'A'))
	RJMP _0x115
_0x112:
	LDD  R26,Y+3
	CPI  R26,LOW(0x47)
	BRNE _0x117
	LDD  R26,Y+2
	CPI  R26,LOW(0x53)
	BRNE _0x117
	LDD  R26,Y+1
	CPI  R26,LOW(0x41)
	BREQ _0x118
_0x117:
	RJMP _0x116
_0x118:
;    2266 	{
;    2267 	msg_type = GSA;
	LDI  R16,LOW(51)
;    2268 	}
;    2269 else if ((id1 == 'G') && (id2 == 'S') && (id3 == 'V'))
	RJMP _0x119
_0x116:
	LDD  R26,Y+3
	CPI  R26,LOW(0x47)
	BRNE _0x11B
	LDD  R26,Y+2
	CPI  R26,LOW(0x53)
	BRNE _0x11B
	LDD  R26,Y+1
	CPI  R26,LOW(0x56)
	BREQ _0x11C
_0x11B:
	RJMP _0x11A
_0x11C:
;    2270 	{
;    2271 	msg_type = GSV;
	LDI  R16,LOW(52)
;    2272 	}
;    2273 else if ((id1 == 'G') && (id2 == 'L') && (id3 == 'L'))
	RJMP _0x11D
_0x11A:
	LDD  R26,Y+3
	CPI  R26,LOW(0x47)
	BRNE _0x11F
	LDD  R26,Y+2
	CPI  R26,LOW(0x4C)
	BRNE _0x11F
	LDD  R26,Y+1
	CPI  R26,LOW(0x4C)
	BREQ _0x120
_0x11F:
	RJMP _0x11E
_0x120:
;    2274 	{
;    2275 	msg_type = GLL;
	LDI  R16,LOW(53)
;    2276 	}
;    2277 else
	RJMP _0x121
_0x11E:
;    2278 	{
;    2279 	msg_type = '0';
	LDI  R16,LOW(48)
;    2280 	} 
_0x121:
_0x11D:
_0x119:
_0x115:
_0x111:
;    2281 return msg_type;
	MOV  R30,R16
	LDD  R16,Y+0
	ADIW R28,4
	RET
;    2282 }   	         
;    2283  
;    2284 //Check for new tracking point (Check if LAT and LON have changed)
;    2285 char check_new_track(void)
;    2286 {
_check_new_track:
;    2287 unsigned char i=0;
;    2288 unsigned char new_nmea_msg=0;
;    2289 UCSR0B.7=0;   //disable RXC0 interrupt, we don't want any new data while checking
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16
;	new_nmea_msg -> R17
	LDI  R16,0
	LDI  R17,0
	CBI  0xA,7
;    2290 if (valid_nmea == 1) //for safety..
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x123
;    2291         {
;    2292         //Returns 0 if 20 first bytes of tracking_pkt_buf == tracking_pkt, i.e. LAT & LON
;    2293         new_nmea_msg = memcmp(tracking_pkt_buf, tracking_pkt,22); 
	LDI  R30,LOW(_tracking_pkt_buf)
	LDI  R31,HIGH(_tracking_pkt_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_tracking_pkt)
	LDI  R31,HIGH(_tracking_pkt)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(22)
	LDI  R31,HIGH(22)
	ST   -Y,R31
	ST   -Y,R30
	CALL _memcmp
	MOV  R17,R30
;    2294         if (new_nmea_msg != 0)
	CPI  R17,0
	BREQ _0x124
;    2295         	{
;    2296         	for (i=0; i < tracking_index; i++)
	LDI  R16,LOW(0)
_0x126:
	CPI  R16,39
	BRSH _0x127
;    2297         		{
;    2298         		tracking_pkt[i] = tracking_pkt_buf[i];
	MOV  R30,R16
	CLR  R31
	SUBI R30,LOW(-_tracking_pkt)
	SBCI R31,HIGH(-_tracking_pkt)
	PUSH R31
	PUSH R30
	MOV  R30,R16
	CLR  R31
	SUBI R30,LOW(-_tracking_pkt_buf)
	SBCI R31,HIGH(-_tracking_pkt_buf)
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;    2299         		}
	SUBI R16,-1
	RJMP _0x126
_0x127:
;    2300         	}
;    2301         }
_0x124:
;    2302 UCSR0B.7=1;	//enable RXC0 interrupt
_0x123:
	SBI  0xA,7
;    2303 return new_nmea_msg; 
	MOV  R30,R17
	RJMP _0x156
;    2304 }
;    2305 
;    2306 	
;    2307 /**************************************************************************
;    2308 Name:		time.c
;    2309 Comments:	Functions related to time
;    2310 **************************************************************************/ 
;    2311 
;    2312 #include "time.h"
;    2313 
;    2314 //RTC-module 
;    2315 //This function is called from th TIMER0 overflow ISR.
;    2316 //Async. external 32KHz x-tal mode.
;    2317 void RTC(void)
;    2318 {
_RTC:
;    2319 static char LeapMonth;

	.DSEG
_LeapMonth_S13:
	.BYTE 0x1

	.CSEG
;    2320 
;    2321 SECOND++;               // increment second
	INC  R12
;    2322 
;    2323 if (SECOND == 60)
	LDI  R30,LOW(60)
	CP   R30,R12
	BREQ PC+3
	JMP _0x12D
;    2324 	{
;    2325         SECOND = 0;
	CLR  R12
;    2326         MINUTE++;
	INC  R13
;    2327         
;    2328         if (MINUTE > 59)
	LDI  R30,LOW(59)
	CP   R30,R13
	BRLO PC+3
	JMP _0x12E
;    2329         	{
;    2330             	MINUTE = 0;
	CLR  R13
;    2331             	HOUR++;
	INC  R14
;    2332             
;    2333             	if (HOUR > 23)
	LDI  R30,LOW(23)
	CP   R30,R14
	BRLO PC+3
	JMP _0x12F
;    2334                     	{
;    2335                         HOUR = 0;
	CLR  R14
;    2336                         DAY++;
	LDS  R30,_DAY
	SUBI R30,-LOW(1)
	STS  _DAY,R30
;    2337         
;    2338                         // Check for leap year if month == February
;    2339                         if (MONTH == 2)
	LDS  R26,_MONTH
	CPI  R26,LOW(0x2)
	BRNE _0x130
;    2340                             	{
;    2341                             	if (!(YEAR & 0x0003))  
	LDS  R30,_YEAR
	ANDI R30,LOW(0x3)
	BRNE _0x131
;    2342                                 	{
;    2343                                 	if (YEAR%100 == 0)
	LDS  R26,_YEAR
	LDS  R27,_YEAR+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MODW21U
	SBIW R30,0
	BRNE _0x132
;    2344                                     		{
;    2345                                     		if (YEAR%400 == 0)
	LDS  R26,_YEAR
	LDS  R27,_YEAR+1
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	CALL __MODW21U
	SBIW R30,0
	BRNE _0x133
;    2346                                         		{LeapMonth = 1;}
	LDI  R30,LOW(1)
	RJMP _0x15E
;    2347         		                        else
_0x133:
;    2348                         		                {LeapMonth = 0;}
	CLR  R30
_0x15E:
	STS  _LeapMonth_S13,R30
;    2349                                     		}
;    2350                                 	else
	RJMP _0x135
_0x132:
;    2351                                     		{LeapMonth = 1;}
	LDI  R30,LOW(1)
	STS  _LeapMonth_S13,R30
_0x135:
;    2352                                 	}
;    2353                             	else
	RJMP _0x136
_0x131:
;    2354                                 	{LeapMonth = 0;}
	CLR  R30
	STS  _LeapMonth_S13,R30
_0x136:
;    2355                             	}
;    2356                         else
	RJMP _0x137
_0x130:
;    2357                             	{LeapMonth = 0;}
	CLR  R30
	STS  _LeapMonth_S13,R30
_0x137:
;    2358         
;    2359                         // Check for month length
;    2360                         if (DAY > (MonthLength[MONTH] + LeapMonth))
	LDS  R30,_MONTH
	CLR  R31
	SUBI R30,LOW(-_MonthLength)
	SBCI R31,HIGH(-_MonthLength)
	LD   R30,Z
	LDS  R26,_LeapMonth_S13
	ADD  R30,R26
	LDS  R26,_DAY
	CP   R30,R26
	BRSH _0x138
;    2361         	                {
;    2362                 	        DAY = 1;
	LDI  R30,LOW(1)
	STS  _DAY,R30
;    2363                         	MONTH++;
	LDS  R30,_MONTH
	SUBI R30,-LOW(1)
	STS  _MONTH,R30
;    2364         
;    2365                             	if (MONTH > 12)
	LDS  R26,_MONTH
	LDI  R30,LOW(12)
	CP   R30,R26
	BRSH _0x139
;    2366                             		{
;    2367                                 	MONTH = 1;
	LDI  R30,LOW(1)
	STS  _MONTH,R30
;    2368                                 	YEAR++;
	LDS  R30,_YEAR
	LDS  R31,_YEAR+1
	ADIW R30,1
	STS  _YEAR,R30
	STS  _YEAR+1,R31
;    2369         		                }
;    2370                         	}
_0x139:
;    2371                     	}
_0x138:
;    2372         	}
_0x12F:
;    2373     	}
_0x12E:
;    2374 }
_0x12D:
	RET
;    2375 
;    2376 
;    2377 
;    2378 
;    2379 //Syncronizes the time and date to GPS(UTC) time.
;    2380 void adjust_time(void)
;    2381 {
_adjust_time:
;    2382 unsigned char HourData[3];
;    2383 unsigned char MinData[3];
;    2384 unsigned char SecData[3];
;    2385 
;    2386 unsigned char YearData[3];
;    2387 unsigned char MonthData[3];
;    2388 unsigned char DayData[3];
;    2389 
;    2390 //uppdate only if we recieved a valid NMEA msg.
;    2391 if(valid_nmea == 1)
	SBIW R28,18
;	HourData -> Y+15
;	MinData -> Y+12
;	SecData -> Y+9
;	YearData -> Y+6
;	MonthData -> Y+3
;	DayData -> Y+0
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ PC+3
	JMP _0x13B
;    2392         {
;    2393         HourData[0] = UTC[0]; 
	LDS  R30,_UTC
	STD  Y+15,R30
;    2394         HourData[1] = UTC[1];
	__GETB1MN _UTC,1
	STD  Y+16,R30
;    2395         HourData[2] = 0;
	CLR  R30
	STD  Y+17,R30
;    2396         MinData[0] = UTC[2];
	__GETB1MN _UTC,2
	STD  Y+12,R30
;    2397         MinData[1] = UTC[3];
	__GETB1MN _UTC,3
	STD  Y+13,R30
;    2398         MinData[2] = 0;
	CLR  R30
	STD  Y+14,R30
;    2399         SecData[0] = UTC[4];
	__GETB1MN _UTC,4
	STD  Y+9,R30
;    2400         SecData[1] = UTC[5];
	__GETB1MN _UTC,5
	STD  Y+10,R30
;    2401         SecData[2] = 0;
	CLR  R30
	STD  Y+11,R30
;    2402         
;    2403         DayData[0] = DATE[0];
	LDS  R30,_DATE
	ST   Y,R30
;    2404         DayData[1] = DATE[1];
	__GETB1MN _DATE,1
	STD  Y+1,R30
;    2405         DayData[2] = 0;
	CLR  R30
	STD  Y+2,R30
;    2406         MonthData[0] = DATE[2];
	__GETB1MN _DATE,2
	STD  Y+3,R30
;    2407         MonthData[1] = DATE[3];
	__GETB1MN _DATE,3
	STD  Y+4,R30
;    2408         MonthData[2] = 0;
	CLR  R30
	STD  Y+5,R30
;    2409         YearData[0] = DATE[4];
	__GETB1MN _DATE,4
	STD  Y+6,R30
;    2410         YearData[1] = DATE[5];
	__GETB1MN _DATE,5
	STD  Y+7,R30
;    2411         YearData[2] = 0;
	CLR  R30
	STD  Y+8,R30
;    2412         
;    2413         //ASCII to integer conversion
;    2414         SECOND = (unsigned char)atoi(SecData);
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	MOV  R12,R30
;    2415         MINUTE = (unsigned char)atoi(MinData);
	MOVW R30,R28
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	MOV  R13,R30
;    2416         HOUR = (unsigned char)atoi(HourData);
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	MOV  R14,R30
;    2417         
;    2418         DAY = (unsigned char)atoi(DayData);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	STS  _DAY,R30
;    2419         MONTH = (unsigned char)atoi(MonthData);
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	STS  _MONTH,R30
;    2420         YEAR = (unsigned char)atoi(YearData);
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	CLR  R31
	STS  _YEAR,R30
	STS  _YEAR+1,R31
;    2421         }
;    2422 }
_0x13B:
	ADIW R28,18
	RET
;    2423 
;    2424 
;    2425 
;    2426 //Displays the clock (UTC)  
;    2427 void display_clock(void)
;    2428 {
_display_clock:
;    2429 unsigned char HH, HL, MH, ML, SH, SL;
;    2430 
;    2431 HH = CHAR2BCD2(HOUR);
	CALL __SAVELOCR6
;	HH -> R16
;	HL -> R17
;	MH -> R18
;	ML -> R19
;	SH -> R20
;	SL -> R21
	ST   -Y,R14
	RCALL SUBOPT_0x28
;    2432 HL = (HH & 0x0F) + '0';
;    2433 HH = (HH >> 4) + '0';
;    2434 
;    2435 MH = CHAR2BCD2(MINUTE);
	ST   -Y,R13
	RCALL SUBOPT_0x29
;    2436 ML = (MH & 0x0F) + '0';
;    2437 MH = (MH >> 4) + '0';
;    2438 
;    2439 SH = CHAR2BCD2(SECOND);
	ST   -Y,R12
	RCALL SUBOPT_0x2A
;    2440 SL = (SH & 0x0F) + '0';
;    2441 SH = (SH >> 4) + '0';
;    2442 
;    2443 //Display: UTC <clock>
;    2444 Write('U', 3, 0); Write('T', 3, 1); Write('C', 3, 2); Write(' ', 3, 3); Write(' ', 3, 4); 
	LDI  R30,LOW(85)
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x7
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x9
	LDI  R30,LOW(67)
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0xB
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2B
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0xD
;    2445 Write(HH, 3, 5);
	ST   -Y,R16
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0xE
;    2446 Write(HL, 3, 6);
	ST   -Y,R17
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x16
;    2447 Write(':', 3, 7);
	LDI  R30,LOW(58)
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x14
;    2448 Write(MH, 3, 8);
	ST   -Y,R18
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x1F
;    2449 Write(ML, 3, 9);
	ST   -Y,R19
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x20
;    2450 Write(':', 3, 10);
	LDI  R30,LOW(58)
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2
;    2451 Write(SH, 3, 11);
	ST   -Y,R20
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x3
;    2452 Write(SL, 3, 12);
	ST   -Y,R21
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x4
;    2453 }
	RJMP _0x157
;    2454 
;    2455 
;    2456 
;    2457 //Displays the date
;    2458 void display_date(void)
;    2459 {
_display_date:
;    2460 char YH, YL, MH, ML, DH, DL;
;    2461 
;    2462 YH = CHAR2BCD2(YEAR);
	CALL __SAVELOCR6
;	YH -> R16
;	YL -> R17
;	MH -> R18
;	ML -> R19
;	DH -> R20
;	DL -> R21
	LDS  R30,_YEAR
	LDS  R31,_YEAR+1
	ST   -Y,R30
	RCALL SUBOPT_0x28
;    2463 YL = (YH & 0x0F) + '0';
;    2464 YH = (YH >> 4) + '0';
;    2465 
;    2466 MH = CHAR2BCD2(MONTH);
	LDS  R30,_MONTH
	ST   -Y,R30
	RCALL SUBOPT_0x29
;    2467 ML = (MH & 0x0F) + '0';
;    2468 MH = (MH >> 4) + '0';
;    2469 
;    2470 DH = CHAR2BCD2(DAY);
	LDS  R30,_DAY
	ST   -Y,R30
	RCALL SUBOPT_0x2A
;    2471 DL = (DH & 0x0F) + '0';
;    2472 DH = (DH >> 4) + '0'; 
;    2473 
;    2474 //Display: DTE <date>
;    2475 Write('D', 4, 0); Write('T', 4, 1); Write('E', 4, 2); Write(' ', 4, 3);  Write(' ', 4, 4);
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x7
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x9
	LDI  R30,LOW(69)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0xB
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0xC
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2C
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
;    2476 Write(DH, 4, 5);
	ST   -Y,R20
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0xE
;    2477 Write(DL, 4, 6);
	ST   -Y,R21
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x16
;    2478 Write('.', 4, 7);
	LDI  R30,LOW(46)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x14
;    2479 Write(MH, 4, 8);
	ST   -Y,R18
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x1F
;    2480 Write(ML, 4, 9);
	ST   -Y,R19
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x20
;    2481 Write('.', 4, 10);
	LDI  R30,LOW(46)
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2
;    2482 Write(YH, 4, 11);
	ST   -Y,R16
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x3
;    2483 Write(YL, 4, 12); 
	ST   -Y,R17
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x4
;    2484 }
_0x157:
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;    2485 
;    2486 /************************************************************************** 
;    2487 Name: 		flash.c
;    2488 Comments:	Functions for writing to/reading 
;    2489 		the M25P80 FLASHmemory from ST.
;    2490 **************************************************************************/ 
;    2491 
;    2492 #include <mega128.h>
;    2493 #include <delay.h>
;    2494 #include <spi.h>
;    2495 #include "flash.h"
;    2496 
;    2497 
;    2498 //Check the statusregister and wait until flash is ready
;    2499 void wait_flash_rdy(void)
;    2500 {
_wait_flash_rdy:
;    2501 unsigned char status = 0;
;    2502 unsigned char klar = 0x01;
;    2503 
;    2504 ACTIVATE_FLASH;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	klar -> R17
	LDI  R16,0
	LDI  R17,1
	CBI  0x12,4
;    2505 spi(RDSR);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _spi
;    2506 while (klar == 0x01)
_0x148:
	CPI  R17,1
	BRNE _0x14A
;    2507 	{
;    2508 	status = spi(0x00);
	RCALL SUBOPT_0x12
;    2509 	klar = (status & 0x01);
	MOV  R30,R16
	ANDI R30,LOW(0x1)
	MOV  R17,R30
;    2510 	}
	RJMP _0x148
_0x14A:
;    2511 DEACTIVATE_FLASH;
	SBI  0x12,4
;    2512 }
_0x156:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    2513 
;    2514 
;    2515 //Write enable
;    2516 void write_enable(void)
;    2517 {
_write_enable:
;    2518 ACTIVATE_FLASH;
	CBI  0x12,4
;    2519 spi(WREN);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _spi
;    2520 DEACTIVATE_FLASH;
	SBI  0x12,4
;    2521 }
	RET
;    2522 
;    2523 
;    2524 //Write disable   
;    2525 //Not in use
;    2526 void write_disable(void)
;    2527 {
;    2528 ACTIVATE_FLASH;
;    2529 spi(WRDI);
;    2530 DEACTIVATE_FLASH;
;    2531 }
;    2532 
;    2533 
;    2534 //Pageprogram in flash 
;    2535 //Programs one byte at a time.
;    2536 void PageProgram(char data, unsigned long int adress)
;    2537 {
_PageProgram:
;    2538 wait_flash_rdy();
	RCALL _wait_flash_rdy
;    2539 
;    2540 write_enable();
	RCALL _write_enable
;    2541 
;    2542 ACTIVATE_FLASH;
	CBI  0x12,4
;    2543 spi(PP);
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x2D
;    2544 spi(adress>>16);
	CALL __LSRD16
	ST   -Y,R30
	CALL _spi
;    2545 spi(adress>>8);
	__GETD2S 0
	LDI  R30,LOW(8)
	CALL __LSRD12
	RCALL SUBOPT_0x2D
;    2546 spi(adress);
	ST   -Y,R30
	CALL _spi
;    2547 spi(data);	
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _spi
;    2548 DEACTIVATE_FLASH;
	SBI  0x12,4
;    2549 }
	ADIW R28,5
	RET
;    2550  
;    2551 
;    2552 //Delete the flash 
;    2553 //This takes a long time..
;    2554 void bulk_erase(void)
;    2555 {
_bulk_erase:
;    2556 wait_flash_rdy();
	RCALL _wait_flash_rdy
;    2557 
;    2558 write_enable();
	RCALL _write_enable
;    2559 
;    2560 //BULK ERASE
;    2561 ACTIVATE_FLASH;
	CBI  0x12,4
;    2562 spi(BE);
	LDI  R30,LOW(199)
	ST   -Y,R30
	CALL _spi
;    2563 DEACTIVATE_FLASH;
	SBI  0x12,4
;    2564 wait_flash_rdy();
	RCALL _wait_flash_rdy
;    2565 }
	RET
;    2566 
;    2567 
;    2568 //Read flash page by page (not in use).
;    2569 void flash_page_to_UART(int page_nr)
;    2570 {
;    2571 unsigned char i, data;
;    2572 unsigned long int start_adress;
;    2573 
;    2574 start_adress = (page_nr*256);
;	page_nr -> Y+6
;	i -> R16
;	data -> R17
;	start_adress -> Y+2
;    2575 
;    2576 wait_flash_rdy();
;    2577 
;    2578 ACTIVATE_FLASH;
;    2579 spi(READ);
;    2580 spi(start_adress>>16);
;    2581 spi(start_adress>>8);
;    2582 spi(start_adress);
;    2583 for(i=0; i<255; i++)
;    2584 	{
;    2585 	data=spi(0x00);
;    2586 	while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
;    2587         UDR1=data;
;    2588 	}	
;    2589 DEACTIVATE_FLASH;
;    2590 }

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	CLR  R30
	STS  _tracking,R30
	LDI  R30,LOW(78)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(79)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES
SUBOPT_0x1:
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x7:
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(82)
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xA:
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xE:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	ST   -Y,R30
	CALL _spi
	CLR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x11:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	CLR  R30
	ST   -Y,R30
	CALL _spi
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 45 TIMES
SUBOPT_0x13:
	ST   -Y,R30
	CLR  R30
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x14:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	ST   -Y,R30
	CLR  R30
	CLR  R31
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x16:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	__PUTW1R 16,17
	__GETW1R 16,17
	ADIW R30,48
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	__GETW2R 16,17
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDS  R26,_volt
	LDS  R27,_volt+1
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	__GETW2R 18,19
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x1C:
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x1D:
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x1E:
	ST   -Y,R31
	ST   -Y,R30
	CALL _Write
	LDI  R30,LOW(32)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1F:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x20:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x21:
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x23:
	MOV  R30,R4
	CLR  R31
	SUBI R30,LOW(-_nmea_data)
	SBCI R31,HIGH(-_nmea_data)
	LD   R30,Z
	CPI  R30,LOW(0x2C)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x24:
	MOV  R30,R4
	CLR  R31
	SUBI R30,LOW(-_nmea_data)
	SBCI R31,HIGH(-_nmea_data)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x25:
	ST   X,R30
	INC  R4
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_LAT)
	SBCI R31,HIGH(-_LAT)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	LDS  R30,_i
	CLR  R31
	SUBI R30,LOW(-_LON)
	SBCI R31,HIGH(-_LON)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	CALL _CHAR2BCD2
	MOV  R16,R30
	MOV  R30,R16
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(48)
	MOV  R17,R30
	MOV  R30,R16
	SWAP R30
	ANDI R30,0xF
	SUBI R30,-LOW(48)
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	CALL _CHAR2BCD2
	MOV  R18,R30
	MOV  R30,R18
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(48)
	MOV  R19,R30
	MOV  R30,R18
	SWAP R30
	ANDI R30,0xF
	SUBI R30,-LOW(48)
	MOV  R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	CALL _CHAR2BCD2
	MOV  R20,R30
	MOV  R30,R20
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(48)
	MOV  R21,R30
	MOV  R30,R20
	SWAP R30
	ANDI R30,0xF
	SUBI R30,-LOW(48)
	MOV  R20,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x2B:
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x2C:
	ST   -Y,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	ST   -Y,R30
	CALL _spi
	__GETD1S 0
	RET

_atoi:
	ldd  r27,y+1
	ld   r26,y
__atoi0:
	ld   r30,x
	st   -y,r30
	rcall _isspace
	tst  r30
	breq __atoi1
	adiw r26,1
	rjmp __atoi0
__atoi1:
	clt
	ld   r30,x
	cpi  r30,'-'
	brne __atoi2
	set
	rjmp __atoi3
__atoi2:
	cpi  r30,'+'
	brne __atoi4
__atoi3:
	adiw r26,1
__atoi4:
	clr  r22
	clr  r23
__atoi5:
	ld   r30,x
	st   -y,r30
	rcall _isdigit
	tst  r30
	breq __atoi6
	mov  r30,r22
	mov  r31,r23
	lsl  r22
	rol  r23
	lsl  r22
	rol  r23
	add  r22,r30
	adc  r23,r31
	lsl  r22
	rol  r23
	ld   r30,x+
	clr  r31
	subi r30,'0'
	add  r22,r30
	adc  r23,r31
	rjmp __atoi5
__atoi6:
	mov  r30,r22
	mov  r31,r23
	brtc __atoi7
	com  r30
	com  r31
	adiw r30,1
__atoi7:
	adiw r28,2
	ret

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	breq __isspace1
	cpi  r31,13
	breq __isspace1
	clr  r30
__isspace1:
	ret

_memcmp:
	clr  r22
	clr  r23
	ld   r24,y+
	ld   r25,y+
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
__memcmp0:
	adiw r24,0
	breq __memcmp1
	sbiw r24,1
	ld   r22,x+
	ld   r23,z+
	cp   r22,r23
	breq __memcmp0
__memcmp1:
	sub  r22,r23
	mov  r30,r22
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_spi:
	ld   r30,y+
	out  spdr,r30
__spi0:
	sbis spsr,7
	rjmp __spi0
	in   r30,spdr
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	CLR  R22
	CLR  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOV  R23,R31
	MOV  R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	IN   R0,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R0
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOV  R0,R30
	MOV  R1,R31
	MOV  R30,R22
	MOV  R31,R23
	RCALL __EEPROMWRW
	MOV  R30,R0
	MOV  R31,R1
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

